<?php
if (!defined('IN_GW'))
{
	die("<!-- $Id$ -->");
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *  Copyright (C) 2002, 2003 Dmitry Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 * Enables exended optiions for dictionary elements.
 * (transcription, abbreviation, translation etc.)
 */
//

class gw_fields_extension
{
	var $curElementId = '';

	function get_js($fieldname, $id_element)
	{
	 	$tmp['strJs'] = '<script type="text/javascript">//<![CDATA[';

	 	$tmp['strJs'] .= '

function extSetFont(idEl)
{
	var n = document.forms.vbform[\'arPre_trsp_\' + idEl + \'_value_\'];
	var fontname = document.forms.vbform.ext_trsp_font.value
	var arNames = new Array(6);
	arNames[1] = \'Arial Unicode MS\';
	arNames[2] = \'Lucida Sans Unicode\';
	arNames[5] = \'Tahoma\';
	arNames[6] = \'Verdana\';
	n.style.fontFamily = arNames[fontname];
}
function extSetFontize(idEl, fsize)
{
	var n = document.forms.vbform[\'arPre_trsp_\' + idEl + \'_value_\'];
	n.style.fontSize = fsize + \'%\';
}
function getCharmap(key0, key1)
{
	var charmap = new Array(2);
	var charbase = new Array();
	var charorder = new Array();

	// numeric english characters
	charbase[\'en_numeric\'] = new Array("a","a1","a2","a3","a4","ai1","ai2","ai3","ai4","an1","an2","an3","an4","ang1","ang2","ang3","ang4","ao1","ao2","ao3","ao4","ba","ba1","ba2","ba3","ba4","bai1","bai2","bai3","bai4","ban1","ban3","ban4","bang1","bang3","bang4","bao","bao1","bao2","bao3","bao4","bei","bei1","bei3","bei4","ben1","ben3","ben4","beng1","beng2","beng3","beng4","bi1","bi2","bi3","bi4","bian","bian1","bian3","bian4","biao1","biao3","biao4","bie1","bie2","bie3","bie4","bin","bin1","bin3","bin4","bing1","bing3","bing4","bo","bo1","bo2","bo3","bo4","bu1","bu2","bu3","bu4","ca1","ca3","ca4","cai","cai1","cai2","cai3","cai4","can1","can2","can3","can4","cang1","cang2","cang3","cang4","cao1","cao2","cao3","cao4","ce4","cen1","cen2","ceng1","ceng2","ceng4","cha","cha1","cha2","cha3","cha4","chai","chai1","chai2","chai3","chai4","chan1","chan2","chan3","chan4","chang1","chang2","chang3","chang4","chao1","chao2","chao3","chao4","che1","che3","che4","chen1","chen2","chen3","chen4","cheng1","cheng2","cheng3","cheng4","chi1","chi2","chi3","chi4","chong1","chong2","chong3","chong4","chou1","chou2","chou3","chou4","chu1","chu2","chu3","chu4","chua1","chua4","chuai1","chuai2","chuai3","chuai4","chuan1","chuan2","chuan3","chuan4","chuang1","chuang2","chuang3","chuang4","chui1","chui2","chui3","chui4","chun","chun1","chun2","chun3","chuo1","chuo2","chuo4","ci1","ci2","ci3","ci4","cong1","cong2","cong4","cou3","cou4","cu1","cu2","cu3","cu4","cuan1","cuan2","cuan3","cuan4","cui1","cui2","cui3","cui4","cun1","cun2","cun3","cun4","cuo1","cuo2","cuo3","cuo4","da","da1","da2","da3","da4","dai1","dai3","dai4","dan1","dan2","dan3","dan4","dang1","dang3","dang4","dao1","dao2","dao3","dao4","de","de1","de2","dei1","dei3","den1","den4","deng1","deng3","deng4","di1","di2","di3","di4","dia3","dian1","dian2","dian3","dian4","diao1","diao3","diao4","die1","die2","die4","ding1","ding2","ding3","ding4","diu1","dong1","dong3","dong4","dou1","dou3","dou4","du1","du2","du3","du4","duan1","duan3","duan4","dui1","dui3","dui4","dun1","dun2","dun3","dun4","duo1","duo2","duo3","duo4","e1","e2","e3","e4","ei1","ei2","ei3","ei4","en1","en3","en4","eng1","er","er2","er3","er4","fa1","fa2","fa3","fa4","fan1","fan2","fan3","fan4","fang1","fang2","fang3","fang4","fei1","fei2","fei3","fei4","fen1","fen2","fen3","fen4","feng1","feng2","feng3","feng4","fo2","fou1","fou2","fou3","fou4","fu","fu1","fu2","fu3","fu4","ga1","ga2","ga3","ga4","gai1","gai3","gai4","gan1","gan2","gan3","gan4","gang1","gang3","gang4","gao1","gao3","gao4","ge1","ge2","ge3","ge4","gei3","gen1","gen2","gen3","gen4","geng1","geng3","geng4","gong","gong1","gong3","gong4","gou1","gou3","gou4","gu1","gu2","gu3","gu4","gua","gua1","gua3","gua4","guai1","guai3","guai4","guan","guan1","guan3","guan4","guang","guang1","guang3","guang4","gui","gui1","gui2","gui3","gui4","gun1","gun3","gun4","guo","guo1","guo2","guo3","guo4","ha1","ha2","ha3","ha4","hai1","hai2","hai3","hai4","han1","han2","han3","han4","hang1","hang2","hang3","hang4","hao1","hao2","hao3","hao4","he1","he2","he3","he4","hei1","hen1","hen2","hen3","hen4","heng1","heng2","heng4","hm","hng","hong1","hong2","hong3","hong4","hou1","hou2","hou3","hou4","hu1","hu2","hu3","hu4","hua1","hua2","hua3","hua4","huai1","huai2","huai4","huan1","huan2","huan3","huan4","huang1","huang2","huang3","huang4","hui","hui1","hui2","hui3","hui4","hun1","hun2","hun3","hun4","huo","huo1","huo2","huo3","huo4","ji1","ji2","ji3","ji4","jia","jia1","jia2","jia3","jia4","jian","jian1","jian3","jian4","jiang1","jiang3","jiang4","jiao1","jiao2","jiao3","jiao4","jie","jie1","jie2","jie3","jie4","jin1","jin3","jin4","jing1","jing3","jing4","jiong1","jiong3","jiong4","jiu1","jiu2","jiu3","jiu4","ju","ju1","ju2","ju3","ju4","juan1","juan3","juan4","jue1","jue2","jue3","jue4","jun1","jun3","jun4","ka1","ka3","ka4","kai1","kai3","kai4","kan1","kan3","kan4","kang","kang1","kang2","kang3","kang4","kao1","kao2","kao3","kao4","ke1","ke2","ke3","ke4","ken3","ken4","keng1","keng3","kong1","kong3","kong4","kou1","kou3","kou4","ku1","ku3","ku4","kua1","kua3","kua4","kuai1","kuai3","kuai4","kuan1","kuan3","kuan4","kuang1","kuang2","kuang3","kuang4","kui","kui1","kui2","kui3","kui4","kun1","kun3","kun4","kuo3","kuo4","la","la1","la2","la3","la4","lai2","lai3","lai4","lan2","lan3","lan4","lang1","lang2","lang3","lang4","lao1","lao2","lao3","lao4","le","le1","le4","lei","lei1","lei2","lei3","lei4","leng1","leng2","leng3","leng4","li","li1","li2","li3","li4","lia3","lian1","lian2","lian3","lian4","liang2","liang3","liang4","liao1","liao2","liao3","liao4","lie","lie1","lie3","lie4","lin","lin2","lin3","lin4","ling1","ling2","ling3","ling4","liu1","liu2","liu3","liu4","lo","long1","long2","long3","long4","lou","lou1","lou2","lou3","lou4","lu1","lu2","lu3","lu4","luan2","luan3","luan4","lue3","lue4","lun1","lun2","lun3","lun4","luo","luo1","luo2","luo3","luo4","luu2","luu3","luu4","luuan2","luue3","luue4","m","m2","m4","ma","ma1","ma2","ma3","ma4","mai2","mai3","mai4","man1","man2","man3","man4","mang1","mang2","mang3","mang4","mao","mao1","mao2","mao3","mao4","me","mei2","mei3","mei4","men","men1","men2","men3","men4","meng1","meng2","meng3","meng4","mi1","mi2","mi3","mi4","mian2","mian3","mian4","miao1","miao2","miao3","miao4","mie1","mie4","min2","min3","ming1","ming2","ming3","ming4","miu4","mo","mo1","mo2","mo3","mo4","mou1","mou2","mou3","mou4","mu2","mu3","mu4","n","n3","na","na1","na2","na3","na4","nai2","nai3","nai4","nan1","nan2","nan3","nan4","nang1","nang2","nang3","nang4","nao1","nao2","nao3","nao4","ne","ne2","ne4","nei3","nei4","nen1","nen3","nen4","neng2","neng3","neng4","ng2","ng3","ng4","ni1","ni2","ni3","ni4","nian1","nian2","nian3","nian4","niang2","niang4","niao3","niao4","nie1","nie2","nie3","nie4","nin2","nin3","ning2","ning3","ning4","niu1","niu2","niu3","niu4","nong2","nong3","nong4","nou2","nou3","nou4","nu2","nu3","nu4","nuan2","nuan3","nuan4","nue4","nuo2","nuo3","nuo4","nuu3","nuu4","nuue4","o1","o2","o4","ou","ou1","ou2","ou3","ou4","pa1","pa2","pa4","pai1","pai2","pai3","pai4","pan1","pan2","pan3","pan4","pang","pang1","pang2","pang3","pang4","pao1","pao2","pao3","pao4","pei1","pei2","pei3","pei4","pen1","pen2","pen3","pen4","peng","peng1","peng2","peng3","peng4","pi1","pi2","pi3","pi4","pian1","pian2","pian3","pian4","piao1","piao2","piao3","piao4","pie1","pie3","pie4","pin1","pin2","pin3","pin4","ping1","ping2","ping4","po","po1","po2","po3","po4","pou1","pou2","pou3","pou4","pu","pu1","pu2","pu3","pu4","qi","qi1","qi2","qi3","qi4","qia1","qia2","qia3","qia4","qian1","qian2","qian3","qian4","qiang1","qiang2","qiang3","qiang4","qiao1","qiao2","qiao3","qiao4","qie","qie1","qie2","qie3","qie4","qin1","qin2","qin3","qin4","qing1","qing2","qing3","qing4","qiong","qiong1","qiong2","qiong3","qiu1","qiu2","qiu3","qiu4","qu1","qu2","qu3","qu4","quan1","quan2","quan3","quan4","que1","que2","que4","qun1","qun2","qun3","ran2","ran3","rang1","rang2","rang3","rang4","rao2","rao3","rao4","re2","re3","re4","ren2","ren3","ren4","reng1","reng2","reng4","ri4","rong2","rong3","rong4","rou2","rou3","rou4","ru2","ru3","ru4","ruan2","ruan3","rui2","rui3","rui4","run2","run4","ruo2","ruo4","sa1","sa3","sa4","sai","sai1","sai3","sai4","san1","san3","san4","sang1","sang3","sang4","sao1","sao3","sao4","se4","sen1","sen3","seng1","sha1","sha3","sha4","shai1","shai3","shai4","shan1","shan2","shan3","shan4","shang1","shang2","shang3","shang4","shao1","shao2","shao3","shao4","she1","she2","she3","she4","shei2","shen","shen1","shen2","shen3","shen4","sheng","sheng1","sheng2","sheng3","sheng4","shi","shi1","shi2","shi3","shi4","shou1","shou2","shou3","shou4","shu1","shu2","shu3","shu4","shua1","shua3","shua4","shuai1","shuai3","shuai4","shuan1","shuan4","shuang1","shuang3","shuang4","shui2","shui3","shui4","shun3","shun4","shuo1","shuo2","shuo4","si1","si3","si4","song1","song3","song4","sou","sou1","sou3","sou4","su","su1","su2","su4","suan1","suan3","suan4","sui1","sui2","sui3","sui4","sun1","sun3","sun4","suo1","suo3","suo4","ta1","ta3","ta4","tai","tai1","tai2","tai3","tai4","tan1","tan2","tan3","tan4","tang","tang1","tang2","tang3","tang4","tao1","tao2","tao3","tao4","te4","teng1","teng2","ti1","ti2","ti3","ti4","tian","tian1","tian2","tian3","tian4","tiao1","tiao2","tiao3","tiao4","tie1","tie2","tie3","tie4","ting1","ting2","ting3","ting4","tong","tong1","tong2","tong3","tong4","tou","tou1","tou2","tou3","tou4","tu1","tu2","tu3","tu4","tuan1","tuan2","tuan3","tuan4","tui1","tui2","tui3","tui4","tun","tun1","tun2","tun3","tun4","tuo","tuo1","tuo2","tuo3","tuo4","wa","wa1","wa2","wa3","wa4","wai1","wai3","wai4","wan1","wan2","wan3","wan4","wang1","wang2","wang3","wang4","wei","wei1","wei2","wei3","wei4","wen1","wen2","wen3","wen4","weng1","weng3","weng4","wo","wo1","wo2","wo3","wo4","wu","wu1","wu2","wu3","wu4","xi","xi1","xi2","xi3","xi4","xia1","xia2","xia3","xia4","xian1","xian2","xian3","xian4","xiang1","xiang2","xiang3","xiang4","xiao1","xiao2","xiao3","xiao4","xie1","xie2","xie3","xie4","xin","xin1","xin2","xin3","xin4","xing1","xing2","xing3","xing4","xiong1","xiong2","xiong4","xiu1","xiu3","xiu4","xu1","xu2","xu3","xu4","xuan","xuan1","xuan2","xuan3","xuan4","xue1","xue2","xue3","xue4","xun1","xun2","xun4","ya","ya1","ya2","ya3","ya4","yai2","yan1","yan2","yan3","yan4","yang1","yang2","yang3","yang4","yao1","yao2","yao3","yao4","ye1","ye2","ye3","ye4","yi","yi1","yi2","yi3","yi4","yin","yin1","yin2","yin3","yin4","ying1","ying2","ying3","ying4","yo","yo1","yong","yong1","yong2","yong3","yong4","you1","you2","you3","you4","yu1","yu2","yu3","yu4","yuan","yuan1","yuan2","yuan3","yuan4","yue1","yue3","yue4","yun1","yun2","yun3","yun4","za1","za2","za3","zai1","zai3","zai4","zan1","zan2","zan3","zan4","zang1","zang2","zang3","zang4","zao1","zao2","zao3","zao4","ze2","ze4","zei2","zen3","zen4","zeng1","zeng3","zeng4","zha1","zha2","zha3","zha4","zhai1","zhai2","zhai3","zhai4","zhan1","zhan2","zhan3","zhan4","zhang1","zhang3","zhang4","zhao1","zhao2","zhao3","zhao4","zhe","zhe1","zhe2","zhe3","zhe4","zhei4","zhen","zhen1","zhen3","zhen4","zheng1","zheng3","zheng4","zhi1","zhi2","zhi3","zhi4","zhong1","zhong3","zhong4","zhou","zhou1","zhou2","zhou3","zhou4","zhu","zhu1","zhu2","zhu3","zhu4","zhua1","zhua3","zhuai1","zhuai3","zhuai4","zhuan1","zhuan3","zhuan4","zhuang1","zhuang3","zhuang4","zhui1","zhui3","zhui4","zhun1","zhun3","zhun4","zhuo1","zhuo2","zhuo3","zhuo4","zi","zi1","zi2","zi3","zi4","zong1","zong3","zong4","zou1","zou3","zou4","zu1","zu2","zu3","zu4","zuan1","zuan3","zuan4","zui1","zui3","zui4","zun1","zun3","zun4","zuo1","zuo2","zuo3","zuo4");
	// phonetic english characters
	charbase[\'en_phonetic\'] = new Array("a","ā","á","ǎ","à","āi","ái","ǎi","ài","ān","án","ǎn","àn","āng","áng","ǎng","àng","āo","áo","ǎo","ào","ba","bā","bá","bǎ","bà","bāi","bái","bǎi","bài","bān","bǎn","bàn","bāng","bǎng","bàng","bao","bāo","báo","bǎo","bào","bei","bēi","běi","bèi","bēn","běn","bèn","bēng","béng","běng","bèng","bī","bí","bǐ","bì","bian","biān","biǎn","biàn","biāo","biǎo","biào","biē","bié","biě","biè","bin","bīn","bǐn","bìn","bīng","bǐng","bìng","bo","bō","bó","bǒ","bò","bū","bú","bǔ","bù","cā","cǎ","cà","cai","cāi","cái","cǎi","cài","cān","cán","cǎn","càn","cāng","cáng","cǎng","càng","cāo","cáo","cǎo","cào","cè","cēn","cén","cēng","céng","cèng","cha","chā","chá","chǎ","chà","chai","chāi","chái","chǎi","chài","chān","chán","chǎn","chàn","chāng","cháng","chǎng","chàng","chāo","cháo","chǎo","chào","chē","chě","chè","chēn","chén","chěn","chèn","chēng","chéng","chěng","chèng","chī","chí","chǐ","chì","chōng","chóng","chǒng","chòng","chōu","chóu","chǒu","chòu","chū","chú","chǔ","chù","chuā","chuà","chuāi","chuái","chuǎi","chuài","chuān","chuán","chuǎn","chuàn","chuāng","chuáng","chuǎng","chuàng","chūi","chúi","chǔi","chùi","chun","chūn","chún","chǔn","chuō","chuó","chuò","cī","cí","cǐ","cì","cōng","cóng","còng","cǒu","còu","cū","cú","cǔ","cù","cuān","cuán","cuǎn","cuàn","cūi","cúi","cǔi","cùi","cūn","cún","cǔn","cùn","cuō","cuó","cuǒ","cuò","da","dā","dá","dǎ","dà","dāi","dǎi","dài","dān","dán","dǎn","dàn","dāng","dǎng","dàng","dāo","dáo","dǎo","dào","de","dē","dé","dēi","děi","dēn","dèn","dēng","děng","dèng","dī","dí","dǐ","dì","diǎ","diān","dián","diǎn","diàn","diāo","diǎo","diào","diē","dié","diè","dīng","díng","dǐng","dìng","diū","dōng","dǒng","dòng","dōu","dǒu","dòu","dū","dú","dǔ","dù","duān","duǎn","duàn","dūi","dǔi","dùi","dūn","dún","dǔn","dùn","duō","duó","duǒ","duò","ē","é","ě","è","ēi","éi","ěi","èi","ēn","ěn","èn","ēng","er","ér","ěr","èr","fā","fá","fǎ","fà","fān","fán","fǎn","fàn","fāng","fáng","fǎng","fàng","fēi","féi","fěi","fèi","fēn","fén","fěn","fèn","fēng","féng","fěng","fèng","fó","fōu","fóu","fǒu","fòu","fu","fū","fú","fǔ","fù","gā","gá","gǎ","gà","gāi","gǎi","gài","gān","gán","gǎn","gàn","gāng","gǎng","gàng","gāo","gǎo","gào","gē","gé","gě","gè","gěi","gēn","gén","gěn","gèn","gēng","gěng","gèng","gong","gōng","gǒng","gòng","gōu","gǒu","gòu","gū","gú","gǔ","gù","gua","guā","guǎ","guà","guāi","guǎi","guài","guan","guān","guǎn","guàn","guang","guāng","guǎng","guàng","gui","gūi","gúi","gǔi","gùi","gūn","gǔn","gùn","guo","guō","guó","guǒ","guò","hā","há","hǎ","hà","hāi","hái","hǎi","hài","hān","hán","hǎn","hàn","hāng","háng","hǎng","hàng","hāo","háo","hǎo","hào","hē","hé","hě","hè","hēi","hēn","hén","hěn","hèn","hēng","héng","hèng","hm","hng","hōng","hóng","hǒng","hòng","hōu","hóu","hǒu","hòu","hū","hú","hǔ","hù","huā","huá","huǎ","huà","huāi","huái","huài","huān","huán","huǎn","huàn","huāng","huáng","huǎng","huàng","hui","huī","huí","huǐ","huì","hūn","hún","hǔn","hùn","huo","huō","huó","huǒ","huò","jī","jí","jǐ","jì","jia","jiā","jiá","jiǎ","jià","jian","jiān","jiǎn","jiàn","jiāng","jiǎng","jiàng","jiāo","jiáo","jiǎo","jiào","jie","jiē","jié","jiě","jiè","jīn","jǐn","jìn","jīng","jǐng","jìng","jiōng","jiǒng","jiòng","jiū","jiú","jiǔ","jiù","ju","jū","jú","jǔ","jù","juān","juǎn","juàn","juē","jué","juě","juè","jūn","jǔn","jùn","kā","kǎ","kà","kāi","kǎi","kài","kān","kǎn","kàn","kang","kāng","káng","kǎng","kàng","kāo","káo","kǎo","kào","kē","ké","kě","kè","kěn","kèn","kēng","kěng","kōng","kǒng","kòng","kōu","kǒu","kòu","kū","kǔ","kù","kuā","kuǎ","kuà","kuāi","kuǎi","kuài","kuān","kuǎn","kuàn","kuāng","kuáng","kuǎng","kuàng","kui","kūi","kúi","kǔi","kùi","kūn","kǔn","kùn","kuǒ","kuò","la","lā","lá","lǎ","là","lái","lǎi","lài","lán","lǎn","làn","lāng","láng","lǎng","làng","lāo","láo","lǎo","lào","le","lē","lè","lei","lēi","léi","lěi","lèi","lēng","léng","lěng","lèng","li","lī","lí","lǐ","lì","liǎ","liān","lián","liǎn","liàn","liáng","liǎng","liàng","liāo","liáo","liǎo","liào","lie","liē","liě","liè","lin","lín","lǐn","lìn","līng","líng","lǐng","lìng","liū","liú","liǔ","liù","lo","lōng","lóng","lǒng","lòng","lou","lōu","lóu","lǒu","lòu","lū","lú","lǔ","lù","luán","luǎn","luàn","luě","luè","lūn","lún","lǔn","lùn","luo","luō","luó","luǒ","luò","lǘ","lǚ","lǜ","lüán","lüě","lüè","m","ḿ","m̀","ma","mā","má","mǎ","mà","mái","mǎi","mài","mān","mán","mǎn","màn","māng","máng","mǎng","màng","mao","māo","máo","mǎo","mào","me","méi","měi","mèi","men","mēn","mén","měn","mèn","mēng","méng","měng","mèng","mī","mí","mǐ","mì","mián","miǎn","miàn","miāo","miáo","miǎo","miào","miē","miè","mín","mǐn","mīng","míng","mǐng","mìng","miù","mo","mō","mó","mǒ","mò","mōu","móu","mǒu","mòu","mú","mǔ","mù","n","ň","na","nā","ná","nǎ","nà","nái","nǎi","nài","nān","nán","nǎn","nàn","nāng","náng","nǎng","nàng","nāo","náo","nǎo","nào","ne","né","nè","něi","nèi","nēn","něn","nèn","néng","něng","nèng","ńg","ňg","ǹg","nī","ní","nǐ","nì","niān","nián","niǎn","niàn","niáng","niàng","niǎo","niào","niē","nié","niě","niè","nín","nǐn","níng","nǐng","nìng","niū","niú","niǔ","niù","nóng","nǒng","nòng","nóu","nǒu","nòu","nú","nǔ","nù","nuán","nuǎn","nuàn","nuè","nuó","nuǒ","nuò","nǚ","nǜ","nüè","ō","ó","ò","ou","ōu","óu","ǒu","òu","pā","pá","pà","pāi","pái","pǎi","pài","pān","pán","pǎn","pàn","pang","pāng","páng","pǎng","pàng","pāo","páo","pǎo","pào","pēi","péi","pěi","pèi","pēn","pén","pěn","pèn","peng","pēng","péng","pěng","pèng","pī","pí","pǐ","pì","piān","pián","piǎn","piàn","piāo","piáo","piǎo","piào","piē","piě","piè","pīn","pín","pǐn","pìn","pīng","píng","pìng","po","pō","pó","pǒ","pò","pōu","póu","pǒu","pòu","pu","pū","pú","pǔ","pù","qi","qī","qí","qǐ","qì","qiā","qiá","qiǎ","qià","qiān","qián","qiǎn","qiàn","qiāng","qiáng","qiǎng","qiàng","qiāo","qiáo","qiǎo","qiào","qie","qiē","qié","qiě","qiè","qīn","qín","qǐn","qìn","qīng","qíng","qǐng","qìng","qiong","qiōng","qióng","qiǒng","qiū","qiú","qiǔ","qiù","qū","qú","qǔ","qù","quān","quán","quǎn","quàn","quē","qué","què","qūn","qún","qǔn","rán","rǎn","rāng","ráng","rǎng","ràng","ráo","rǎo","rào","ré","rě","rè","rén","rěn","rèn","rēng","réng","rèng","rì","róng","rǒng","ròng","róu","rǒu","ròu","rú","rǔ","rù","ruán","ruǎn","ruí","ruǐ","ruì","rún","rùn","ruó","ruò","sā","sǎ","sà","sai","sāi","sǎi","sài","sān","sǎn","sàn","sāng","sǎng","sàng","sāo","sǎo","sào","sè","sēn","sěn","sēng","shā","shǎ","shà","shāi","shǎi","shài","shān","shán","shǎn","shàn","shāng","sháng","shǎng","shàng","shāo","sháo","shǎo","shào","shē","shé","shě","shè","shéi","shen","shēn","shén","shěn","shèn","sheng","shēng","shéng","shěng","shèng","shi","shī","shí","shǐ","shì","shōu","shóu","shǒu","shòu","shū","shú","shǔ","shù","shuā","shuǎ","shuà","shuāi","shuǎi","shuài","shuān","shuàn","shuāng","shuǎng","shuàng","shuí","shuǐ","shuì","shǔn","shùn","shuō","shuó","shuò","sī","sǐ","sì","sōng","sǒng","sòng","sou","sōu","sǒu","sòu","su","sū","sú","sù","suān","suǎn","suàn","suī","suí","suǐ","suì","sūn","sǔn","sùn","suō","suǒ","suò","tā","tǎ","tà","tai","tāi","tái","tǎi","tài","tān","tán","tǎn","tàn","tang","tāng","táng","tǎng","tàng","tāo","táo","tǎo","tào","tè","tēng","téng","tī","tí","tǐ","tì","tian","tiān","tián","tiǎn","tiàn","tiāo","tiáo","tiǎo","tiào","tiē","tié","tiě","tiè","tīng","tíng","tǐng","tìng","tong","tōng","tóng","tǒng","tòng","tou","tōu","tóu","tǎu","tòu","tū","tú","tǔ","tù","tuān","tuán","tuǎn","tuàn","tūi","túi","tǔi","tùi","tun","tūn","tún","tǔn","tùn","tuo","tuō","tuó","tuǒ","tuò","wa","wā","wá","wǎ","wà","wāi","wǎi","wài","wān","wán","wǎn","wàn","wāng","wáng","wǎng","wàng","wei","wēi","wéi","wěi","wèi","wēn","wén","wěn","wèn","wēng","wěng","wèng","wo","wō","wó","wǒ","wò","wu","wū","wú","wǔ","wù","xi","xī","xí","xǐ","xì","xiā","xiá","xiǎ","xià","xiān","xián","xiǎn","xiàn","xiāng","xiáng","xiǎng","xiàng","xiāo","xiáo","xiǎo","xiào","xiē","xié","xiě","xiè","xin","xīn","xín","xǐn","xìn","xīng","xíng","xǐng","xìng","xiōng","xióng","xiòng","xiū","xiǔ","xiù","xū","xú","xǔ","xù","xuan","xuān","xuán","xuǎn","xuàn","xuē","xué","xuě","xuè","xūn","xún","xùn","ya","yā","yá","yǎ","yà","yái","yān","yán","yǎn","yàn","yāng","yáng","yǎng","yàng","yāo","yáo","yǎo","yào","yē","yé","yě","yè","yi","yī","yí","yǐ","yì","yin","yīn","yín","yǐn","yìn","yīng","yíng","yǐng","yìng","yo","yō","yong","yōng","yóng","yǒng","yòng","yōu","yóu","yǒu","yòu","yū","yú","yǔ","yù","yuan","yuān","yuán","yuǎn","yuàn","yuē","yuě","yuè","yūn","yún","yǔn","yùn","zā","zá","zǎ","zāi","zài","zài","zān","zán","zǎn","zàn","zāng","záng","zǎng","zàng","zāo","záo","zǎo","zào","zé","zè","zéi","zěn","zèn","zēng","zěng","zèng","zhā","zhá","zhǎ","zhà","zhāi","zhái","zhǎi","zhài","zhān","zhán","zhǎn","zhàn","zhāng","zhǎng","zhàng","zhāo","zháo","zhǎo","zhào","zhe","zhē","zhé","zhě","zhè","zhèi","zhen","zhēn","zhěn","zhèn","zhēng","zhěng","zhèng","zhī","zhí","zhǐ","zhì","zhōng","zhǒng","zhòng","zhou","zhōu","zhóu","zhǒu","zhòu","zhu","zhū","zhú","zhǔ","zhù","zhuā","zhuǎ","zhuāi","zhuǎi","zhuài","zhuān","zhuǎn","zhuàn","zhuāng","zhuǎng","zhuàng","zhūi","zhǔi","zhùi","zhūn","zhǔn","zhùn","zhuō","zhuó","zhuǒ","zhuò","zi","zī","zí","zǐ","zì","zōng","zǒng","zòng","zōu","zǒu","zòu","zū","zú","zǔ","zù","zuān","zuǎn","zuàn","zūi","zǔi","zùi","zūn","zǔn","zùn","zuō","zuó","zuǒ","zuò"); 
	// numeric english pinyin
	charorder[\'en_numeric\'] =  new Array("169","170","171","172","1081","1082","1083","1436","1437","1438","124","125","126","127","139","140","141","142","147","148","149","150","161","162","163","164","165","166","167","168","388","389","390","461","462","463","464","492","493","494","510","511","512","576","577","578","579","631","632","633","685","801","802","927","928","929","930","949","950","951","1037","1038","1039","1040","1056","1057","1058","1059","1076","1077","1078","1079","1080","1247","1248","1249","1250","1268","1269","1270","1391","1392","1393","1408","1409","1410","1415","1416","1417","1430","1431","1432","1433","1434","1435","34","35","36","49","50","51","52","58","59","60","61","62","63","72","73","74","96","97","98","99","107","108","109","116","117","118","119","120","121","122","123","128","129","130","131","135","136","137","138","151","152","153","154","159","160","173","174","175","176","178","179","180","181","182","183","188","189","190","197","198","199","200","225","226","227","239","240","241","247","248","249","250","251","252","253","257","258","259","260","262","263","264","272","273","274","310","311","312","313","322","323","324","325","347","348","349","362","363","364","366","367","368","380","381","382","384","385","386","387","416","417","418","419","433","434","435","438","439","440","441","454","455","456","457","458","459","460","489","490","491","495","496","497","498","507","508","509","522","523","524","542","543","544","545","556","557","558","559","560","570","571","572","573","574","575","601","602","603","604","617","618","619","620","627","628","629","630","634","635","636","637","646","647","648","649","655","656","657","658","668","669","670","686","687","703","704","705","706","721","722","723","724","729","730","731","732","733","734","735","740","741","742","743","771","772","773","774","787","788","789","797","798","799","800","803","804","811","812","813","818","819","820","827","828","829","836","857","858","859","860","874","875","876","877","882","883","884","885","886","887","888","889","897","898","899","923","924","925","926","931","932","933","934","944","945","946","947","948","960","961","962","963","972","973","974","975","985","986","987","989","990","991","998","999","1017","1018","1019","1026","1030","1031","1032","1033","1034","1035","1036","1041","1042","1043","1044","1049","1051","1052","1053","1054","1055","1065","1066","1067","1068","1073","1074","1075","1084","1085","1086","1087","1088","1089","1090","1091","1095","1096","1097","1106","1107","1108","1132","1133","1134","1135","1141","1142","1148","1149","1150","1151","1152","1153","1154","1155","1160","1161","1162","1163","1165","1166","1167","1168","1178","1179","1180","1181","1208","1209","1210","1211","1221","1222","1223","1243","1244","1245","1246","1251","1252","1253","1254","1264","1265","1266","1267","1279","1280","1281","1282","1300","1301","1302","1303","1322","1323","1324","1325","1329","1330","1331","1332","1342","1343","1344","1345","1363","1364","1365","1366","1376","1377","1378","1383","1384","1385","1386","1387","1388","1389","1390","1394","1395","1396","1397","1403","1405","1406","1407","1419","1420","1421","1422","1428","1429","1439","1440","1441","1442","1443","1444","1445","1446","1447","1448","1454","1455","1456","1464","1465","1466","14","15","16","17","27","28","29","30","31","32","33","38","39","40","41","43","44","45","46","47","48","57","64","65","66","67","69","70","71","88","89","90","91","92","93","94","95","100","101","102","103","105","106","111","112","113","114","115","132","133","134","143","144","145","146","155","156","157","158","177","191","192","201","202","203","204","205","206","207","208","209","210","211","212","218","219","220","221","222","223","224","228","229","230","231","235","236","237","238","246","254","255","256","261","265","266","267","275","276","277","278","279","280","281","282","283","284","285","297","306","307","308","309","314","315","316","317","318","319","320","321","327","328","329","330","340","341","342","343","344","345","346","350","351","352","357","358","359","360","361","365","369","370","371","377","378","379","383","392","393","394","395","396","397","398","400","401","402","403","408","409","410","411","412","413","414","415","420","421","422","423","428","429","430","431","432","442","443","444","445","450","451","452","453","466","467","468","469","470","471","472","473","475","476","477","478","484","485","486","487","488","500","501","502","503","504","505","506","513","514","515","516","525","526","527","528","529","530","531","535","536","537","538","539","540","541","546","547","548","549","554","555","561","562","563","567","568","569","581","582","583","584","585","586","587","588","589","595","596","597","598","599","600","605","606","607","608","613","614","615","616","626","639","640","641","643","644","645","650","651","652","653","660","661","662","663","671","672","673","674","675","676","678","679","680","681","682","683","684","696","697","698","699","700","701","702","708","709","710","711","713","714","715","717","718","719","720","736","737","738","739","744","750","751","752","753","764","765","766","767","768","769","770","775","776","777","778","782","783","784","785","786","805","806","807","808","809","810","814","815","816","817","821","822","823","830","831","832","833","834","835","848","849","850","851","852","853","854","855","856","861","862","863","864","865","866","867","868","869","870","871","872","873","890","891","892","893","894","895","896","905","906","907","908","919","920","921","922","936","937","938","939","940","941","942","943","952","953","954","955","964","965","966","967","968","969","970","971","976","977","978","982","983","984","992","993","994","1000","1001","1002","1003","1004","1005","1006","1011","1012","1013","1014","1015","1016","1020","1021","1022","1024","1025","1027","1028","1029","1045","1046","1047","1048","1050","1061","1062","1063","1064","1069","1070","1071","1072","1099","1100","1101","1109","1110","1111","1112","1113","1114","1115","1116","1117","1118","1123","1124","1125","1126","1127","1128","1129","1130","1131","1136","1137","1138","1139","1147","1156","1157","1158","1159","1164","1170","1171","1172","1173","1182","1183","1184","1185","1187","1188","1189","1190","1192","1193","1194","1195","1201","1202","1203","1204","1205","1206","1207","1213","1214","1215","1216","1217","1218","1219","1220","1239","1240","1241","1242","1255","1256","1257","1258","1260","1261","1262","1263","1271","1272","1273","1278","1283","1284","1285","1286","1287","1288","1289","1295","1296","1297","1298","1299","1304","1305","1306","1307","1318","1319","1320","1321","1328","1333","1334","1335","1336","1341","1346","1347","1348","1349","1350","1351","1352","1356","1357","1358","1359","1360","1361","1362","1367","1368","1369","1370","1373","1374","1375","1379","1380","1381","1382","1399","1400","1401","1402","1404","1411","1412","1413","1414","1418","1424","1425","1426","1427","1457","1458","1459","1467","1468","1469","1470","1471","1472","1473","1474","1475","1476","6","7","8","9","10","11","12","13","18","19","20","21","23","24","25","26","37","42","53","54","55","56","68","76","77","78","79","80","81","82","83","84","85","86","87","104","110","184","185","186","187","193","194","195","196","214","215","216","217","233","234","242","243","244","245","268","269","270","271","290","291","292","293","294","295","296","299","300","301","302","303","304","305","326","332","333","334","335","336","337","338","339","353","354","355","356","372","373","374","375","376","391","399","404","405","406","407","424","425","426","427","437","446","447","448","449","465","474","479","480","481","482","483","499","518","519","520","521","532","533","534","550","551","552","553","564","565","566","580","591","592","593","594","610","611","612","622","623","624","625","638","642","659","664","665","666","667","677","692","693","694","695","707","716","725","726","727","728","746","747","748","749","754","755","756","760","761","762","763","780","781","790","791","792","793","794","795","796","824","825","826","841","842","843","844","845","846","847","878","879","880","881","901","902","903","904","910","911","912","913","915","916","917","918","935","956","957","958","959","979","980","981","988","995","996","997","1007","1008","1009","1010","1023","1060","1092","1093","1094","1098","1103","1104","1105","1119","1120","1121","1122","1140","1143","1144","1145","1146","1169","1174","1175","1176","1177","1186","1191","1197","1198","1199","1200","1212","1225","1226","1227","1228","1230","1231","1232","1233","1235","1236","1237","1238","1259","1274","1275","1276","1277","1291","1292","1293","1294","1308","1309","1310","1311","1313","1314","1315","1316","1317","1327","1337","1338","1339","1340","1353","1354","1355","1371","1372","1398","1423","1450","1451","1452","1453","1460","1461","1462","1463","2","3","4","5","22","75","213","232","286","287","288","289","298","331","436","517","590","609","621","654","689","690","691","712","745","758","759","779","837","838","839","840","900","909","914","1102","1196","1224","1229","1234","1290","1312","1326","1449","1","688","757");
	// phonetic english pinyin
	charorder[\'en_phonetic\'] = new Array("169","170","171","172","1081","1082","1083","1436","1437","1438","124","125","126","127","139","140","141","142","147","148","149","150","161","162","163","164","165","166","167","168","173","174","175","176","199","388","389","390","461","462","463","464","492","493","494","510","511","512","576","577","578","579","631","632","633","685","801","802","927","928","929","930","949","950","951","1037","1038","1039","1040","1056","1057","1058","1059","1076","1077","1078","1079","1080","1247","1248","1249","1250","1268","1269","1270","1391","1392","1393","1408","1409","1410","1415","1416","1417","1430","1431","1432","1433","1434","1435","1439","1440","1441","34","35","36","49","50","51","52","58","59","60","61","62","63","72","73","74","96","97","98","99","107","108","109","116","117","118","119","120","121","122","123","128","129","130","131","135","136","137","138","151","152","153","154","159","160","178","179","180","181","182","183","188","189","190","197","198","200","201","202","203","204","225","226","227","239","240","241","247","248","249","250","251","252","253","257","258","259","260","262","263","264","272","273","274","275","276","277","310","311","312","313","322","323","324","325","347","348","349","362","363","364","366","367","368","380","381","382","384","385","386","387","392","393","394","395","416","417","418","419","433","434","435","438","439","440","441","454","455","456","457","458","459","460","489","490","491","495","496","497","498","507","508","509","522","523","524","542","543","544","545","556","557","558","559","560","570","571","572","573","574","575","581","582","583","584","601","602","603","604","617","618","619","620","627","628","629","630","634","635","636","637","646","647","648","649","655","656","657","658","668","669","670","686","687","703","704","705","706","721","722","723","724","729","730","731","732","733","734","735","740","741","742","743","771","772","773","774","787","788","789","797","798","799","800","803","804","811","812","813","818","819","820","827","828","829","836","857","858","859","860","874","875","876","877","882","883","884","885","886","887","888","889","897","898","899","923","924","925","926","931","932","933","934","944","945","946","947","948","960","961","962","963","972","973","974","975","985","986","987","989","990","991","998","999","1017","1018","1019","1026","1030","1031","1032","1033","1034","1035","1036","1041","1042","1043","1044","1049","1051","1052","1053","1054","1055","1065","1066","1067","1068","1073","1074","1075","1084","1085","1086","1087","1088","1089","1090","1091","1095","1096","1097","1106","1107","1108","1132","1133","1134","1135","1141","1142","1148","1149","1150","1151","1152","1153","1154","1155","1160","1161","1162","1163","1165","1166","1167","1168","1178","1179","1180","1181","1182","1183","1184","1185","1208","1209","1210","1211","1221","1222","1223","1243","1244","1245","1246","1251","1252","1253","1254","1264","1265","1266","1267","1279","1280","1281","1282","1300","1301","1302","1303","1322","1323","1324","1325","1329","1330","1331","1332","1342","1343","1344","1345","1363","1364","1365","1366","1373","1376","1377","1378","1383","1384","1385","1386","1387","1388","1389","1390","1394","1395","1396","1397","1403","1405","1406","1407","1419","1420","1421","1422","1428","1429","1442","1443","1444","1445","1446","1447","1448","1454","1455","1456","1464","1465","1466","1467","1468","1469","14","15","16","17","27","28","29","30","31","32","33","38","39","40","41","43","44","45","46","47","48","57","64","65","66","67","69","70","71","88","89","90","91","92","93","94","95","100","101","102","103","105","106","111","112","113","114","115","132","133","134","143","144","145","146","155","156","157","158","177","191","192","205","206","207","208","209","210","211","212","218","219","220","221","222","223","224","228","229","230","231","235","236","237","238","246","254","255","256","261","265","266","267","278","279","280","281","282","283","284","285","297","306","307","308","309","314","315","316","317","318","319","320","321","327","328","329","330","340","341","342","343","344","345","346","350","351","352","357","358","359","360","361","365","369","370","371","377","378","379","383","396","397","398","400","401","402","403","408","409","410","411","412","413","414","415","420","421","422","423","428","429","430","431","432","442","443","444","445","450","451","452","453","466","467","468","469","470","471","472","473","475","476","477","478","484","485","486","487","488","500","501","502","503","504","505","506","513","514","515","516","525","526","527","528","529","530","531","535","536","537","538","539","540","541","546","547","548","549","554","555","561","562","563","567","568","569","585","586","587","588","589","595","596","597","598","599","600","605","606","607","608","613","614","615","616","626","639","640","641","643","644","645","650","651","652","653","660","661","662","663","671","672","673","674","675","676","678","679","680","681","696","697","698","699","700","701","702","708","709","710","711","713","714","715","717","718","719","720","736","737","738","739","744","750","751","752","753","764","765","766","767","768","769","770","775","776","777","778","782","783","784","785","786","792","805","806","807","808","809","810","814","815","816","817","821","822","823","830","831","832","833","848","849","850","851","852","853","854","855","856","861","862","863","864","865","866","867","868","869","870","871","872","873","890","891","892","893","894","895","896","905","906","907","908","919","920","921","922","936","937","938","939","940","941","942","943","952","953","954","955","964","965","966","967","968","969","970","971","976","977","978","982","983","984","992","993","994","1000","1001","1002","1003","1004","1005","1006","1011","1012","1013","1014","1015","1016","1020","1021","1022","1024","1025","1027","1028","1029","1045","1046","1047","1048","1050","1061","1062","1063","1064","1069","1070","1071","1072","1099","1100","1101","1109","1110","1111","1112","1113","1114","1115","1116","1117","1118","1123","1124","1125","1126","1127","1128","1129","1130","1131","1136","1137","1138","1139","1147","1156","1157","1158","1159","1164","1170","1171","1172","1173","1187","1188","1189","1190","1192","1193","1194","1195","1201","1202","1203","1204","1205","1206","1207","1213","1214","1215","1216","1217","1218","1219","1220","1239","1240","1241","1242","1255","1256","1257","1258","1260","1261","1262","1263","1271","1272","1273","1278","1283","1284","1285","1286","1287","1288","1289","1295","1296","1297","1298","1299","1304","1305","1306","1307","1318","1319","1320","1321","1328","1333","1334","1335","1336","1341","1346","1347","1348","1349","1350","1351","1352","1356","1357","1358","1359","1360","1361","1362","1367","1368","1369","1370","1374","1375","1379","1380","1381","1382","1399","1400","1401","1402","1404","1411","1412","1413","1414","1418","1424","1425","1426","1427","1457","1458","1459","1470","1471","1472","1473","1474","1475","1476","6","7","8","9","10","11","12","13","18","19","20","21","23","24","25","26","37","42","53","54","55","56","68","76","77","78","79","80","81","82","83","84","85","86","87","104","110","184","185","186","187","193","194","195","196","214","215","216","217","233","234","242","243","244","245","268","269","270","271","290","291","292","293","294","295","296","299","300","301","302","303","304","305","326","332","333","334","335","336","337","338","339","353","354","355","356","372","373","374","375","376","391","399","404","405","406","407","424","425","426","427","437","446","447","448","449","465","474","479","480","481","482","483","499","518","519","520","521","532","533","534","550","551","552","553","564","565","566","580","591","592","593","594","610","611","612","622","623","624","625","638","642","659","664","665","666","667","677","682","683","684","689","690","692","693","694","695","707","716","725","726","727","728","746","747","748","749","754","755","756","760","761","762","763","780","781","790","791","793","794","795","796","824","825","826","834","835","841","842","843","844","845","846","847","878","879","880","881","901","902","903","904","910","911","912","913","915","916","917","918","935","956","957","958","959","979","980","981","988","995","996","997","1007","1008","1009","1010","1023","1060","1092","1093","1094","1098","1103","1104","1105","1119","1120","1121","1122","1140","1143","1144","1145","1146","1169","1174","1175","1176","1177","1186","1191","1197","1198","1199","1200","1212","1225","1226","1227","1228","1230","1231","1232","1233","1235","1236","1237","1238","1259","1274","1275","1276","1277","1291","1292","1293","1294","1308","1309","1310","1311","1313","1314","1315","1316","1317","1327","1337","1338","1339","1340","1353","1354","1355","1371","1372","1398","1423","1450","1451","1452","1453","1460","1461","1462","1463","2","3","4","5","22","75","213","232","286","287","288","289","298","331","436","517","590","609","621","654","691","712","745","758","759","779","837","838","839","840","900","909","914","1102","1196","1224","1229","1234","1290","1312","1326","1449","1","688","757");

	// key0 and key1
	arMap0 = new Array(1476);
	arMap1 = new Array(1476);
	for (i = 0; i < charorder[key0].length; i++)
	{
		el = (charorder[key0][i]-1);
		arMap0[i] = charbase[key0][el];
		arMap1[i] = charbase[key1][el];
	}
	charmap[0] = arMap0;
	charmap[1] = arMap1;
		
	return charmap;
}
//]]></script>
<script language="javascript1.2">//<![CDATA[
function gwtw_makereplace(idEl, arCharmap) {
	var n = document.forms.vbform[\'arPre_trsp_\' + idEl + \'_value_\'];
	text = n.value;
	for (i = 0; i < arCharmap[0].length; i++)
	{
		re = new RegExp(arCharmap[0][i], "g");
		text = text.replace(re, arCharmap[1][i]);
	}
	n.value = text;
}
function en_phonetic2numeric(idEl) {
	gwtw_makereplace(idEl, getCharmap(\'en_phonetic\', \'en_numeric\'));
}
function en_numeric2phonetic(idEl) {
	gwtw_makereplace(idEl, getCharmap(\'en_numeric\', \'en_phonetic\'));
}
// classic solution
function storeCaret(textEl) {
	if (textEl.createTextRange) { textEl.caretPos = document.selection.createRange().duplicate(); }
}
';


	 	$tmp['strJs'] .= '//]]></script>';
	 	return $tmp['strJs'];
	}

	function get_html($fieldname, $id_element)
	{
		global $oHtml;
	 	$tmp['strHtml'] = '';

		$tmp['strHtml'] .= '
<table class="toolbar" cellpadding="2" cellspacing="0" border="0" width="100%">
<tr style="vertical-align:middle">
<td style="width:15%"><select name="ext_trsp_font" onchange="extSetFont('.$id_element.')">
<option value="1">Arial Unicode MS</option>
<option value="2">Lucida Sans Unicode</option>
<option value="5" selected="selected">Courier New</option>
<option value="6">Verdana</option>
</select></td>
<td style="width:10%;white-space:nowrap" class="t">
&#160;<span style="font-size: 1.1em;"><a href="#" onclick="extSetFontize('.$id_element.',100)">A</a></span>&#160;
&#160;<span style="font-size: 1.4em;"><a href="#" onclick="extSetFontize('.$id_element.',140)">A</a></span>&#160;
&#160;<span style="font-size: 1.8em;"><a href="#" onclick="extSetFontize('.$id_element.',190)">A</a></span>&#160;
</td>
<td style="width:1%"><img src="gw_admin/images/spacer.gif" width="4" height="22" alt="" /></td>
<td>

<table cellpadding="2" cellspacing="0" border="0">
<tr>';

		$oHtml->unsetTag('input'); // reset settings for <input>
		$oHtml->setTag('input', 'type', 'button');
		$oHtml->setTag('input', 'class', 'btn');
		$oHtml->setTag('input', 'onmouseover', 'this.className=\'btnO\'');
		$oHtml->setTag('input', 'onmouseout',  'this.className=\'btn\'');
		$oHtml->setTag('input', 'onmousedown', 'this.className=\'btnD\'');
		$oHtml->setTag('input', 'onmouseup',   'this.className=\'btnO\'');

		$oHtml->setTag('input', 'onclick',   'en_numeric2phonetic('.$id_element.')');
		$tmp['strHtml'] .= '<td>' . $oHtml->input('', 'yi1&#8594;yī') . '</td>';
		$oHtml->setTag('input', 'onclick',   'en_phonetic2numeric('.$id_element.')');
		$tmp['strHtml'] .= '<td>' . $oHtml->input('', 'yī&#8594;yi1') . '</td>';

		$tmp['strHtml'] .= '
</tr>
</table>
</td>
</tr>
</table>';

		return $tmp['strHtml'];
	}





}




?>