<?php
/* Protects script from wrong virtual host configuration */
if (defined('IN_GW'))
{
	die("<!-- $Id: gw_admin.php,v 1.19 2005/06/08 20:43:57 yrtimd Exp $ -->");
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
/**
 *  Main administrative events.
 */
/* Time counter */
$mtime = explode(" ", microtime());
$starttime = $mtime[1] + $mtime[0];
define('IN_GW', TRUE);
define('THIS_SCRIPT', 'gw_admin.php');
define('GW_IS_BROWSE_WEB',   0);
define('GW_IS_BROWSE_ADMIN', 1);
/* Maximum error control when in admin mode */
error_reporting(E_ALL);
/* ------------------------------------------------------- */
/* Load configuration */
$sys['path_gwlib'] = 'lib';
$sys['path_include'] = 'inc';
$sys['path_include_local'] = 'inc';
$sys['is_prepend'] = 1;
include_once('db_config.php');
include_once($sys['path_include_local'] . '/config.inc.php');
/* --------------------------------------------------------
 * Database -> Query storage
 * ----------------------------------------------------- */
$oDb = new gwtkDb;
$oSqlQ = new $sys['class_queries'];
$oSqlQ->set_suffix('-'.$sys['db_type']);
/* ------------------------------------------------------- */
/* Append system settings */
$sys = array_merge($sys, getSettings());
/* Fill empty settings */
$sys['visualtheme'] = isset($sys['visualtheme']) ? $sys['visualtheme'] : 'gw_silver';
/* --------------------------------------------------------
 * mod_rewrite configuration
 * ------------------------------------------------------- */
$sys['is_mod_rewrite'] = 0;
$oHtml = new gw_html;
$oHtml->setVar('is_htmlspecialchars', 0);
$oHtml->setVar('is_mod_rewrite', $sys['is_mod_rewrite']);
$oHtml->is_append_sid = 1;
$oHtml->id_sess_name = GW_SID;
/* --------------------------------------------------------
 * Register global variables
 * ----------------------------------------------------- */
$gw_this['vars'] = $oGlobals->register(array(
	'arControl','arPost','arPre','d','in','file_location',
	GW_ACTION,GW_SID,GW_TARGET,GW_LANG_I,GW_LANG_C,'visualtheme',
	'id','isConfirm','srch','id_srch','is','name','email','id_topic',
	'isUpdate','mode','p','post','q','strict','submit','tid'
));
$oGlobals->do_default($gw_this['vars']['p'], 1);
$oGlobals->do_default($gw_this['vars'][GW_LANG_C], $gw_this['vars'][GW_LANG_I]);
$oGlobals->do_default($gw_this['vars']['lang_enc'], $sys['locale_name']);
$oGlobals->do_default($gw_this['vars']['visualtheme'], $sys['visualtheme']);
/* Depreciated method */
for (reset($gw_this['vars']); list($k1, $v1) = each($gw_this['vars']);)
{
	$$k1 = $v1;
}
$arPostVars = array('file_location');
for (reset($arPostVars); list($k, $v) = each($arPostVars);)
{
	if (isset($_FILES[$v]) && ($_FILES[$v] != '')) // get values from FILES
	{
		$$v = $_FILES[$v];
	}
	elseif (isset($HTTP_POST_FILES[$v]) && ($HTTP_POST_FILES[$v] != '')) // compatibility FILES
	{
		$$v = $HTTP_POST_FILES[$v];
	}
}
unset($arPostVars);
/* Start session */
$oSess = new $sys['class_session'];
$oSess->start();
/** Contents below are available for logged users only **/
if ($gw_this['vars'][GW_ACTION] == 'logout')
{
	$oSess->logout();
}
/* Get the list of dictionaries */
$gw_this['ar_dict_list'] = getDictArray();
##------------------------------------------------
## Admin-only included files
##
## isDebugQ         Show insert/update/delete queries
## path_img_admin   Path to images for administrative interface
## path_export      Path to directory where import/export files will be readed/saved (chmod 0777 required)
##------------------------------------------------
$sys['isDebugQ'] = 0;
$sys['path_img_admin'] = $sys['path_admin'] . '/images';
include_once( $sys['path_include'] . '/class.forms.' .        $sys['phpEx'] );
include_once( $sys['path_include'] . '/class.gw_htmlforms.' . $sys['phpEx'] );
include_once( $sys['path_include'] . '/func.admin.inc.' .     $sys['phpEx'] );
include_once( $sys['path_include'] . '/class.confirm.' .      $sys['phpEx'] );
/* Uppercase / lowercase */
$oCase = new gwv_casemap(array(1,2,3,4,5,6,7,8), array(1,2,3,4,5));
$oCase->set_replace_sp(array('--'=>' ', '-' => ''));
/* --------------------------------------------------------
 * Set interface language, last modified: 22 mar 2005
 * ----------------------------------------------------- */
/* No custom language defined */
if ($gw_this['vars'][GW_LANG_I] == '')
{
	$gw_this['vars'][GW_LANG_I] = $sys['locale_name'];
	/* Get user settings */
	if ($oSess->user_get('locale_name'))
	{
		$gw_this['vars'][GW_LANG_I] = $oSess->user_get('locale_name');
		$gw_this['vars']['lang_enc'] = $oSess->user_get('locale_name');
	}
}
$gw_this['vars'][GW_LANG_I] = preg_replace("/-([a-z0-9])+$/", '', $gw_this['vars'][GW_LANG_I]);
$gw_this['vars']['lang_enc'] = preg_replace("/^([a-z0-9])+-/", '', $gw_this['vars']['lang_enc']);


$oL = new gwtk;
/* path to ./your_project/locale */
$oL->setHomeDir($sys['path_locale']);
$oL->setLocale($gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc']); // path to ./your_project/locale/ru-utf8/
//
// Language files
$oL->getCustom('actions', $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('admin',   $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('err',     $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('options', $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('status',  $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('tdb',     $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('tht',     $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
$oL->getCustom('tol',     $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'], 'join');
//
// Treads for topic editor
$arImgTread = array();
$arImgTread['c'] = '<img src="' . $sys['path_img_admin'] . '/p_c.gif" width="9" height="21" alt="" />';
$arImgTread['i'] = '<img src="' . $sys['path_img_admin'] . '/p_i.gif" width="12" height="21" alt="" />';
$arImgTread['l'] = '<img src="' . $sys['path_img_admin'] . '/p_l.gif" width="12" height="21" alt="" />';
$arImgTread['m'] = '<img src="' . $sys['path_img_admin'] . '/p_m.gif" width="9" height="21" alt="" />';
$arImgTread['n'] = '<img src="' . $sys['path_img_admin'] . '/p_n.gif" width="9" height="21" alt="" />';
$arImgTread['p'] = '<img src="' . $sys['path_img_admin'] . '/p_p.gif" width="9" height="21" alt="" />';
$arImgTread['t'] = '<img src="' . $sys['path_img_admin'] . '/p_t.gif" width="12" height="21" alt="" />';
$arImgTread['trans'] = '<img src="' . $sys['path_img'] . '/0x0.gif" width="12" height="21" alt="" />';
$arImgTread['space'] = '<img src="' . $sys['path_img'] . '/0x0.gif" width="5" height="21" alt="" />';

/* --------------------------------------------------------
 * Load visual theme
 * ----------------------------------------------------- */
if ($oSess->user_get('visualtheme'))
{
	$gw_this['vars']['visualtheme'] = $oSess->user_get('visualtheme');
}
$isThemeLoaded = 0;
if (preg_match("/^[0-9a-z_-]+$/", $gw_this['vars']['visualtheme']))
{
	$themefile = $sys['path_tpl'] . '/' . $gw_this['vars']['visualtheme'] . '/theme.inc.' . $sys['phpEx'];
	if (file_exists($themefile))
	{
		$isThemeLoaded = 1;
		$sys['path_theme'] = $gw_this['vars']['visualtheme'];
	}
}
if (!$isThemeLoaded)
{
	$sys['path_theme'] = $sys['visualtheme'];
	$themefile = $sys['path_tpl'] . '/' . $sys['path_theme'] . '/theme.inc.' . $sys['phpEx'];
}
if (file_exists($themefile))
{
	include_once( $themefile );
}
else
{
	die('Can\'t find ' . $themefile);
}

//
// Init. strings for HTML-templates
$strR = $strL = $strM = '';
// Start new template for admin page
//
$oTpl = new gwTemplate();
$oTpl->isTextSmooth = 0;
$oTpl->unknownTagsT = 'keep';

$menu_info = array();
$menu_info[] = '<span class="green"><b>' . $oL->m('online') . '</b></span>: <b>' . $oSess->user_get('user_name') . '</b>';
$menu_info[] = $oFunc->date_SecToTime( gmmktime() - $oSess->user_get('date_login') );
$menu_info[] = $oHtml->a($sys['page_admin'].'?a=logout', $oL->m('3_logout'));
// --------------------------------------------------------
// Load Add-ons
// --------------------------------------------------------
include_once('gw_addon/multilingual_vars.php');
# include_once('gw_addon/fields_extension.php');

//
// Apply variables for HTML-templates
//
$oTpl->addVal( 'LANG',           $oL->languagelist("0") );
$oTpl->addVal( 'TEXT_DIRECTION', $oL->languagelist("1") );
$oTpl->addVal( 'CHARSET',        $oL->languagelist("2") );
// 11 december 2002, r-t-l with l-t-r
$sys['css_align_right'] = 'right';
$sys['css_align_left'] = 'left';
if ($oL->languagelist("1") == 'rtl')
{
	$sys['css_align_right'] = 'left';
	$sys['css_align_left'] = 'right';
}
$oTpl->addVal( "CSS_ALIGN_RIGHT", $sys['css_align_right'] );
$oTpl->addVal( "CSS_ALIGN_LEFT",  $sys['css_align_left'] );
$oTpl->addVal( "PATH_IMG",        $sys['path_img'] );
$oTpl->addVal( "PATH_SERVER_URL", $sys['server_url'] );
$oTpl->addVal( "PATH_SERVER_DIR", $sys['server_dir'] );
$oTpl->addVal( "V_THEME_NAME",    $gw_this['vars']['visualtheme'] );
$oTpl->addVal( "PATH_IMG",        $sys['path_img'] );
$oTpl->addVal( "TITLE",           $oL->m('2_page_1') );
$oTpl->addVal( "name_dict",       $oL->m('2_page_1') );
$oTpl->addVal( "PATH_CSS",        $sys['path_tpl'] . '/' . $sys['visualtheme'] );
$oTpl->addVal( "PATH_ADMIN",      $sys['path_admin'] );
$oTpl->addVal( "TABLEWIDTH",      $sys['tblwidth'] );
$oTpl->addVal( "FORM_ACTION",     $sys['page_admin'] );
$oTpl->addVal( "CURRENT_ACTION",  '' );
$oTpl->addVal( "q",               '*' );
$oTpl->addVal( "U_TO_WEB",        $sys['server_proto'] . $sys['server_host'] . $sys['page_index'] );
$oTpl->addVal( "U_TO_MAIN",       append_url($sys['page_admin']) );
$oTpl->addVal( "L_TO_MAIN",       $oL->m('3_tomain'));
$oTpl->addVal( "L_TOP_OF_PAGE",   $oL->m('3_top'));
$oTpl->addVal( "non:menuinfo",    implode(" | ", $menu_info));
$oTpl->addVal( "GLOSSWORDVERSION",$sys['version'] );
$oTpl->addVal( "termsamount",     $oL->m('termsamount'));
$oTpl->addVal( "sitename",        $oL->m('sitename'));
$oTpl->addVal( "URL_MAILTO",      $oFunc->text_mailto('<a href="mailto:'. $sys['y_email'].'">'. $sys['y_name'] . '</a>'));
$ar_tpl_construct = array( $sys['path_admin'] . "/" . $sys['path_tpl'] . "/header.html",
					   $sys['path_admin'] . "/" . $sys['path_tpl'] . "/dictname.html");

$oTpl->addVal( 'sid_name', GW_SID);
$oTpl->addVal( 'sid', $gw_this['vars'][GW_SID]);
$oTpl->addVal( 'L_ADD_A_TERM', $oL->m('3_add_term'));
$oTpl->addVal( 'A_SEARCH', GW_A_SEARCH);

$oTpl->addVal( 'L_TERM', $oL->m('term'));
$oTpl->addVal( 'L_DICT', $oL->m('dict'));
$oTpl->addVal( 'L_DEFN', $oL->m('defn'));
	
		
// Possible variables for admin mode:
// $p  is page number   [ $p > 1 ]
// $id is dictionary ID [ $id > 0 ]

// ---------------------------------------------------------
// Search engine, last modified 1 aug 2003
// ---------------------------------------------------------
// Add variables used in search form into common templates
$arTplVars['srch'] = array();

$arTplVars['srch'][] = array(
	'L_SRCH_TERM' => $oL->m('srch_1'),
	'L_SRCH_DEFN' => $oL->m('srch_0'),
	'L_SRCH_BOTH' => $oL->m('srch_-1'),
	'L_SRCH_PHRASE_EDIT' => $oL->m('srch_phrase_edit'),
	'L_SRCH_SUBMIT' => $oL->m('3_srch_submit'),
);

//
// Feature list of dictionary ID
$gw_this['arDictListSrch'] = array();
//
// Search query, default values
if (!is_array($srch)) { $srch = array(); }
if (!isset($srch['by'])) { $srch['by'] = 'd'; } // search by dictionary
if (!isset($srch['in'])) { $srch['in'] = 1; }  // search in terms only for admin mode
if (!isset($srch['adv'])) { $srch['adv'] = 'all'; } // seach all words
//
// Set switcher for HTML
$arTplVars['srch'][] = array('chk_srch_all' => '' );
$arTplVars['srch'][] = array('chk_srch_exact' => '' );
$arTplVars['srch'][] = array('chk_srch_any' => '' );
$arTplVars['srch'][] = array('chk_srch_in_both' => '' );

// Web parameters conversion
$srch['in'] = ($in == 'both') ? -1 : intval($srch['in']);
$srch['in'] = ($in == 'defn') ? 0 : intval($srch['in']);
$srch['in'] = ($in == 'term') ? 1 : intval($srch['in']);
$srch['in'] = ($in == 'syn') ? 7 : intval($srch['in']);
$srch['in'] = ($in == 'address') ? 9 : intval($srch['in']);
$srch['in'] = ($in == 'phone') ? 10 : intval($srch['in']);

// Where to search
if ($srch['in'] == '1')
{
	// search for term only
	$arTplVars['srch'][] = array('chk_srch_in_term' => ' checked="checked"' );
}
elseif (intval($srch['in']) == 0) // search in terms and definitions, default
{
	$arTplVars['srch'][] = array('chk_srch_in_defn' => ' checked="checked"' );
}
elseif (intval($srch['in']) == -1) // search in terms and definitions, default
{
	$arTplVars['srch'][] = array('chk_srch_in_both' => ' checked="checked"' );
}
else // search for all fields
{
	$srch['in'] = array(0);
	$arTplVars['srch'][] = array('chk_srch_in_term' => ' checked="checked"' );
}
if (isset($srch['by']) && $srch['by'] == 'd')
{
	// Search by dictionary
	//
	// Set switcher for HTML
	$arTplVars['srch'][] = array('chk_srch_by_dict' => ' checked="checked"' );
	for (reset($gw_this['ar_dict_list']); list($kDict, $vDict) = each($gw_this['ar_dict_list']);)
	{
		if ($d == 0)
		{
			$gw_this['arDictListSrch'][] = $vDict['id'];
		}
		else
		{
			// TODO: search for multiple dictionaries
			$gw_this['arDictListSrch'][] = $d;
			break;
		}
	}
}

// ---------------------------------------------------------
// Fix dictionary ID
/* Old variables */
$d = ( $id != '' ) ? $id : $d;
$id = ( $d != '' ) ? $d : $id;
/* 1.7.0 */
$gw_this['vars']['d'] = ($gw_this['vars']['id'] == '') ? $gw_this['vars']['d'] : $gw_this['vars']['id'];
$gw_this['vars']['id'] = ($gw_this['vars']['d'] == '') ? $gw_this['vars']['id'] : $gw_this['vars']['d'];

/* Process selected terms from search results */
if (isset($gw_this['vars']['arPost']) && is_array($gw_this['vars']['arPost']))
{
	if (isset($gw_this['vars']['arPost']['selected_term_on']) 
		|| isset($gw_this['vars']['arPost']['selected_term_off'])
		|| isset($gw_this['vars']['arPost']['selected_term_move'])
		)
	{
		$gw_this['vars'][GW_ACTION] = UPDATE;
		$gw_this['vars'][GW_TARGET] = GW_T_TERM;
	}
	elseif (isset($gw_this['vars']['arPost']['selected_term_remove']))
	{
		$gw_this['vars'][GW_ACTION] = GW_A_REMOVE;
		$gw_this['vars'][GW_TARGET] = GW_T_TERM;
	}
}
/* Set required field names for HTML-forms */
$arReq['dict'] = array('title', 'id_tp', 'uid', 'tablename', 'lang', 'cfg', 'visualtheme');
$arReq['term'] = array('arPre[term][0][value]');
$arReq['topic'] = array('name', 'parent');
$strDictDetails = '';
// --------------------------------------------------------
// Load extensions: 27 aug 2003
// --------------------------------------------------------
$gw_this['vars']['funcnames'][UPDATE . GW_T_TERM] = isset($gw_this['vars']['funcnames'][UPDATE . GW_T_TERM]) ? $gw_this['vars']['funcnames'][UPDATE . GW_T_TERM] : array();
$gw_this['vars']['funcnames'][UPDATE . GW_T_DICT] = isset($gw_this['vars']['funcnames'][UPDATE . GW_T_DICT]) ? $gw_this['vars']['funcnames'][UPDATE . GW_T_DICT] : array();
## --------------------------------------------------------
## Get dictionary description
## Very important
	if ($gw_this['vars']['d'])
	{
		// Get dictionary settings
		$arDictParam = getDictParam($gw_this['vars']['d']);
		//
		// No any settings, return to the dictionary listing
		if (empty($arDictParam))
		{
			gwtk_header(append_url($sys['server_proto'].$sys['server_host'].$sys['page_admin'].'?'.GW_ACTION.'='.BRWS.'&'.GW_TARGET.'=' . GW_T_DICT));
		}
		//
		$DBTABLE = $arDictParam['tablename'];
		// add dictionary ID into HTML-template
		$oTpl->addVal( 'd', $gw_this['vars']['d'] );
		//
		$languagelist = $oL->languagelist();
		$str_is = $arDictParam['is_active'] ? '<span class="green">%s</span>' : '<span class="red">%s</span>';
		$str_is = sprintf($str_is, $oL->m('is_'.$arDictParam['is_active']));

		//
		$strDictDetails .= '<table cellspacing="0" cellpadding="2" border="0" width="100%">';
		$strDictDetails .= '<tr class="t" style="vertical-align:top">';
		$strDictDetails .= '<td style="width:45%"><span class="f">' . $oL->m('dict') . ':</span><br />'. '<a href="'.$sys['page_index'].'?a=list&amp;d='.$id.'" onclick="window.open(this.href);return false;">' . $arDictParam['title'] . '</a></td>';
		$strDictDetails .= '<td style="width:25%"><span class="f">' . $oL->m('termsamount') . ':</span><br />'. $oFunc->number_format($arDictParam['int_terms'], 0, $oL->languagelist('4')) .'</td>';
		$strDictDetails .= '<td style="width:10%"><span class="f">' . $oL->m('status') . ':</span><br />'. $str_is . '</td>';
		$strDictDetails .= '<td style="width:10%"><span class="f">' . $oL->m('lang') . ':</span><br />'. $languagelist[$arDictParam["lang"]] . '</td>';
		$strDictDetails .= '<td style="width:10%"><span class="f">' . $oL->m('size') . ':</span><br />'. $oFunc->number_format($arDictParam["int_bytes"]/1024, 1, $oL->languagelist('4')) . '&#160;'. $oL->m('kb') . '</td>';
		$strDictDetails .= '</tr>';
		$strDictDetails .= '</table>';
		$oTpl->addVal( "DICT_DETAILS", $strDictDetails );
		/* Get a term parameters */
		if ($gw_this['vars']['tid'])
		{
			$arTermParam = getTermParam($tid);
		}
	}
	/* Display navigation tool bar */
	$strL .= admGetNavbar($arNav, $gw_this['vars'][GW_ACTION], $gw_this['vars'][GW_TARGET]);
	if (empty($arDictParam)){ $arDictParam = array(); }
	$q = trim($oFunc->mb_substr($q, 0, 254));
	/* Search for terms */
	if ($gw_this['vars'][GW_ACTION] == GW_A_SEARCH)
	{
		if ($id_srch == '')
		{
			/* 1st search query */
			$gw_this['arSrchResults'] = gw_search($q, $gw_this['arDictListSrch'], $srch);
		}
		else 
		{
			/* list seach results */
			$gw_this['arSrchResults'] = gw_search_results($id_srch, $p);
		}
		$oTpl->addVal( 'q', textcodetoform($q) );

		$intSumPages = 1;
		if ( isset($gw_this['arSrchResults']['pages']) )
		{
			$intSumPages = $gw_this['arSrchResults']['pages'];
		}
		/* fix page number */
		if ( ( $p < 1 ) || ( $p > $intSumPages) ){ $p = 1; }
		if ($intSumPages > 1)
		{
			$oTpl->addVal("L_pages", $oL->m('L_pages'));
		}
		$sys['total'] = $gw_this['arSrchResults']['found'];
		$oTpl->addVal( 'q', textcodetoform($gw_this['arSrchResults']['q']) );
		$oTpl->addVal( 'PAGE_SELECTION', '');
		/* enable page navigation */
		if ($intSumPages > 1)
		{
			$oTpl->addVal( 'PAGE_SELECTION',
					getNavToolbar($intSumPages, $p, $sys['page_admin'] . '?'.GW_ACTION.'='.GW_A_SEARCH.'&id_srch='.$id_srch.'&d='.$d.'&p=')
					);
		}
		if ($gw_this['arSrchResults']['found'] == 0) // nothing was found
		{
			$gw_this['arSrchResults']['html'] =
			'<div style="font:75% verdana, helvetica">'.
			'<p>'. $oL->m('reason_5') . '</p>'.
			'<p>' .$oHtml->a(append_url($sys['page_admin'] . '?'. GW_ACTION . '='.GW_A_SEARCH.'&amp;d='.$d."&amp;q=".urlencode($gw_this['arSrchResults']['q']).'&amp;in=both'),
								$oL->m('srch_-1')).
			'</p>'.
			'</div>';
		}
		$strR .= $gw_this['arSrchResults']['html'];
	}
	/* Display search form */
	if (($id != '') && ((${GW_TARGET} == GW_T_DICT) || (${GW_TARGET} == GW_T_TERM)) || !empty($q) || !empty($id_srch))
	{
		$oTpl->addVal( 'srch_a_name', GW_A_SEARCH);
		$ar_tpl_construct[] = $sys['path_admin'].'/'.$sys['path_tpl'].'/searchform.html';
	}
	else
	{
		$ar_tpl_construct[] = $sys['path_admin'].'/'.$sys['path_tpl'].'/searchform_empty.html';
	}
##
## --------------------------------------------------------

$strForm = $strToMain = '';
$isPostError = 1;

## --------------------------------------------------------
## Preview items (translation, transcription, pages etc.)
if (is_array($arPre))
{
	/* Change current action to "Edit" */
	if ($gw_this['vars'][GW_ACTION] != GW_A_ADD){ $gw_this['vars'][GW_ACTION] = GW_A_EDIT; }
	if (isset($arPre[$t]['remove'])){ $gw_this['vars'][GW_ACTION] = GW_A_REMOVE; }
#	${GW_TARGET} = GW_T_TERM;
}
##
## --------------------------------------------------------
/* Constructs 'at.{GW_ACTION}_{GW_TARGET}.php' files */
$pathAction = $sys['path_include'] . '/' . GW_TARGET . '.' . $gw_this['vars'][GW_TARGET] . '.inc.' . $sys['phpEx'];
$gw_this['vars']['cur_funcname'] = $gw_this['vars'][GW_TARGET] . '_' . $gw_this['vars'][GW_ACTION];

/* Array index for $oL->m() */
$strPageIndex = isset($arPageNumbers[$gw_this['vars'][GW_TARGET] . '_' . $gw_this['vars'][GW_ACTION]])
				? '2_page_' . $arPageNumbers[$gw_this['vars'][GW_TARGET] . '_' . $gw_this['vars'][GW_ACTION]]
				: '2_page_1';
if ($gw_this['vars'][GW_TARGET] != '')
{
	file_exists($pathAction) ? include_once($pathAction) : printf($oL->m('reason_10'), $pathAction);
}
file_exists($sys['path_include'].'/t.'.$gw_this['vars']['cur_funcname'].'.inc.' . $sys['phpEx']) 
	? include_once($sys['path_include'].'/t.'.$gw_this['vars']['cur_funcname'].'.inc.' . $sys['phpEx']) 
	: '';
/* Set current action name (page numbers) */
$oTpl->addVal( "CURRENT_ACTION", $oL->m($strPageIndex));

/* Create dictionaries list */
$oTpl->AddVal( 'block:SearchSelect', getDictSrch('', 1, 99,'', 1, $d));

/* Control panel home */
if ($strPageIndex == '2_page_1')
{
	if (sizeof($gw_this['ar_dict_list']) > 0)
	{
		/* Last updated dictionaries */
		$oTpl->addVal( 'block:dict_updated', 
			gw_html_block_small(
				$oL->m('r_dict_updated'), 
				getTop10('R_DICT_UPDATED', $sys['max_dict_top'], 1), 
				't', 0, 0)
		);
		/* Last updated terms */
		$oTpl->addVal( 'block:term_updated', 
			gw_html_block_small(
				$oL->m('r_term_updated'), 
				getTop10('R_TERM_UPDATED', intval($sys['max_dict_top']/2), 0), 
				't', 0, 0)
		);
	}
	$oTpl->addVal( 'A_ADD', GW_A_ADD);
	$oTpl->addVal( 'L_ADD', $oL->m('3_add'));
	$arHelpMap = array(
					'tip016' => 'tip019',
					'tip017' => 'tip020',
					'tip018' => 'tip021'
				 );
	$strHelp = '';
	$strHelp .= '<dl>';
	for(; list($k, $v) = each($arHelpMap);)
	{
		$strHelp .= '<dt><b>' . $oL->m($k) . '</b></dt>';
		$strHelp .= '<dd>' . $oL->m($v) . '</dd>';
	}
	$strHelp .= '</dl>';
	$strR .= '<br/>'.kTbHelp($oL->m('2_tip'), $strHelp);
}
else
{
   $oTpl->addVal( "TITLE", $oL->m('2_page_1') . ' - ' . $oL->m($strPageIndex) );
}

/* The last elements for page */
$ar_tpl_construct[] = $sys['path_admin']. '/' . $sys['path_tpl'] . '/page_admin.html';
$ar_tpl_construct[] = $sys['path_admin']. '/' . $sys['path_tpl'] . '/footer.html';

/* Add previously defined template variables */
for (reset($arTplVars['srch']); list($k, $v) = each($arTplVars['srch']);)
{
	while (is_array($v) && list($k2, $v2) = each($v))
	{
		$oTpl->AddVal($k2, $v2);
	}
}
/* Add previously defined template files */
if ( isset($ar_tpl_construct) && is_array($ar_tpl_construct) )
{
	for (reset($ar_tpl_construct); list($k, $v) = each($ar_tpl_construct); )
	{
		$oTpl->setHandle( $k , $v );
	}
}
/* Close sessions */
$oSess->user_close();

// --------------------------------------------------------
// Debug information
if (DEBUG)
{
	include($sys['path_include'] . '/page.footer.' . $sys['phpEx']);
}
/* The last header */
$oHdr->add('Content-Type: text/html; charset='.$oL->languagelist('2'));
$oHdr->output();

# $strR .= '<br />';
# $strR .= getTop10('R_DICT_EFFIC', 100);

$oTpl->addVal( "TOMAIN", $strToMain );
$oTpl->addVal( "ADMIN_RIGHT_SIDE", $strR );
$oTpl->addVal( "ADMIN_LEFT_SIDE", $strL );
$oTpl->parse();

print $oTpl->output();

#print_r($_POST);

/* end of file */
?>