<?php
/**
 * Glossword plug-in: Export to CSV
 * Special for Spiros Doikas
 * Location: glossword/inc/export_CSV/index.inc.php
 * by Dmitry N. Shilnikov <dev@glossword.info>
 * @version $Id: index.inc.php,v 1.1 2005/06/07 22:03:54 yrtimd Exp $
 */
// --------------------------------------------------------
if (!defined('IN_GW'))
{
	die("<!-- leave empty -->");
}
// --------------------------------------------------------
define('FORMAT_NAME', str_replace('export_', '', $arPost['fmt']));
define('FORMAT_EXT', 'txt');
// --------------------------------------------------------
/**
 *
 */
function getFormCsv($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global ${GW_ACTION}, $id, $sys, $oL, $arPost, $arSplit, $arDictParam, $oFunc, ${GW_SID};
	$strForm = "";
	$trClass = "t";
	$form = new gwForms();
	$form->action = append_url($sys['page_admin']);
	$form->submitok = $oL->m('3_next').' &gt;';
	$form->submitdel = $oL->m('3_remove');
	$form->submitcancel = $oL->m('3_cancel');
	$form->formbgcolor = $GLOBALS['theme']['color_2'];
	$form->formbordercolor = $GLOBALS['theme']['color_4'];
	$form->formbordercolorL = $GLOBALS['theme']['color_1'];
	$form->Set('charset', $sys['internal_encoding']);
	$form->arLtr = array('arPost[split]');
	## ----------------------------------------------------
	##
	// reverse array keys <-- values;
	$arReq = array_flip($arReq);
	// mark fields as "REQUIRED" and make error messages
	while(is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = "";
		if (isset($arReq[$key])) { $arReqMsg[$key] = ' <span style="color:#E30"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span class="'.$trClass.'" style="color:#E30"><b>' . $oL->m('reason_9') .'</b></span>'; }
	} // end of while
	##
	## ----------------------------------------------------
	$form->setTag('select', 'class', 'input');

	$strForm = '';
	$strForm .= '<table width="100%">';
	$strForm .= '<col width="50%"/><col width="50%"/>';
	$strForm .= '<tbody><tr valign="top"><td>';
			$strForm .= getFormTitleNav($oL->m('3_export'), '<span class="r">'.FORMAT_NAME.'</span>');
			$strForm .= '<table class="gw2TableFieldset" width="100%">';
			$arTmp['id'] = 'arPost-t';




			$strForm .= '</tbody></table>';

	$strForm .= '</td><td>';

		$strForm .= getFormTitleNav($oL->m('dictdump_split'));
		$strForm .= '<table cellspacing="3" cellpadding="0" border="0" width="100%" class="gw2TableFieldset">';
		$strForm .= '<tbody><tr><td style="width:30%"></td><td style="width:70%"></td></tr>';
		$arBoxId = array();
		$arBoxId['id'] = "split_list1";
		$arBoxId['onchange'] = 'checkSplit()';
		$strForm .= '
			<tr>
			<td class="td1">' . $form->field('radio', 'arPost[split_m]', 'list', $vars['is_list1'], $arBoxId) . '</td>
			<td class="td2"><label id="labelList" for="split_list1">'.$oL->m('dictdump_list').'</label></td>
			</tr>';
		$strForm .= '
	  		<tr>
			<td></td>
			<td class="td2">'. $form->field('select', 'arPost[split1]', $vars['intsplit'], '100%', $arSplit). '
			</td>
			</tr>';
		$arBoxId['id'] = 'split_custom';
		$arBoxId['onchange'] = 'checkSplit()';
		$strForm .= '
			<tr>
			<td class="td1">' . $form->field('radio', 'arPost[split_m]', 'custom', $vars['is_list2'], $arBoxId) . '</td>
			<td class="td2"><label id="labelCustom" for="split_custom">'.$oL->m('dictdump_custom').'</label></td>
			</tr>';
		$strForm .= '
			<tr>
			<td></td>
			<td class="td2">'. $form->field('input', "arPost[split2]", $vars['int_terms'], '100%', $arSplit). '
			</td>
			</tr>';
		$strForm .= '</tbody></table>';

		$arBoxId = array();


	$strForm .= '</td>';
	$strForm .= '</tr>';
	$strForm .= '</table>';
	include($sys['path_include'] . '/export_CSV/index.js.' . $GLOBALS['sys']['phpEx']);
	$strForm .= $form->field("hidden", 'arPost['.GW_TARGET.']', FORMAT_NAME);
	$strForm .= $form->field("hidden", 'arPost[fmt]', $vars['fmt']);
	$strForm .= $form->field("hidden", 'arPost[int_terms]', $vars['int_terms']);
	$strForm .= $form->field("hidden", 'arPost[min]', $vars['min']);
	$strForm .= $form->field("hidden", 'arPost[max]', $vars['max']);
	$strForm .= $form->field("hidden", 'id', $id);
	$strForm .= $form->field("hidden", GW_TARGET, GW_T_DICT);
	$strForm .= $form->field("hidden", GW_ACTION, EXPORT);
	$strForm .= $form->field("hidden", GW_SID, ${GW_SID});
	return $form->Output($strForm);
} //
// --------------------------------------------------------
$arReq = array('fmt');
// --------------------------------------------------------
// split per lines
$is_split   = isset($arPost['is_split']) ? $arPost['is_split'] : 100;
$is_list1   = ( isset($arPost['is_list1']) && $arPost['is_list1'] == "list" ) ? 1 : 0;
$is_list2   = ( isset($arPost['is_list2']) && $arPost['is_list2'] == "custom" ) ? 1 : 0;
if (!($is_list1)&&!($is_list2) ) { $is_list1 = 1; }
$is_term_t1   = isset($arPost['is_term_t1']) ? $arPost['is_term_t1'] : 0;
$is_term_t2   = isset($arPost['is_term_t2']) ? $arPost['is_term_t2'] : 0;
$is_term_id   = isset($arPost['is_term_id']) ? $arPost['is_term_id'] : 0;
//
$arSplit = array ('100' => '100', '500' => '500', '1000' => '1000', '2500' => '2500', '5000' => '5000');
$intSplit = 500;
//
if (!isset($arPost[GW_TARGET])) { $post = ''; }
if ($post == '')
{
	/** not saved */
	/* the number of terms */
	$vars['int_terms'] = 0;

	$tmp['ar_min_his'] = explode(":", $arPost['date_minS']);
	$tmp['ar_max_his'] = explode(":", $arPost['date_maxS']);
	/* hour, minute, second, month, day, year  */
	$vars['min']  = mktime($tmp['ar_min_his'][0], $tmp['ar_min_his'][1], $tmp['ar_min_his'][2],
						$arPost['date_minM'], $arPost['date_minD'], $arPost['date_minY']);
	$vars['max']  = mktime($tmp['ar_max_his'][0], $tmp['ar_max_his'][1], $tmp['ar_max_his'][2],
							$arPost['date_maxM'], $arPost['date_maxD'], $arPost['date_maxY']);
	if (isset($arPost['date_minY']))
	{
		$arSql = $oDb->sqlRun($oSqlQ->getQ('cnt-dict-date', $arDictParam['tablename'], $vars['min'], $vars['max']));
		$vars['int_terms'] = isset($arSql['0']['n']) ? $arSql['0']['n'] : 0;
	}
	//
	$vars['fmt'] = $arPost['fmt'];
	$vars['intsplit'] = $intSplit;
	$vars['is_list1'] = $is_list1;
	$vars['is_list2'] = $is_list2;
	$strR .= getFormCsv($vars, 0, 0, $arReq);
}
else
{
	$arBroken = validatePostWalk($arPost, $arReq);
	if (sizeof($arBroken) == 0)
	{
		$isPostError = 0;
	}
	if (!$isPostError) // single check is ok
	{
		$i = 0;
		$q = array();
		$sqlWhereDate = 'date_created >= ' . $arPost['min'] . ' AND date_created <= ' . $arPost['max'];
		$mode = 'w';
		if ($arPost['split_m'] == GW_A_LIST)
		{
			$int_split = $arPost['split1'];
		}
		else
		{
			$int_split = $arPost['split2'];
		}
		$cntFiles = ceil($arPost['int_terms'] / $int_split);
		$fileS = getExportFilename(
				$sys['path_export'] . '/csv/' . sprintf("%05s", $id) . '_' . $arDictParam['tablename'],
				$cntFiles,
				FORMAT_EXT
			 );
		$strR .= '<ul class="t">';
		/* Export in progress */
		$oHtml->setTag('a', 'target', '_blank');
		for ($i = 0; $i < $cntFiles; $i++)
		{
			$limit = getSqlLimit($arDictParam['int_terms'], $i + 1,  $int_split);
			$filename = sprintf($fileS, ($i + 1), $cntFiles);
			$strQ = '';
			$strR .= '<li><span class="f">';
			$strR .= $oHtml->a($filename, $filename);
			$strR .= '</span>... ';;
			$sql = $oSqlQ->getQ('get-term-export', $DBTABLE, $sqlWhereDate, $limit);
			$arSql = $oDb->sqlExec($sql, '', 0);
			/* */
			/* MS format */
			$str_enclose_append = $str_enclose_prepend = '"';
			$str_split = ";";
			$str_split_defn = " ;; ";
			/* Plain format */
			$str_enclose_append = $str_enclose_prepend = '';
			$str_split = "\t";
			$str_split_defn = " ;; ";

			$is_ms = 0;
			if ($str_enclose_append == '"')
			{
				$is_ms = 1;
			}
			$objDom = new gw_domxml;
			$arCSV = array();
			
			/* Add header to CSV-file */
			$incr_term = 0;
			$arCSV[0] = 'term';
			$arCSV[1] = 't1';
			$arCSV[2] = 't2';
			$arDictParam['is_term'] = 1;
			for (reset($arFields); list($fK, $fV) = each($arFields);)
			{
				$arCSV[$fV[5]] = ($arDictParam['is_'.$fV[0]]) ? $fV[0] : '';
			}
			$strQ .= $str_enclose_prepend.implode($str_enclose_append.$str_split.$str_enclose_prepend, $arCSV).$str_enclose_append;
			$strQ .= CRLF;
			$arCSV = array();
			/* */
			for (; list($k, $arV) = each($arSql);)
			{
				$incr_term = $k;
				$strQ .= '';
				$arPre = array();
				$arDuplicates = array(array());
				/* Init. */
				for ($int_empty = 1; $int_empty < 11; $int_empty++)
				{
					$arCSV[$incr_term][$int_empty] = '';
				}
				/* Term */
				$arCSV[$incr_term][0] = text_parse_csv_column($arV['term'], $is_ms);
				$arCSV[$incr_term][1] = text_parse_csv_column($arV['term_1'], $is_ms);
				$arCSV[$incr_term][2] = text_parse_csv_column($arV['term_2'], $is_ms);
				/* */
				$str_xml = '<term>'.$arV['term'].'</term>';
				$arPre = array_merge_clobber($arPre, gw_Xml2Array($str_xml.$arV['defn']));
				for (reset($arFields); list($fK, $fV) = each($arFields);)
				{
					if (!isset($arPre[$fV[0]])){ continue; }
					$tmpStr = $objDom->get_content( $arPre[$fV[0]] );
					if (trim($tmpStr) == ''){ continue; }

			switch ($fV[0])
			{
				case 'trsp':
					$tmpf = array();
					for (reset($arPre[$fV[0]]); list($kfV, $vfV) = each($arPre[$fV[0]]);)
					{
						$arCSV[$incr_term][$fV[5]] .= text_parse_csv_column( $vfV['value'] );
					}
				break;
				case 'defn':
					$tmpf = array();
					for (reset($arPre[$fV[0]]); list($kfV, $vfV) = each($arPre[$fV[0]]);)
					{
						if ($kfV == 0)
						{
							$arCSV[$incr_term][$fV[5]] .= text_parse_csv_column( $vfV['value'] );
						}
						else
						{
							$arDuplicates[$fV[5]][] = $vfV['value'];
						}
					}
				break;
				case 'abbr':
				case 'trns':
					for (reset($arPre[$fV[0]]); list($kfV, $vfV) = each($arPre[$fV[0]]);)
					{
						$ar_vvfV = array();
						for (reset($vfV); list($kkfV, $vvfV) = each($vfV);)
						{
							$str_attributes = implode(', ', $vvfV['attributes']);
							$str_attributes = ($str_attributes == '') ? '' : '('.$str_attributes.') ';
							$ar_vvfV[] = strval($str_attributes).$vvfV['value'];

						}
						if ($kfV == 0)
						{
							$arCSV[$incr_term][$fV[5]] .= text_parse_csv_column( implode($str_split_defn, $ar_vvfV) );
						}
						else
						{
							$arDuplicates[$fV[5]][] = implode($str_split_defn, $ar_vvfV);
						}
					}
				break;
				case 'see':
				case 'syn':
					for (reset($arPre[$fV[0]]); list($kfV, $vfV) = each($arPre[$fV[0]]);)
					{
						$ar_vvfV = array();
						for (reset($vfV); list($kkfV, $vvfV) = each($vfV);)
						{
							$str_attributes = implode(', ', $vvfV['attributes']);
							$str_attributes = ($str_attributes == '') ? '' : '('.$str_attributes.') ';
							$ar_vvfV[] = $str_attributes.$vvfV['value'];

						}
						if ($kfV == 0)
						{
							$arCSV[$incr_term][$fV[5]] .= text_parse_csv_column( implode($str_split_defn, $ar_vvfV) );
						}
						else
						{
							$arDuplicates[$fV[5]][] = implode($str_split_defn, $ar_vvfV);
						}
					}
				break;
				case 'usg':
				case 'src':
				case 'phone':
				case 'address':
					for (reset($arPre[$fV[0]]); list($kfV, $vfV) = each($arPre[$fV[0]]);)
					{
						$ar_vvfV = array();
						for (reset($vfV); list($kkfV, $vvfV) = each($vfV);)
						{
							$ar_vvfV[] = $vvfV['value'];

						}
						if ($kfV == 0)
						{
							$arCSV[$incr_term][$fV[5]] .= text_parse_csv_column( implode($str_split_defn, $ar_vvfV) );
						}
						else
						{
							$arDuplicates[$fV[5]][] = implode($str_split_defn, $ar_vvfV);
						}
					}
				break;
			}
				} /* end of $arFields */
				ksort($arCSV[$incr_term]);
				$strQ .= $str_enclose_prepend.implode($str_enclose_append.$str_split.$str_enclose_prepend, $arCSV[$incr_term]).$str_enclose_append;
				$strQ .= CRLF;
				for (reset($arDuplicates); list($dK, $dV) = each($arDuplicates);)
				{
					for (reset($dV); list($dKv, $dVv) = each($dV);)
					{
						$arCSV[$incr_term][$dK] = text_parse_csv_column($dVv);
						$strQ .= $str_enclose_prepend.implode($str_enclose_append.$str_split.$str_enclose_prepend, $arCSV[$incr_term]).$str_enclose_append;
						$strQ .= CRLF;
					}
				}
			}
			$isWrite = $oFunc->file_put_contents( $filename, $strQ, $mode);
			$strR .= ( $isWrite ?  'ok (' . $oFunc->number_format(strlen($strQ), 0, $oL->languagelist('4')) . " " . $oL->m('bytes') . ')' : $oL->m('error') ) . '</li>';
		}
		$strR .= '</ul>';
		$oHtml->unsetTag('a');
	}
}
/* */
function text_parse_csv_column($t, $is_ms = 0)
{
	if ($is_ms)
	{
		$t = str_replace('"', '""', $t);
	}
	$t = str_replace('\r\n', '\\n', $t);
	$t = str_replace('\n', '\\n', $t);
	$t = str_replace('\r', '\\r', $t);
	$t = str_replace('\t', '\\t', $t);

	$t = str_replace("\r\n", '\n', $t);
	$t = str_replace("\n", '\n', $t);
	$t = str_replace("\r", '\r', $t);
	$t = str_replace("\t", '\t', $t);
	return $t;
}

/* End of file */
?>