<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: func.browse.inc.php,v 1.26 2005/06/09 06:32:02 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *  © 2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Math, SQL, HTML functions for browsing dictionary.
 */
// --------------------------------------------------------

/* Create custom page */
function gw_custom_page($id_page)
{
	global $oSqlQ, $oDb, $oTpl, $oFunc, $oHtml;
	global $gw_this, $sys, $oL, $str_current_section, $ar_tpl_construct, $arPost, $layout;
	$id_lang = 0;
	/* Check languages first */
	switch ($sys['pages_link_mode'])
	{
		case GW_PAGE_LINK_NAME:
			$sql_id_page = 'gpph.page_title = "'.gw_text_sql(urlencode($id_page)).'"';
		break;
		case GW_PAGE_LINK_URI:
			$sql_id_page = 'gp.page_uri = "'.gw_text_sql(urlencode($id_page)).'"';
		break;
		default:
			$sql_id_page = 'gp.id_page = "'.$id_page.'"';
		break;
	}
	$arSql = $oDb->sqlRun($oSqlQ->getQ('get-custompages-lang', $sql_id_page), 'page');
	for (; list($arK, $arV) = each($arSql);)
	{
		if ($arV['id_lang'] == $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'])
		{
			$id_lang = $arV['id_lang'];
			break;
		}
		elseif ($arV['id_lang'] == $sys['locale_name'])
		{
			$id_lang = $arV['id_lang'];
			break;
		}
		else
		{
			$id_lang = $arV['id_lang'];
		}
	}
	$id_page_int = 0;
	if ($id_lang)
	{
		$arSql = $oDb->sqlRun($oSqlQ->getQ('get-custompages', $sql_id_page, $id_lang), 'page');
		for (; list($arK, $arV) = each($arSql);)
		{
			$id_page_int = $arV['id_page'];
			$ar_tpl_construct[] = '../common/custom_page.html';
			/* Process text filters */
			while (!$sys['is_debug_output']
					&& is_array($sys['filters_defn'])
					&& list($k, $v) = each($sys['filters_defn']) )
			{
				$arV['page_content'] = $v($arV['page_content']);
			}
			/* Custom content */
			$oTpl->addVal( 'block:page_content', $arV['page_content']);
			$oTpl->addVal( 'block:page_descr', $arV['page_descr']);
			/* Custom PHP-code */
			eval( $arV['page_php_1'] );
			$gw_this['arTitle'][] = $str_current_section = $arV['page_title'];
		}
	}
	/* Create the list of subpages */
	$arSqlc = $oDb->sqlRun($oSqlQ->getQ('get-subpages-list'), 'page');
	$arSqlc = gw_rearrange_custompages($arSqlc);
	$arSqlc = gw_create_tree_custompages($arSqlc);
	$ar_page_titles = array();
	$ar_pages_p_uplevel = array();
	$ar_pages_p_level = isset($arSqlc[$id_page_int]) ? $arSqlc[$id_page_int] : array();

	$arQ['subpages_cnt'] = 0;
	$arQ['subpages_tpl'] = '';
	$arQ['subpages_ul'] = '';
	/* The list pages, 1 level up. */
	$ar_parents = isset($arSqlc[$id_page_int]['p']) ? $arSqlc[$arSqlc[$id_page_int]['p']]['ch'] : array();
	for (; list($page_k, $ar_page_v) = each($ar_parents);)
	{
		if (($arSqlc[$page_k]['p'] == 0) && ($layout != 'title')) { continue; } 
		switch ($sys['pages_link_mode'])
		{
			case GW_PAGE_LINK_NAME:
				$str_page_id = urlencode($arSqlc[$page_k]['page_title']);
			break;
			case GW_PAGE_LINK_URI:
				$str_page_id = urlencode($arSqlc[$page_k]['page_uri']);
			break;
			default:
				$str_page_id = $arSqlc[$page_k]['id'];
			break;
		}
#		if ($arSqlc[$page_k]['p'] == 0) { continue; } 
		$ar_page_titles[] = $oHtml->a( $sys['page_index'] . 
			'?a='.GW_A_CUSTOMPAGE.'&id=' . $str_page_id, $arSqlc[$page_k]['page_title']
		);
	}
	if (!empty($ar_page_titles))
	{
		$arQ['subpages_ul_1'] = '<ul><li>' . implode('</li><li>', $ar_page_titles) . '</li></ul>';
	}
	/* */
	if (isset($arSqlc[$id_page_int]['ch']))
	{
		$arVarPage = array();
		$ar_page_titles = array();
		$subpages_cnt = 0;
		/* The list subpages, current level. */
		$ar_subpages = $arSqlc[$id_page_int]['ch'];
		for (; list($page_k, $ar_page_v) = each($ar_subpages);)
		{
			switch ($sys['pages_link_mode'])
			{
				case GW_PAGE_LINK_NAME:
					$str_page_id = urlencode($arSqlc[$page_k]['page_title']);
				break;
				case GW_PAGE_LINK_URI:
					$str_page_id = urlencode($arSqlc[$page_k]['page_uri']);
				break;
				default:
					$str_page_id = $arSqlc[$page_k]['id'];
				break;
			}
			$arVarPage[$page_k] = $arSqlc[$page_k];
			$arVarPage[$page_k]['url:page_title'] = $oHtml->a( $sys['page_index'] . 
				'?a='.GW_A_CUSTOMPAGE.'&id=' . $str_page_id, $arSqlc[$page_k]['page_title']
			);
			$ar_page_titles[] = $arVarPage[$page_k]['url:page_title'];
			$subpages_cnt++;
			if (isset($arVarPage[$page_k]['ch']))
			{
				unset($arVarPage[$page_k]['ch']);
			}
		}
		$arQ['subpages_ul'] = '<ul><li>' . implode('</li><li>', $ar_page_titles) . '</li></ul>';
		$oTplPage = new gwTemplate;
		$oTplPage->setHandle( 0 , 'templates/common/tpl_pages_list.html' );
		$oTplPage->setBlock(0, 'page_list', $arVarPage);
		$oTplPage->parse();
		$arQ['subpages_cnt'] = $subpages_cnt;
		$arQ['subpages_tpl'] = $oTplPage->output();
	}
	for (; list($k, $v) = each($arQ);)
	{
		$oTpl->addVal($k, $v);
	}
	$gw_this['id_page_int'] = $id_page_int;
	$gw_this['ar_pages'] = $arSqlc;
}

/**
 * Feedback form
 *
 * @param    array   $vars       posted variables
 * @param    int     $runtime    is this form posted first time [ 0 - no | 1 - yes ]
 * @param    array   $arBroken   the names of broken fields (after post)
 * @param    array   $arReq      the names of required fields (after post)
 * @return   string  complete HTML-code
 * @see textcodetoform()
 */
function scrFeedback($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global $oL, $sys, $tmp, $gw_this;
	$strForm = "";
	include_once( $sys['path_include'].'/class.forms.php' );

	$form = new gwForms();
	$form->action = $sys['server_dir'].'/index.php';
	$trClass = "t";
	$form->Set('submitok', $oL->m('3_send'));
	$form->Set('submitcancel', $oL->m('3_cancel'));
	$form->Set('formbgcolor', $GLOBALS['theme']['color_2']);
	$form->Set('formbordercolor', $GLOBALS['theme']['color_4']);
	$form->Set('formbordercolorL', $GLOBALS['theme']['color_1']);
	$form->Set('formwidth', 450);
	$form->Set('align_buttons', $sys['css_align_right']);
	$form->Set('charset', $sys['internal_encoding']);
	$form->arLtr = array('email', 'url');
	## ----------------------------------------------------
	##

	/* reverse array keys <-- values; */
	$arReq = array_flip($arReq);
	/* mark fields as "REQUIRED" and make error messages */
	while(is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = "";
		if (isset($arReq[$key])) { $arReqMsg[$key] = '&#160;<span style="color:#E30"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span style="color:#E30"><b>' . $oL->m('reason_9') . '</b></span><br/>'; }
	}
	##
	## ----------------------------------------------------
		$strForm = "";
		$strForm .= '<table class="gw2TableFieldset" cellspacing="0" cellpadding="0" border="0" width="100%">';
		$strForm .= '<tr><td style="width:25%"></td><td></td></tr>';
		$strForm .= '<tr>'.
					'<td class="td1">' .$oL->m('y_name') . ':' . $arReqMsg['name'] . '</td>'.
					'<td class="td2">' . $arBrokenMsg['name'] . $form->field("input","name", textcodetoform($vars['name'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="td1">' . $oL->m('y_email') . ':' . $arReqMsg['email'] . '</td>'.
					'<td class="td2">' . $arBrokenMsg['email'] . $form->field("input", "email", textcodetoform($vars['email']) ) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="td1">' . $oL->m('message') . ':' . $arReqMsg['message'] . '</td>'.
					'<td class="td2">' . $arBrokenMsg['message'] . $form->field("textarea", "arPost[message]", textcodetoform($vars['message']), 10) . '</td>'.
					'</tr>';
		$strForm .= '</table>';
		$strForm .= $form->field("hidden", GW_ACTION, GW_A_CUSTOMPAGE);
		$strForm .= $form->field("hidden", 'id', $gw_this['vars']['id']);
		$strForm .= $tmp['input_url_append'];

		return $form->Output($strForm);
}


/**
 * Top 10
 *
 * @param    int    $m [ R_DICT_AVERAGEHITS | R_DICT_EFFIC |
 *                       R_DICT_NEWEST | R_TERM_NEWEST |
 *                       R_DICT_UPDATED | R_POLL ] // todo ...
 * @return   string  complete HTML-code
 * @see htmlTagsA()
 * @global $oL
 */
function getTop10($m, $amount = 10, $isItemOnly = 0)
{
	global $oL, $sys, $gw_this;
	global $oHtml, $oDb, $oSqlQ, $arDictParam;
	global $oFunc, $oSess;
	$str = '';
	$cnt = 0;
	/* Current date in UNIX timestamp */
	$curDateMk  = gmmktime(date("H,i,s,Y,m,d"));
	$arThText = $arThWidth = array();
	$strData = $strTopicName = '';
	$m = strtolower(str_replace('R_', '', $m));
	$filename = $sys['path_include'] . '/top.' . $m . '.inc.' . $sys['phpEx'];
	if (file_exists($filename))
	{
		include_once( $filename );
	}
	else
	{
		print("Can't find " . $filename);
	}

	$intRows = sizeof($arThWidth);

	if (!empty($arThText) || !empty($arThWidth))
	{
		$str .= '<table style="background:'.$GLOBALS['theme']['color_1'].'" width="100%" border="0" cellpadding="3" cellspacing="1">';
		$str .= '<col align="'.$sys['css_align_right'].'" width="1%"/>';
		for (reset($arThWidth); list ($kT, $vT)= each($arThWidth);)
		{
			$str .= '<col width="'.$vT.'" align="'.$arThAlign[$kT].'"/>';
		}
		$str .= '<thead>';
		if ($strTopicName != '')
		{
			$str .= '<tr>'
				 . '<td style="background:'.$GLOBALS['theme']['color_4'].';text-align:'.$sys['css_align_left'].'" colspan="' . ($intRows + 1) . '" class="r">'
				 . '&#160;' . $strTopicName
				 . '</td>'
				 . '</tr>';
		}
		if (!empty($arThText))
		{
			$str .= '<tr class="a" style="color:'.$GLOBALS['theme']['color_white'].';background:'.$GLOBALS['theme']['color_6'].'">';
			$str .= '<th class="gw" style="text-align:center">N</th>';
			reset($arThText);
			for (; list ($kT, $vT)= each($arThText);)
			{
				$str .= '<th class="gw">' . $vT . '</th>';
			}
			$str .= '</tr>';
		}
		$str .= '</thead>';
		$str .= '<tbody>';
		$str .= $strData;
		$str .= '</tbody></table>';
	}
	return $str;
}

/* */
function getValidDictID()
{
	global $oSqlQ, $oDb;
	$arSql = $oDb->sqlRun($oSqlQ->getQ('get-dict-valid'), 'st');
	return $arSql;
}

/* */
function getStat()
{
	global $oSqlQ, $oDb;
	$arSql = $oDb->sqlRun($oSqlQ->getQ('get-terms-total'), 'st');
	$arSql = isset($arSql[0]) ? $arSql[0] : array('num' => 0, 'sum' => 0);
	$arSql['date'] = gmmktime();
	return $arSql;
}

/* */
function getSettings()
{
	global $oSqlQ, $oDb, $sys;
	$strA = array();
	$arSql = $oDb->sqlRun($oSqlQ->getQ('get-settings'), 'st');
	for (; list($k, $v) = each($arSql);)
	{
		$strA[$v['settings_key']] = $v['settings_val'];
	}
	/* No system settings found, run install */
	if (empty($strA))
	{
		gwtk_header($sys['server_proto'].$sys['server_host'].$sys['server_dir'].'/gw_install/install.php?step=novar');
	}
	return $strA;
}



/**
 * Builds HTML-code for page navigation, like [ Pages: 1 .. 5 6 7 .. 11 ]
 *
 * @return   string  simple HTML-code, ready to put inside a table or else.
 */
function getNavToolbar($intSumPages, $page = 1, $url)
{
	global $sys, $oHtml;
	$strA = array();
	if ($intSumPages == 1)
	{
		return "&#160;";
	}
	$sys['split_pagenums'] = isset($sys['split_pagenums']) ? $sys['split_pagenums'] : ' | ';

	$isShowJump = 0;
	$intVisible = 7;
	$intJump = 10;
#   [prev 10] [prev] 1 2 3 .. 11 [next] [next 10]

	$strNext = $GLOBALS['oL']->m('1_nextpage').'&#160;&gt;&gt;';
	$strPrev = '&lt;&lt;&#160;'.$GLOBALS['oL']->m('1_prevpage');
	$strNextN = $GLOBALS['oL']->m('next_n %d');
	$strPrevN = $GLOBALS['oL']->m('prev_n %d');
	// 1 <<
	// 2 <
	// 3 min
	// 4 ..
	// 5 n
	// 6 ..
	// 7 max
	// 8 >
	// 9 >>
	// min & max values
	$max = $page + $intJump;
	if ($max > $intSumPages) { $max = $intSumPages; }
	$min = $page - $intJump;
	if ($min < 1) { $min = 1; }
	// prev/next processing
	if ( ($page - 1) != 0 ) { $linkPrev = $oHtml->a( append_url($url . ($page - 1)), $strPrev); }
	else { $linkPrev = ''; }
	if ( ($page + 1) <= $intSumPages )
	{
		$linkNext = $oHtml->a( append_url($url . ($page + 1)), $strNext);
	}
	else { $linkNext = ''; }
	//
	if ($isShowJump)
	{
		$strA[] = (($page == 1) || ($page <= $intJump)) ? '' : $oHtml->a( append_url($url . $min), sprintf($strPrevN, $intJump));
	}
	$strA[] = $linkPrev;
	$strA[] = ($page == 1) ? '<b style="color:'.$GLOBALS['theme']['color_5'].';font:bold 110%">1</b>' : $oHtml->a( append_url($url . 1), '<b>1</b>');
	//
	$p1 = ($page - intval($intVisible / 2));
	$p2 = ($p1 + $intVisible);
	if ($p2 > $intSumPages)
	{
		$p2 = ($intSumPages - 1);
		$p1 = ($p2 - $intVisible);
	}
	// $intVisible..
	if((($p2 - $intVisible) < 0) || ($p1 <= 1))
	{
		$p1 = 2;
		$p2 = $p1 + $intVisible;
	}
	if (($p1 - 1) > 1 ) { $strA[] = '..'; }

	if ( (($intSumPages - $page) * 2) < $intVisible )
	{
		$p2++;
	}
	if ($p2 > $intSumPages) { $p2 = $intSumPages; }
	// visible part
	for ($i = $p1; $i < $p2; $i++)
	{
		$strA[] = ($i == $page) ? '<b style="color:'.$GLOBALS['theme']['color_5'].';font:bold 110%">'.$i.'</b>' : $oHtml->a( append_url($url . $i), '<b>'.$i.'</b>');
	}
	if (($intSumPages - $p2) >= 1) { $strA[] = '..'; }
	$strA[] = ($page == $intSumPages) ? '<b style="color:'.$GLOBALS['theme']['color_5'].';font:bold 110%">'.$intSumPages.'</b>' : $oHtml->a( append_url($url . $intSumPages), '<b>'.$intSumPages.'</b>');

	$strA[] = $linkNext;

	if ($isShowJump)
	{
		$strA[] = (($page == $intSumPages) || (($page + $intJump) > $intSumPages)) ? "" : $oHtml->a( append_url($url . $max), sprintf($strPrevN, $intJump));
	}
	$str = implode($sys['split_pagenums'], $strA);
	return $str;
}



/**
 * Depreciated function
 *
 * Builds query "LIMIT n,n" for database
 *
 * @param    int   $total    total number of items
 * @param    int   $page     current page number
 * @param    int   $perpage  items per page
 * @return   string  part of database query
 */
function getSqlLimit($total, $page, $perpage)
{
	$numpages = ceil($total / $perpage);
	for ($i=1; $i <= $numpages; $i++)
	{
		$pos = ($i * $perpage);
		if ($i == ($page - 1))
		{
			return " LIMIT $pos, $perpage";
		}
	}
	return " LIMIT 0, $perpage";
}


/**
 * Get all dictionary parameters, such as:
 * title, description, number of terms, sql-table name etc.
 *
 * @param    int     dictionary ID
 * @return   array   dictionary name, description, total terms etc.
 */
function getDictParam($dict_id)
{
	global $gw_this;
	$ar = array();
	for (reset($gw_this['ar_dict_list']); list($kDict, $vDict) = each($gw_this['ar_dict_list']);)
	{
		if ($vDict['id'] == $dict_id)
		{
			$vDict['dict_settings'] = unserialize($vDict['dict_settings']);
			if (is_array($vDict['dict_settings']))
			{
				$vDict = array_merge($vDict, $vDict['dict_settings']);
			}
			unset($vDict['dict_settings']);
			$ar = $vDict;
			break;
		}
	}
	return $ar;
} // end of getDictName


/**
 * Get a random term from a random dictionary
 * @param   int     dictionary ID
 * @return  array   array with term and dictionary
 */
function getTermRandom()
{
	global $gw_this, $oDb, $oSqlQ;
	$arSqlD = $gw_this['ar_dict_list'][rand(0, sizeof($gw_this['ar_dict_list'])-1)];
	$sql = $oSqlQ->getQ('get-term-rand', $arSqlD['tablename']);
	$arSql = $oDb->sqlExec($sql, '', 0);
	$arSql = isset($arSql[0]) ? $arSql[0] : array();
	$arSql = array_merge($arSqlD, $arSql);
	return $arSql;
}


/**
 * Get term parameters:
 * term id, term, definition
 *
 * @param    int     term ID
 * @return   array   term id, defn id, name, definition(s), synonym(s)
 */
function getTermParam($tid = '', $name = '')
{
	global $gw_this, $oL, $arDictParam, $oDb, $oSqlQ, $oSess;

	$arFound = $arFoundInit = array('is_active' => '0', 'term' => '', 'term_1' => ' ', 'term_2' => ' ', 'defn' => '', 'tid' => '');
	if ($tid != '')
	{
		/* search by id (faster) */
		if (GW_IS_BROWSE_ADMIN)
		{
			$sql = $oSqlQ->getQ('get-term-by-id-adm', $arDictParam['tablename'], $tid);
		}
		else
		{
			$sql = $oSqlQ->getQ('get-term-by-id', $arDictParam['tablename'], $tid);
		}
		$arFound = $oDb->sqlExec($sql, sprintf("%05d", $gw_this['vars'][GW_ID_DICT]), 0);
		$arFound = isset($arFound[0]) ? $arFound[0] : array();
	}
	elseif ($name != '')
	{
		/* remove specials */
		$arKeywordsT = text2keywords( text_normalize( gw_stripslashes($name) ), 1);
		$word_srch_sql = "'" . implode("', '", $arKeywordsT) . "'";
		if (GW_IS_BROWSE_ADMIN)
		{
			$sql = $oSqlQ->getQ('get-term-by-name-adm', TBL_WORDLIST, TBL_WORDMAP, $arDictParam['tablename'], $gw_this['vars'][GW_ID_DICT], $word_srch_sql);
		}
		else
		{
			$sql = $oSqlQ->getQ('get-term-by-name', TBL_WORDLIST, TBL_WORDMAP, $arDictParam['tablename'], $gw_this['vars'][GW_ID_DICT], $word_srch_sql);
		}
		$arSql = $oDb->sqlExec($sql, sprintf("%05d", $gw_this['vars'][GW_ID_DICT]), 0);
		for (reset($arSql); list($arK, $arV) = each($arSql);) // compare founded values (Q) with imported (T)
		{
			$isTermExist = 0;
			// first method, 08 july 2000
			if (!$isTermExist && ($arV['term'] == $name))
			{
				$isTermExist = 1;
				$arFound = $arV;
#				prn_r( $arV['term'].' = '.$name."\narsize=".sizeof($arSql) );
				break; // breaks at first loop, usually.
			}
			// do NOT remove specials
			$arKeywordsQ = text2keywords( text_normalize($arV['term']), 1); // 1 - is the minimum length
			$div1 = sizeof(gw_array_exclude($arKeywordsT, $arKeywordsQ));
			$div2 = sizeof(gw_array_exclude($arKeywordsQ, $arKeywordsT));
			$isTermNotMatched = ($div1 + $div2);
			// if the sum of excluded arrays is 0, this term already exists
			if (!$isTermNotMatched) // in english, double negative means positive. yeah.
			{
				$isTermExist = 1;
			}
			if ($isTermExist)
			{
				$arFound = $arV;
			}
		} // end of for each founded terms
	}
	if (empty($arFound))
	{
		$arFound = $arFoundInit;
	}
	return $arFound;
}





## --------------------------------------------------------
## Toolbar functions A-Z, 00-ZZ

/**
 * === Toolbar functions.
 * 1 of 2 functions to create alphabetic index.
 * Get first letters from all terms in dictionary
 *
 * @param    int     $id_dict dictionary ID
 * @param    int     $w      second symbol (optional) // not in use since 1.3
 * @return   array   initial letters 00-ZZ
 */
function getLettersArray($id_dict, $w = '')
{
	global $oDb, $oSqlQ, $oFunc;
	global $arDictParam;
	$arSql = $oDb->sqlRun($oSqlQ->getQ('get-az', $arDictParam['tablename']), sprintf("%05d", $id_dict));
	/* One array for both indexes (single and double) */
	$arL = array();
	for (; list($k, $v) = each($arSql);)
	{
		/* Must be mb_substr($v['L1'], 1, 3), but parameter (0, 3)
		allows to override Unicode sorting order for diacritics.
		Example (urlencoded): S%CC%8C overrides %C5%A0 */
		$arL[$oFunc->mb_substr($v['L1'], 0, 3)][$oFunc->mb_substr($v['L2'], 0, 6)] = $v['L2'];
	}
	/* Remove single character from double's index */
	for (; list($k, $v) = each($arL);)
	{
		if ( isset($v[$k]) ) /* is there any single character? */
		{
			unset($arL[$v[$k]][$v[$k]]);
		}
	}
	/* 1.7.1: Custom sorting order
	$arLnew = array();
	$arSql = $oDb->sqlRun($oSqlQ->getQ('get-tb-by-char', 'gw_toolbar', $arDictParam['lang'], implode('","', array_keys($arL))));
	for (; list($k, $v) = each($arSql);)
	{
		$arLnew[$v['L1']] = $arL[$v['L1']];
		unset($arL[$v['L1']]);
	}
	$arL = array_merge($arLnew, $arL);
	*/
	return $arL;
}

/**
 * === Toolbar functions.
 * 2 of 2 functions to create alphabetic index.
 * Get HTML-code for A-Z letters. Universal function.
 *
 * @param    array   $ar  array[49][49] = 11;
 * @param    int     $id_dict dictionary ID
 * @param    string  $w1  single letter
 * @param    int     $w2  double letter
 * @return   string  HTML-code
 * @return   string  HTML-code
 */
function getLetterHtml($ar, $id_dict, $w1 = '', $w2 = '')
{
	global $oFunc, $oHtml, $sys;

	/* Basic Multilingual Plane: */
	/* http://www.unicode.org/roadmaps/bmp/ */
	/* Break alphabetic toolbar per every set of characters */
	$arUnicodeMap = array(
		array('20', 'Basic Latin Digits'),
		array('41', 'Basic Latin'),
		array('c280', 'Latin Extended'),
		array('c990', 'IPA Extensions'),
		array('cab0', 'Spacing Modifiers'),
		array('cc80', 'Combining Diacritics'),
		array('cdb0', 'Greek'),
		array('d080', 'Cyrillic, Cyrillic Supplement'),
		array('d4b0', 'Armenian')
	);
	$int_cnt = 0;
	$arS = array();
	$ar_tb_last = end($arUnicodeMap);
	$int_tb_last = hexdec($ar_tb_last[0]);
	/* links to letters */
	$arTmp['href'][GW_ACTION] = GW_A_LIST;
	$arTmp['href'][GW_TARGET] = GW_T_DICT;
	$arTmp['href'][GW_ID_DICT] = $id_dict;
	
#	$arTmp['href'][$this->c('A_PAGENUM')] = 1;
#	$arTmp['href'][$this->c('A_LANGUAGE')] = $this->gv['vars'][$this->c('A_LANGUAGE')];
	/* for each letter */
	for (reset($ar); list($k1, $v1) = each($ar);)
	{
		$int_cnt++;
		$cnt1_str = (isset($sys['is_print_toolbar_num']) && $sys['is_print_toolbar_num'] == 1) ? $int_cnt : '';
		/* 0-Z */
		if (($w1 != '') && ($w2 == ''))
		{
			$oHtml->setTag('a', 'title', $cnt1_str);
			$arTmp['href']['w1'] = urlencode($k1);
			/* current letter */
			$int_utf2hex = ($oFunc->text_utf2hex($k1, 0));
			for (reset($arUnicodeMap); list($k2, $v2) = each($arUnicodeMap);)
			{
				/* next letter */
				if (!isset($arUnicodeMap[$k2+1]))
				{
					$int_utf2hex_tb_to = $int_tb_last;
				}
				else
				{
					$int_utf2hex_tb_to = ($arUnicodeMap[$k2+1][0]);
				}
				/* start letter */
				$int_utf2hex_tb_from = ($v2[0]);
				/* start letter > current letter < next letter */
				if (($int_utf2hex >= $int_utf2hex_tb_from) &&
					($int_utf2hex < $int_utf2hex_tb_to))
				{
					$oHtml->setTag('a', 'class', '');
					if (strval($k1) == strval(trim($w1)))
					{
						$oHtml->setTag('a', 'class', 'on');
					}
					$arS[$k2][] = $oHtml->a( $sys['page_index'].'?'.
										$oHtml->paramValue($arTmp['href'], '&', ''),
										htmlspecialchars($k1));
				}
			}
			$oHtml->setTag('a', 'title', '');
		}
		else
		{
			/* 00-ZZ */
			if (strval($k1) == strval(trim($w1)))
			{
				for (reset($v1); list($k2, $v2) = each($v1);)
				{
					$oHtml->setTag('a', 'class', '');
					if (strval($k2) == strval(trim($w2)))
					{
						$oHtml->setTag('a', 'class', 'on');
					}
					
					$arTmp['href']['w1'] = urlencode($k1);
					$arTmp['href']['w2'] = urlencode($v2);
					$arS['0z'][] = $oHtml->a($sys['page_index'].'?'.
										$oHtml->paramValue($arTmp['href'], '&', ''),
										htmlspecialchars($v2));
				}
			}
		}
	}
	unset($ar);
	$oHtml->setTag('a', 'title', '');
	$oHtml->setTag('a', 'class', '');
	/* Build html-code */
	$str = '';
	for (reset($arS); list($k1, $v1) = each($arS);)
	{
		if ( is_array($v1) )
		{
			$str .= implode(' ', $v1);
			$str .= '<br />';
		}
	}
	return $str;
}
## Toolbar functions A-Z, 00-ZZ
## --------------------------------------------------------




/**
 * Parses XML-data and converts it into structured array.
 *
 * @param   string  $str        XML-code, (from database)
 * @return  array   Fields content structure
 */
function gw_Xml2Array($str)
{
	global $arFields;
	//
	$xmlRoot = array();
	$xmlTags = array();
	$xmlAttr = array("link", "lang"); // possible attributes
	// Get defined tags
	for (reset($arFields); list($fk, $fv) = each($arFields);)
	{
		$fieldname = 'is_'.$fv[0];
		if (isset($fv[4]) && $fv[4]) // root
		{
			$xmlRoot[] = $fv[0];
		}
		else // not root elements
		{
			$xmlTags[] = $fv[0];
		}
	}
	// go for each root element
	for (reset($xmlRoot); list($kp, $vp) = each($xmlRoot);)
	{
		preg_match_all("/<$vp>(.+?)<\/$vp>/s", $str, $strDefnA); // root tags without attributes
		if (isset($strDefnA[0]) && isset($strDefnA[0][0]) && !empty($strDefnA[0][0]))
		{
			$intDefnS = sizeof($strDefnA[0]);
			for ($intDefnC = 0; $intDefnC < $intDefnS; $intDefnC++) // foreach <defn>
			{
				// value, 10 march 2003
				$parsedAr[$vp][$intDefnC]['value'] = $strDefnA[1][$intDefnC];
				//
				for (reset($xmlTags); list($kt, $vt) = each($xmlTags);)
				{
					for (reset($xmlAttr); list($ka, $va) = each($xmlAttr);)
					{
						preg_match_all("/<$vt( $va=\"(.*?)\")*\>(.*?)\<\/$vt\>/s", $strDefnA[1][$intDefnC], $strTmpA);
						#prn_r($strTmpA);
						if (isset($strTmpA[0]) && !empty($strTmpA[0]))
						{
							$intTmpS = sizeof($strTmpA[0]);
							for ($intTmpC = 0; $intTmpC < $intTmpS; $intTmpC++) // foreach <trns>
							{
								$parsedAr[$vt][$intDefnC][$intTmpC]['value'] = $strTmpA[3][$intTmpC];
								$parsedAr[$vp][$intDefnC]['value'] = trim(str_replace($strTmpA[0][$intTmpC], '', $parsedAr[$vp][$intDefnC]['value']));
								// per-tag
								if ($vt == 'syn') // collect data for syn
								{
									// 31 may 2002 - new attribute [text]: <syn link="" text="">
									$strSynText = '';
									if (preg_match("/\" text=\"/", $strTmpA[2][$intTmpC]))
									{
										$strSynText = preg_replace("'(.*)(\" text=\")(.*)'", "\\3", $strTmpA[2][$intTmpC]);
									}
									$strTmpA[2][$intTmpC] = preg_replace("'\" text=\"(.*)'", '', $strTmpA[2][$intTmpC]);
									$parsedAr[$vt][$intDefnC][$intTmpC]['attributes']['link'] = $strTmpA[2][$intTmpC];
									if ( ($strTmpA[2][$intTmpC] != '') && ($strTmpA[2][$intTmpC] != '--') )
									{
										$parsedAr[$vt][$intDefnC][$intTmpC]['attributes']['is_link'] = 1;
									}
									if ($strSynText != '') // text=""
									{
										$parsedAr[$vt][$intDefnC][$intTmpC]['attributes']['text'] = ' [['.$strSynText.']]';
									}
									$strSynText = '';
								}
								elseif ($vt == 'see') // collect data for see
								{
									#prn_r( $strTmpA , __LINE__);
									// 31 may 2002 - new attribute [text]: <see link="" text="">
									$strSeeText = '';
									if (preg_match("/\" text=\"/", $strTmpA[1][$intTmpC]))
									{
										$strSeeText = preg_replace("'(.*)(\" text=\")(.*)'", "\\3", $strTmpA[2][$intTmpC]);
									}
									$strTmpA[2][$intTmpC] = preg_replace("'\" text=\"(.*)'", '', $strTmpA[2][$intTmpC]);
									$parsedAr[$vt][$intDefnC][$intTmpC]['attributes']['link'] = $strTmpA[2][$intTmpC];
									if ( ($strTmpA[2][$intTmpC] != '') && ($strTmpA[2][$intTmpC] != '--') )
									{
										$parsedAr[$vt][$intDefnC][$intTmpC]['attributes']['is_link'] = 1;
									}
									if ($strSeeText != '') // text=""
									{
										$parsedAr[$vt][$intDefnC][$intTmpC]['attributes']['text'] = ' [['.$strSeeText.']]';
									}
									$strSeeText = '';
								}
								elseif ($vt == 'abbr') // collect data for abbr
								{
									$parsedAr[$vt][$intDefnC][$intTmpC]['attributes']['lang'] = $strTmpA[2][$intTmpC];
								}
								elseif ($vt == 'trns') // collect data for trns
								{
									$parsedAr[$vt][$intDefnC][$intTmpC]['attributes']['lang'] = $strTmpA[2][$intTmpC];
								}
								elseif ($vt == 'src') // collect data for src
								{
									if ( ($strTmpA[2][$intTmpC] != '') && ($strTmpA[2][$intTmpC] != '--') )
									{
										$parsedAr['src'][$intDefnC][] = $strTmpA[1][$intTmpC];
									}
								}
							}
						}
					} // xmlAttr
				} // xmlTags
			} // foreach <defn>
		}
	} // end of $xmlPrnt
	if (!isset($parsedAr)){ $parsedAr['defn'][0] = ""; }
	return $parsedAr;
} // end of ParseFieldDbToInput()

/* end of file */
?>