<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: t.user.inc.php,v 1.19 2005/06/09 06:32:04 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Actions for a user. New registration, Profile.
 */
// --------------------------------------------------------
/**
 * Authors list
 */
function getFormUsers()
{
	global ${GW_ACTION}, $oL, ${GW_SID}, $sys;
	global $oDb, $oHtml, $oSqlQ;
	$strForm = '';
	$trClass = 't';
	$arSql = $oDb->sqlExec($oSqlQ->getQ('get-users-edit'));
	// common part
	$strForm .= '<table cellspacing="1" cellpadding="3" border="0" width="100%">';
	$strForm .= '<col width="1%"/><col width="4%"/><col width="66%"/><col width="28%"/><col width="1%"/>';
	//
	$cnt = 0;
		$strForm .= '<tr class="f" style="color:'.$GLOBALS['theme']['color_1'].';background:'.$GLOBALS['theme']['color_6'].'">';
		$strForm .= '<th class="gw">N</th>';
		$strForm .= '<th class="gw">'.$oL->m('action').'</th>';
		$strForm .= '<th class="gw">'.$oL->m('contact_name').'</th>';
		$strForm .= '<th class="gw">'.$oL->m('contact_email').'</th>';
		$strForm .= '<th class="gw">'.$oL->m('status').'</th>';
		$strForm .= '</tr>';
	for (; list($k, $arV) = each($arSql);)
	{
		$cnt % 2 ? ($bgcolor = $GLOBALS['theme']['color_2']) : ($bgcolor = $GLOBALS['theme']['color_1']);
		$cnt++;
		$href = $sys['page_admin'] . '?' . GW_TARGET . '=' . USER . '&' .  GW_ACTION . '=' . PROFILE . '&tid='. $arV['id_user'];
		$strForm .= '<tr class="t" style="background:'.$bgcolor.'">';
		$strForm .= '<td>'. $cnt . '.</td>';
		$strForm .= '<td>'. $oHtml->a($href, $oL->m('3_edit')) . '</td>'.
					'<td>'. $oHtml->a($href, $arV['user_name']) . '</td>'.
					'<td><a href="mailto:' . $arV['user_email'] . '">'. $arV['user_email'] . '</a></td>'.
					'<td>'. ($arV['is_active'] ? '<span class="green">'.$oL->m('is_1').'</span>' : '') . '</td>';
		$strForm .= '</tr>';
	}
	$strForm .= '</table>';
	return $strForm;
}
/**
 * HTML-form for profile
 *
 * @param    array   $vars       posted variables
 * @param    int     $runtime    is this form posted first time [ 0 - no | 1 - yes ] // todo: bolean
 * @param    array   $arBroken   the names of broken fields (after post)
 * @param    array   $arReq      the names of required fields (after post)
 * @return   string  complete HTML-code
 * @see textcodetoform(), getFormHeight()
 */
function getFormProfile($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global $oSess, ${GW_ACTION}, $oL, ${GW_SID}, $tid, $sys, $gw_this, $oHtml;
	$strForm = '';
	$trClass = 't';
	$v_class_1 = 'td1';
	$v_class_2 = 'td2';
	$v_td1_width = '25%';
	$trDisabled = 'disabled';

	$form = new gwForms();
	$form->Set('action', $sys['page_admin']);
	$form->Set('submitok', $oL->m('3_save'));
	$form->Set('submitcancel', $oL->m('3_cancel'));
	$form->Set('formbgcolor', $GLOBALS['theme']['color_2']);
	$form->Set('formbordercolor', $GLOBALS['theme']['color_4']);
	$form->Set('formbordercolorL', $GLOBALS['theme']['color_1']);
	$form->Set('align_buttons', $sys['css_align_right']);
	$form->Set('charset', $sys['internal_encoding']);
	$form->arLtr = array('arPost[user_email]');
	## ----------------------------------------------------
	##
	// check vars
	// reverse array keys <-- values;
	$arReq = array_flip($arReq);
	// mark fields as "REQUIRED" and make error messages
	while (is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = "";
		if (isset($arReq[$key])) { $arReqMsg[$key] = ' <span class="red"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span class="red"><b>' . $oL->m('reason_9') .'</b></span>'; }
	} // end of while
	##
	## ----------------------------------------------------
	/* All statements */
	$ar_state = array(
	  'user_add' => 0,
	  'user_edit' => 0,
	  'user_edit_other' => 0
	);
	/* Change profile */
	if ((${GW_ACTION} == PROFILE) || (${GW_ACTION} == UPDATE))
	{
		/* An owner changes his profile (could be administrator) */
		if ($vars['perm_level'] == $oSess->user_get('perm_level') )
		{
			$ar_state['user_edit'] = 1;
		}
		/* Someone changes profile of another user */
		/* Guest cannot edit Admin */
		if ($gw_this['vars']['tid']
			&& $oSess->is('user_edit_other')
			&& ($oSess->user_get('perm_level') >= $vars['perm_level'])
			)
		{
			$ar_state['user_edit_other'] = 1;
		}
	}
	elseif ((${GW_ACTION} == REG) && $oSess->is('user_add'))
	{
		/* New user registration */
		$ar_state['user_add'] = 1;
	}
	$form->setTag('select', 'class',  'input50');
	/** Account settings **/
	if ($ar_state['user_edit'] || $ar_state['user_edit_other'])
	{
		$strForm .= getFormTitleNav($oL->m('user_reginfo'));
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

		if ($oSess->is('user_edit_other'))
		{
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('login') . ':' . $arReqMsg['username'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $arBrokenMsg['username'] . $form->field("input","arPost[username]", textcodetoform($vars['username'])) . '</td>'.
						'</tr>';
		}
		else
		{
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('login') . ':</td>'.
						'<td class="' . $trDisabled . '">' . $vars['username'] . '</td>'.
						'</tr>';
		}
		/* Only priveleged user can change password */
		if ($vars['perm_level'] > 1)
		{
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('pass_new') . ': </td>'.
						'<td class="'.$v_class_2.'">' . $arBrokenMsg['pass_new'] . $form->field("pass", "arPost[pass_new]", textcodetoform($vars['pass_new']), 16) . '</td>'.
						'</tr>';
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('pass_confirm') . ': </td>'.
						'<td class="'.$v_class_2.'">' . $arBrokenMsg['pass_confirm'] . $form->field("pass", "arPost[pass_confirm]", textcodetoform($vars['pass_confirm']), 16) . '</td>'.
						'</tr>';
		}
		else
		{
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('pass_new') . ': </td>'.
						'<td class="' . $trDisabled . '">&#160;</td>'.
						'</tr>';
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('pass_confirm') . ': </td>'.
						'<td class="' . $trDisabled . '">&#160;</td>'.
						'</tr>';
		}
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('date_register') . ':</td>'.
					'<td class="' . $trDisabled . '">' . date_extract_int($vars['date_reg'], "%d %FL %Y %H:%i:%s") . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('date_logged') . ':</td>'.
					'<td class="' . $trDisabled . '">' . ((($vars['date_login'] / 1) != 0) ? date_extract_int($vars['date_login'], "%d %FL %Y %H:%i:%s") : '&#160;') . '</td>'.
					'</tr>';

			/* Do not allow to remove anonymous and admin users */
			if ($ar_state['user_edit_other'])
			{
				$strForm .= '<tr>';
				$strForm .= '<td class="'.$v_class_1.'">' . $form->field("checkbox", "arPost[is_active]", $vars['is_active']) . '</td>';
				$strForm .= '<td class="'.$v_class_2.'"><label for="arPost_is_active_">' . $oL->m('allow_user') . '</label>'.
							' [ <a href="'.
							append_url($sys['page_admin']. '?'.GW_ACTION.'='.GW_A_REMOVE.'&'.GW_TARGET.'='.USER.'&tid='.$tid).
							'">'. $oL->m('3_remove') .'</a> ]'.
							'</td>';
				$strForm .= '</tr>';
			}

		$strForm .= '</tbody></table>';
	}
	if ($ar_state['user_add'])
	{
		$strForm .= getFormTitleNav($oL->m('user_reginfo'));
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('login') . ':' . $arReqMsg['username'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['username'] . $form->field("input", "arPost[username]", textcodetoform($vars['username'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('pass_new') . ':' . $arReqMsg['pass_new'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['pass_new'] . $form->field("input", "arPost[pass_new]", textcodetoform($vars['pass_new']), 16) . '</td>'.
					'</tr>';
		$strForm .= '</tbody></table>';
	}
	/** Profile information **/
	if ($ar_state['user_edit'] || $ar_state['user_edit_other'])
	{
		$strForm .= getFormTitleNav($oL->m('user_profile'));
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
		/* Set small difference between "Your name" and "Contact name" */
		if ($ar_state['user_edit_other'])
		{
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('contact_name') . ':' . $arReqMsg['user_name'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $arBrokenMsg['user_name'] . $form->field("input", "arPost[user_name]", textcodetoform($vars['user_name'])) . '</td>'.
						'</tr>';
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('contact_email') . ':' . $arReqMsg['user_email'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $arBrokenMsg['user_email'] . $form->field("input", "arPost[user_email]", textcodetoform($vars['user_email'])) . '</td>'.
						'</tr>';
		}
		else
		{
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('y_name') . ':' . $arReqMsg['user_name'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $arBrokenMsg['user_name'] . $form->field("input","arPost[user_name]", textcodetoform($vars['user_name'])) . '</td>'.
						'</tr>';
			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'">' . $oL->m('y_email') . ':' . $arReqMsg['user_email'] . '</td>'.
						'<td class="'.$v_class_2.'">' . $arBrokenMsg['user_email'] . $form->field("input", "arPost[user_email]", textcodetoform($vars['user_email'])) . '</td>'.
						'</tr>';
		}
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('user_location') . ':' . $arReqMsg['location'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['location'] . $form->field("input", "arPost[location]", textcodetoform($vars['location'])) . '</td>'.
					'</tr>';

		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('themename') . ':' .  $arReqMsg['visualtheme'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $form->field('select', 'arPost[visualtheme]', $vars['visualtheme'], 0, $gw_this['ar_themes']) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('default_lang') . ':' .  $arReqMsg["locale_name"] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['locale_name'] . $form->field('select', 'arPost[locale_name]', $vars['locale_name'], 0, $oL->getLanguages()) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field('checkbox', 'arPost[is_htmled]', $vars['is_htmled']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="'.$form->text_field2id('arPost[is_htmled]').'">' . $oL->m('allow_htmleditor') . '</label></td>'.
					'</tr>';

		$strForm .= '</tbody></table>';
	}
	if ($ar_state['user_add'])
	{
		$strForm .= getFormTitleNav($oL->m('user_profile'));
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('contact_name') . ':' . $arReqMsg['user_name'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['user_name'] . $form->field("input","arPost[user_name]", textcodetoform($vars['user_name'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $oL->m('contact_email') . ':' . $arReqMsg['user_email'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['user_email'] . $form->field("input", "arPost[user_email]", textcodetoform($vars['user_email'])) . '</td>'.
					'</tr>';
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . $form->field("checkbox", "arPost[is_notice]", $vars['is_notice']) . '</td>'.
					'<td class="'.$v_class_2.'"><label for="arPost_is_notice_">' . $oL->m('user_notice') . '</label></td>'.
					'</tr>';

		$strForm .= '</tbody></table>';
	}
	/** Permissions **/
	
	if (($oSess->user_get('perm_level') > $vars['perm_level'])
		&& ($ar_state['user_add'] || $ar_state['user_edit_other'])
		)
	{
		$strForm .= getFormTitleNav($oL->m('1037'));
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'"></td>'.
					'<td class="'.$v_class_2.'">';
			$strForm .= '<table cellspacing="0" cellpadding="1" border="0" width="100%">';
			$strForm .= '<col width="1%"/><col width="99%"/>';
			$strForm .= '<tr>';
			$strForm .= '<td>' . $form->field("checkbox", "arPost[is_topic_add]", $vars['is_topic_add']) . '</td>';
			$strForm .= '<td><label for="arPost_is_topic_add_">' . $oL->m('2_page_3') . '</label></td>';
			$strForm .= '</tr>';
			$strForm .= '<tr>';
			$strForm .= '<td>' . $form->field("checkbox", "arPost[is_topic_edit_other]", $vars['is_topic_edit_other']) . '</td>';
			$strForm .= '<td><label for="arPost_is_topic_edit_other_">' . $oL->m('2_page_4') . '</label></td>';
			$strForm .= '</tr>';
			$strForm .= '<tr>';
			$strForm .= '<td>' . $form->field("checkbox", "arPost[is_dict_add]", $vars['is_dict_add']) . '</td>';
			$strForm .= '<td><label for="arPost_is_dict_add_">' . $oL->m('2_page_7') . '</label></td>';
			$strForm .= '</tr>';
			$strForm .= '<tr>';
			$strForm .= '<td>' . $form->field("checkbox", "arPost[is_dict_edit]", $vars['is_dict_edit']) . '</td>';
			$strForm .= '<td><label for="arPost_is_dict_edit_">' . $oL->m('2_page_8') . '</label></td>';
			$strForm .= '</tr>';
			$strForm .= '<tr>';
			$strForm .= '<td>' . $form->field("checkbox", "arPost[is_term_add]", $vars['is_term_add']) . '</td>';
			$strForm .= '<td><label for="arPost_is_term_add_">' . $oL->m('2_page_14') . '</label></td>';
			$strForm .= '</tr>';
			$strForm .= '<tr>';
			$strForm .= '<td>' . $form->field("checkbox", "arPost[is_term_edit]", $vars['is_term_edit']) . '</td>';
			$strForm .= '<td><label for="arPost_is_term_edit_">' . $oL->m('2_page_15') . '</label></td>';
			$strForm .= '</tr>';
			$strForm .= '</table>';
		$strForm .= '</td></tr>';

		$strForm .= '</tbody></table>';
	}
	elseif ($ar_state['user_edit'])
	{
		/* Display permissions information */
		$strForm .= getFormTitleNav($oL->m('1037'));
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'"></td>'.
					'<td class="'.$v_class_2.'">';
			$strForm .= '<table cellspacing="0" cellpadding="1" border="0" width="100%">';
			$strForm .= '<col width="1%"/><col width="99%"/>';
			if ($vars['is_topic_add'])
			{
				$strForm .= '<tr><td></td><td>' . $oL->m('2_page_3') . '</td></tr>';
			}
			if ($vars['is_topic_edit_other'])
			{
				$strForm .= '<tr><td></td><td>' . $oL->m('2_page_4') . '</td></tr>';
			}
			if ($vars['is_dict_add'])
			{
				$strForm .= '<tr><td></td><td>' . $oL->m('2_page_7') . '</td></tr>';
			}
			if ($vars['is_dict_edit'])
			{
				$strForm .= '<tr><td></td><td>' . $oL->m('2_page_8') . '</td></tr>';
			}
			if ($vars['is_term_add'])
			{
				$strForm .= '<tr><td></td><td>' . $oL->m('2_page_14') . '</td></tr>';
			}
			if ($vars['is_term_edit'])
			{
				$strForm .= '<tr><td></td><td>' . $oL->m('2_page_15') . '</td></tr>';
			}
			$strForm .= '</table>';
		$strForm .= '</td></tr>';

		$strForm .= '</tbody></table>';
	}
	  
	if (($oSess->user_get('perm_level') > $vars['perm_level'])
		&& ($ar_state['user_add'] || $ar_state['user_edit'] || $ar_state['user_edit_other'])
	)
	{
		$strForm .= getFormTitleNav($oL->m('user_dictionaries'));
		$strForm .= '<table class="gw2TableFieldset" width="100%">';
		$strForm .= '<tr><td style="width:'.$v_td1_width.'"></td><td></td></tr><tbody>';

			$strForm .= '<tr>'.
						'<td class="'.$v_class_1.'"></td>'.
						'<td class="'.$v_class_2.'">';

			$strForm .= '<table cellspacing="1" cellpadding="0" border="0" width="100%">';
			$strForm .= '<col width="1%"/><col width="99%"/>';
			/* Per each dictionary */
			$cnt = 0;
			for (reset($gw_this['ar_dict_list']); list($k, $arDictParam) = each($gw_this['ar_dict_list']);)
			{
				$is_assigned = 0;
				/* $vars['dictionaries'] is flipped */
				if (isset($vars['dictionaries'][$arDictParam['id']]))
				{
					$is_assigned = 1;
				}
				/* show the list of assigned dictionaries to user */
				if ($ar_state['user_edit'] && !$is_assigned)
				{
					continue;
				}
				$str_external_link = $arDictParam['is_active']
							? '<a href="'.$sys['page_index'].'?a=index&amp;d='. $arDictParam['id'] .'" onclick="window.open(this.href);return false;">&gt;&gt;&gt;</a> '
										: '<span class="f">&gt;&gt;&gt; </span>';
				$str_checkbox = '';
				$str_label = $arDictParam['title'];
				if (($vars['perm_level'] < 16)
				  	&& ($ar_state['user_add'] || $ar_state['user_edit_other']))
				{
					$str_checkbox = $form->field('checkbox', "arPost[dictionaries][". $arDictParam['id'] . "]", $is_assigned);
					$str_label = '<label for="arPost_dictionaries_' . $arDictParam['id'] . '_">'. $arDictParam['title'] .'</label>';
				}

				$strForm .= '<tr>'.
						'<td>' . $str_checkbox.'</td><td>'.$str_external_link .$str_label.'</td>'.
						'</tr>';
				$cnt++;
			}
			/* No assigned dictionaries */
			if (!$cnt)
			{
				$strForm .= '<tr>'.
						'<td></td><td>'. $oL->m('reason_4')  .'</td>'.
						'</tr>';
			}
			$strForm .= '</table>';
			$strForm .= '</td></tr>';

		$strForm .= '</tbody></table>';
	}
	if (${GW_ACTION} == REG)
	{
		$strForm .= $form->field("hidden", GW_ACTION, REG);
	}
	else
	{
		$strForm .= $form->field("hidden", GW_ACTION, UPDATE);
		$strForm .= $form->field("hidden", 'tid', $tid);
	}
	$strForm .= $form->field("hidden", 'arPost[perm_level]', $vars['perm_level']);
	$strForm .= $form->field("hidden", GW_TARGET, USER);
	$strForm .= $form->field("hidden", GW_SID, ${GW_SID});
	return $form->Output($strForm);
}

$arReq = array('user_name', 'user_email', 'username');

// --------------------------------------------------------
// action switcher
switch (${GW_ACTION})
{
case BRWS:
## --------------------------------------------------------
##
	$strR .= getFormUsers();
##
## --------------------------------------------------------
break;
case PROFILE:
## --------------------------------------------------------
##
	/* Check permissions */
	if (!$oSess->is('user_edit'))
	{
		$strR .= $oL->m('reason_13');
		return;
	}
	/* Not saved */
	if ($post == '')
	{
		/* < 1.7.0 */
		$vars['location'] = '';
		$vars['visualtheme'] = '';
		$vars['locale_name'] = '';
		$vars['is_htmled'] = '';
		$arBroken  = array();
		if ($gw_this['vars']['tid'])
		{
			/* Someone changes profile of another user */
			$vars = array_merge($vars, $oSess->user_load_values($gw_this['vars']['tid'], 'return'));
		}
		else
		{
			$vars = array_merge($vars, $oSess->user_get());
		}
		if ($oSess->user_get('perm_level') >= $vars['perm_level'])
		{
			$oSess->auth_user($vars);
			$vars['username'] =& $vars['login'];
			$vars['is_topic_add'] = $oSess->is('topic_add', 1);
			$vars['is_topic_edit_other'] = $oSess->is('topic_edit_other', 1);
			$vars['is_dict_add'] = $oSess->is('dict_add', 1);
			$vars['is_dict_edit'] = $oSess->is('dict_edit', 1);
			$vars['is_term_add'] = $oSess->is('term_add', 1);
			$vars['is_term_edit'] = $oSess->is('term_edit_other', 1);
		}
		else
		{
			$vars = array_merge($vars, $oSess->user_get());
			$vars['username'] = $oSess->user_get('login');
		}
#prn_r( $oSess->ar_permissions_user, 'ar_permissions_user' );
#		$vars['dictionaries'] = array_flip($vars['dictionaries']);
		$vars['pass_current'] = $vars['pass_new'] = $vars['pass_confirm'] = '';
		$strR .= getFormProfile($vars, 0, $arBroken, $arReq);
		$arHelpMap = array(
					'login'        => 'tip025',
#					'pass_current' => 'tip022',
					'pass_new'     => 'tip023',
					'pass_confirm' => 'tip024',
				 );
		if ($gw_this['vars']['tid']
			&& ($oSess->user_get('perm_level') >= $vars['perm_level']))
		{
			/* Hide tips */
			/* @todo put show/hide tips into user profile */
			unset($arHelpMap['pass_current']);
		}
		$strHelp = '';
		$strHelp .= '<dl>';
		for (; list($k, $v) = each($arHelpMap);)
		{
			$strHelp .= '<dt><b>' . $oL->m($k) . '</b></dt>';
			$strHelp .= '<dd>' . $oL->m($v) . '</dd>';
		}
		$strHelp .= '</dl>';
		$strR .= '<br />'.kTbHelp($oL->m('2_tip'), $strHelp);
	}
##
## --------------------------------------------------------
break;
case REG:
## --------------------------------------------------------
##
	$arReq[] = 'pass_new';
	/* Check permissions */
	if (!$oSess->is('user_add'))
	{
		$strR .= $oL->m('reason_13');
		return;
	}
	/* Not saved */
	if ($post == '')
	{
		$arBroken   = array();
		$vars['is_showcontact'] = 0;
		$vars['is_notice'] = 1;
		$vars['is_topic_add'] = 0;
		$vars['is_topic_edit_other'] = 0;
		$vars['is_dict_add'] = 0;
		$vars['is_dict_edit'] = 0;
		$vars['is_term_add'] = 1;
		$vars['is_term_edit'] = 1;
		$vars['perm_level'] = 1;
		$vars['username'] = $vars['pass_new'] = '';
		$vars['user_name'] = $vars['user_email'] = $vars['location'] = '';
		$vars['dictionaries'] = array();
		/* create new password and login */
		$vars['pass_new'] = kMakeUid('', $maxchar = 10, 1);
		$vars['username'] = kMakeUid('a', $maxchar = 8);
		$strR .= getFormProfile($vars, 0, $arBroken, $arReq);
	}
	else
	{
		/* Check for broken fields */
		if (isset($arReq))
		{
			$arBroken = validatePostWalk($arPost, $arReq);
		}
		/* Fix on/off options */
		$arIsV = array('is_showcontact','is_notice','is_topic_add','is_topic_add','is_topic_edit_other',
						'is_dict_add','is_dict_edit','is_term_add','is_term_edit');
		for (; list($k, $v) = each($arIsV);)
		{
			$arPost[$v]  = isset($arPost[$v]) ? $arPost[$v] : 0;
		}
		/* Check login */
		if (sizeof( $oSess->auth_info('', $arPost['username'])) > 0)
		{
			$arBroken['username'] = true;
			$strR .= '<p class="r"><span class="s">'. $oL->m('reason_15') . '</span></p>';
			$isPostError = 1;
		}
		/* Check e-mail */
		if (sizeof( $oSess->auth_info('', '', $arPost['user_email'] )) > 0)
		{
			$arBroken['user_email'] = true;
			$isPostError = 1;
			$strR .= '<p class="r"><span class="s">' . $oL->m('reason_18') . '</span></p>';
		}
		/* no errors */
		if (isset($arReq) && sizeof($arBroken) == 0)
		{
			$isPostError = 0;
		}
		else
		{
			if (!isset($arPost['dictionaries']))
			{
				$arPost['dictionaries'] = array();
			}
			$strR .= getFormProfile($arPost, 0, $arBroken, $arReq);
		}
		if (!$isPostError)
		{
#			$sys['isDebugQ'] = 1;
			$queryA = $q = array();
			$login_url = $sys['server_proto'] . $sys['server_host'] . $sys['page_login'];
			$login_url = '<a href="'.$login_url.'" onclick="window.open(this.href);return false;">'.$login_url.'</a>';
			/* Prepare message */
			/* User name, URL, login, password, message template */
			$msgBody = gwCreateMessage($arPost['user_name'], $login_url, $arPost['username'], $arPost['pass_new'], 'mail_newuser.html');
			/* */
			/* Send mail to user */
			if ($arPost['is_notice'])
			{
				if (!kMailTo($arPost['user_email'], $sys['y_email'], '', $msgBody, 0))
				{
					$strR .= '<p class="r"><span class="s">'.sprintf($oL->m("reason_17"), $arPost['user_email']).'</span></p>';
				}
			}
			/* The list of assigned dictionaries */
			$arPost['dictionaries'] = isset($arPost['dictionaries']) ? $arPost['dictionaries'] : array();
			/* Display login and password */
			$strR .= '<p class="u">'.$oL->m('login'). ': <b>' . $arPost['username'] . '</b> <br />'.
					 $oL->m('password'). ': <b>' . $arPost['pass_new'] . '</b><br />'.
					 $login_url . '</p>';
			$q1 = $q2 = array();
			/* Auth table */
			$q1['id_auth'] = $q2['id_user'] = $oDb->MaxId(TBL_AUTH, 'id_auth');
			$q1['login'] = $arPost['username'];
			$q1['password'] = md5($arPost['pass_new']);
			$ar_p = array (
				'topic_add' => $arPost['is_topic_add'],
				'topic_edit_other' => $arPost['is_topic_edit_other'],
				'dict_add' => $arPost['is_dict_add'],
				'dict_edit' => $arPost['is_dict_edit'],
				'term_add' => $arPost['is_term_add'],
				'term_edit_other' => $arPost['is_term_edit'],
			);
			$q1['perm_bits'] = $oSess->make_perm_bits($ar_p, 2);
			$queryA[] = gw_sql_replace($q1, TBL_AUTH);
			/* Users table */
			$q2['date_reg'] = gmmktime();
			$q2['date_login'] = 0;
			$q2['is_active'] = 1;
			$q2['int_terms'] = 0;
			$q2['is_showcontact'] = $arPost['is_showcontact'];
			$q2['perm_level'] = '2';
			$q2['user_name'] = $arPost['user_name'];
			$q2['user_email'] = $arPost['user_email'];
			$q2['user_settings'] = serialize(array(
					'is_htmled' => 1,
					'locale_name' => $sys['locale_name'],
					'visualtheme' => $sys['visualtheme'],
					'dictionaries' => $arPost['dictionaries']
				)
			);
			$queryA[] = gw_sql_replace($q2, TBL_USERS);
			/* Assign dictionaries map */
			for (; list($k, $v) = each($arPost['dictionaries']);)
			{
				$q3 = array();
				$q3['user_id'] = $q2['id_user'];
				$q3['dict_id'] = $k;
				$queryA[] = gw_sql_replace($q3, TBL_MAP_USER_DICT);
			}
			/* Redirect */
			$url = GW_ACTION . '=' . PROFILE . '&' . GW_TARGET . '=' . USER;
			$strR .= postQuery($queryA, $url, $sys['isDebugQ']);
		} /* final update */
	} /* submitted */
##
## --------------------------------------------------------
break;
case NEWPASS:
## --------------------------------------------------------
##
	// TODO: confirm
	// 2) create activation key
	// 3) create mail message
	// 4) send mail
	// 5) update database
	// 6) unauth
	//
	$actkey = kMakeUid('k', $maxchar = 16, 1);
	$actkey_url = $sys['server_proto'] . $sys['server_host'] . $sys['page_login'] . '?' . 'actkey=' . $actkey;
	$actkey_url = '<a href="'.$actkey_url.'">'.$actkey_url.'</a>';
	$mail_sig = $sys['site_name'] . ' - ' . $sys['site_desc'];
	$arSrc = array('{USERNAME}', '{SITENAME}', '{U_ACTIVATE}');
	$arTrg = array($oSess->user_get('user_name'), $sys['site_name'], $actkey_url);
	$msgBody = str_replace($arSrc, $arTrg, $oL->m('mail_newpass'));
	$msgSubj = str_replace($arSrc, $arTrg, $oL->m('mail_newpass_subj'));
	//
	$tpl_mail = new gwTemplate();
	$tpl_mail->addVal( 'LANG',           $oL->languagelist("0") );
	$tpl_mail->addVal( 'TEXT_DIRECTION', $oL->languagelist("1") );
	$tpl_mail->addVal( 'CHARSET',        $oL->languagelist("2") );
	$tpl_mail->addVal( 'EMAIL_SIG',      $mail_sig );
	$tpl_mail->addVal( 'MSG_NEWPASS',    $msgBody );
	$tpl_mail->addVal( 'SUBJECT',        $msgSubj );
	$tpl_mail->setHandle(0, $sys['path_admin'] . '/' . $sys['path_tpl'] . '/mail_newpass.html');
	$tpl_mail->parse();
	$msgBody = $tpl_mail->output();
	//
	if (kMailTo($oSess->user_get('user_email'), $sys['y_email'], $msgSubj, $msgBody, 0))
	{
		// mail was send, now add activation key
		$sql = 'UPDATE %s
				SET is_active = "0", user_actkey = "%s"
				WHERE auth_id ="%d"';
		$sql = sprintf($sql, TBL_USERS, $actkey, $auth->auth['id']);
		if(sqlExec($sql, '', 0))
		{
			$strR .= $oL->m('2_success');
			$auth->logout();
			page_close();
		}
	}
	else
	{
		$strR .= 'mail() error';
	}
##
## --------------------------------------------------------
break;
case UPDATE:
## --------------------------------------------------------
##

	/* Check permissions */
	if (!$oSess->is('user_edit'))
	{
		$strR .= $oL->m('reason_13');
		return;
	}
	/* Check for broken fields */
	if (isset($arReq))
	{
		$arBroken = validatePostWalk($arPost, $arReq);
	}
	/* Fix on/off options */
	$arIsV = array('is_showcontact','is_notice','is_topic_add','is_topic_add','is_topic_edit_other',
					'is_dict_add','is_dict_edit','is_term_add','is_term_edit','is_htmled');
	for (; list($k, $v) = each($arIsV);)
	{
		$arPost[$v]  = isset($arPost[$v]) ? $arPost[$v] : 0;
	}
	/* protect other's username from changing */
	if (isset($arPost['username']) && $gw_this['vars']['tid'] != '')
	{
		unset($arPost['username']);
	}
	/* compare changed username with existent */
	if (isset($arPost['username']))
	{
		$arExistent = $oSess->auth_info('', $arPost['username']);
		while (list($k, $arV) = each($arExistent))
		{
			if (isset($arV['id_user']) && ($arV['id_user'] != $oSess->user_get('id_user')))
			{
				$arBroken['username'] = true;
				$strR .= '<p class="r"><span class="s">'. $oL->m('reason_15') . '</span></p>';
				$isPostError = 1;
			}
		}
	}
	/* Switch for automatic logout */
	$is_pass_changed = 0;

	$id_user = ($gw_this['vars']['tid'] != '') ? $gw_this['vars']['tid'] : $oSess->user_get('id_user');
	$ar_user = $oSess->user_load_values($id_user, 'return');
	/* check e-mail */
	if ($arPost['user_email'] != '')
	{
		$arExistent = $oSess->auth_info('', '', $arPost['user_email']);
		while (list($k, $arV) = each($arExistent))
		{
			if (isset($arV['id_user']) && ($arV['id_user'] != $id_user))
			{
				$arBroken['user_email'] = true;
				$isPostError = 1;
				$strR .= '<p class="r"><span class="s">' . $oL->m('reason_18') . '</span></p>';
				/* admin changes profile of another user */
				if (($gw_this['vars']['tid'] != '') && $oSess->have_perm('perm_admin'))
				{
					/* settings for HTML-form */
					$arPost = array_merge( $oSess->auth_user($gw_this['vars']['tid']), $arPost);
					$arPost['auth_level'] = 2;
				}
			}
		}
	}
	/* parse password change */
	if (!empty($arPost['pass_new']) && !empty($arPost['pass_confirm']))
	{
		if ( $arPost['pass_new'] != $arPost['pass_confirm'] )
		{
			$arBroken['pass_new'] = $arBroken['pass_confirm'] = true;
			$strR .= '<p class="r"><span class="s">'. $oL->m('reason_14') . '</span></p>';
			$isPostError = 1;
		}
		else if ( strlen($arPost['pass_new']) > 32 )
		{
			$arBroken['pass_new'] = $arBroken['pass_confirm'] = true;
			$strR .= '<p class="r"><span class="s">'. $oL->m('reason_19') . '</span></p>';
			$isPostError = 1;
		}
		else if ($tid == '')
		{
			/* check current password */
#			$arExistent = $oSess->auth_info('', '', '', $arPost['pass_current']);
			/* do change password */
#			if (sizeof($arExistent) != 1)
#			{
#				$arBroken['pass_current'] = true;
#				$isPostError = 1;
#			}
			/* password changed by current user */
			if ($id_user == $oSess->user_get('id_user'))
			{
				$is_pass_changed = 1;
			}
		}
	}
	/* New login correct, current password is ok, both passwords is correct */
	if (isset($arReq) && sizeof($arBroken) == 0)
	{
		$isPostError = 0;
	}
	else
	{
		$isPostError = 1;
		/* Admin changes profile of another user */
		if (($gw_this['vars']['tid'] != '') && $oSess->have_perm('perm_admin'))
		{
		}
		else
		{
			$arPost['dictionaries'] = $oSess->user_get('dictionaries');
		}
		$arPost['perm_level'] = $ar_user['perm_level'];
		$arPost['username'] = $ar_user['login'];
		$arPost['date_reg'] = $ar_user['date_reg'];
		$arPost['date_login'] = $ar_user['date_login'];
		$strR .= getFormProfile($arPost, 0, $arBroken, $arReq);
	}
	/* final update */
	if (!$isPostError)
	{
#		$sys['isDebugQ'] = 1;
		$queryA = $q1 = $q2 = array();
		if (isset($arPost['username']))
		{
			$q1['login'] = $arPost['username'];
		}
		if (isset($arPost['pass_confirm']) && ($arPost['pass_confirm'] != ''))
		{
			$q1['password'] = md5($arPost['pass_confirm']);
		}
		/* Auth table */
		$q1['perm_bits'] = $oSess->user_get('perm_bits');
		
		if ($gw_this['vars']['tid'] && $oSess->is('user_edit'))
		{
			$ar_p = array (
				'topic_add' => $arPost['is_topic_add'],
				'topic_edit_other' => $arPost['is_topic_edit_other'],
				'dict_add' => $arPost['is_dict_add'],
				'dict_edit' => $arPost['is_dict_edit'],
				'term_add' => $arPost['is_term_add'],
				'term_edit_other' => $arPost['is_term_edit'],
			);
			$q1['perm_bits'] = $oSess->make_perm_bits($ar_p, $ar_user['perm_level']);
			$q2['perm_level'] = $ar_user['perm_level'];
		}
		$queryA[] = gw_sql_update($q1, TBL_AUTH, 'id_auth = "'.$id_user.'"');
		/* */
		$where = sprintf('id_user = "%d"', $id_user);
		/* Users table */
		$q2['is_active'] = isset($arPost['is_active']) ? $arPost['is_active'] : 1;
#		$q2['int_terms'] = 0;
		$q2['is_showcontact'] = $arPost['is_showcontact'];
		$q2['user_name'] = $arPost['user_name'];
		$q2['user_email'] = $arPost['user_email'];
		$q2['user_settings'] = serialize(array(
		  		'location' => $arPost['location'],
		  		'is_htmled' => $arPost['is_htmled'],
				'locale_name' => $arPost['locale_name'],
				'visualtheme' => $arPost['visualtheme'],
				'dictionaries' => isset($arPost['dictionaries']) ? $arPost['dictionaries'] : $ar_user['dictionaries']
			)
		);
		$queryA[] = gw_sql_update($q2, TBL_USERS, $where);
		/* Assign dictionaries */
		$arPost['dictionaries'] = isset($arPost['dictionaries']) ? $arPost['dictionaries'] : array();
		if ($oSess->have_perm('perm_admin'))
		{
			$queryA[] = sprintf('DELETE FROM %s WHERE user_id = "%d"', TBL_MAP_USER_DICT, $id_user);
		}
		for (; list($k, $v) = each($arPost['dictionaries']);)
		{
			$q3 = array();
			$q3['user_id'] = $id_user;
			$q3['dict_id'] = $k;
			$queryA[] = gw_sql_insert($q3, TBL_MAP_USER_DICT);
		}
		/* */
		$url = GW_ACTION . '=' . PROFILE . '&' . GW_TARGET . '=' . USER;
		if ($tid)
		{
			$url .= '&tid=' . $tid;
		}
		$strR .= postQuery($queryA, $url, $sys['isDebugQ'], 0);
		if ($is_pass_changed)
		{
			$oSess->logout();
		}
	}
##
## --------------------------------------------------------
break;
case GW_A_REMOVE:
## --------------------------------------------------------
##
	/* Check permissions */
	if (!$oSess->is('user_add'))
	{
		$strR .= $oL->m('reason_13');
		return;
	}
	$ar_user = $oSess->user_load_values($gw_this['vars']['tid'], 'return');
	$msg = '<p class="u">'.$ar_user['user_name'].'<br/>'.$ar_user['user_email'].'</p>';
	if (!$isConfirm)
	{
		$Confirm = new gwConfirmWindow;
		$Confirm->action = $sys['page_admin'];
		$Confirm->submitok = $oL->m('3_remove');
		$Confirm->submitcancel = $oL->m('3_cancel');
		$Confirm->formbgcolor = $GLOBALS['theme']['color_2'];
		$Confirm->formbordercolor = $GLOBALS['theme']['color_4'];
		$Confirm->formbordercolorL = $GLOBALS['theme']['color_1'];
		$Confirm->setQuestion('<p class="r"><span class="s"><b>' . $oL->m('9_remove') .
									'</b></span></p><p class="t"><span class="f">'. $oL->m('3_remove').
									': </span>'.$msg.'</p>');
		$Confirm->tAlign = 'center';
		$Confirm->formwidth = '400';
		$Confirm->setField("hidden", "tid", $gw_this['vars']['tid']);
		$Confirm->setField("hidden", GW_ACTION, GW_A_REMOVE);
		$Confirm->setField("hidden", GW_TARGET, ${GW_TARGET});
		$Confirm->setField("hidden", GW_SID, ${GW_SID});
		$strR .= $Confirm->Form();
	}
	else
	{
		/* Remove user:
			1. remove user id from gw_auth
			2. remove user id from gw_users
			3. remove user id from gw_users_map
			4. re-assign dictionary IDs to admin
			5. re-assing term IDs to admin
		*/
		$queryA[] = 'DELETE FROM ' . TBL_AUTH . ' WHERE id_auth = "' . $tid . '"';
		$queryA[] = 'DELETE FROM ' . TBL_USERS . ' WHERE id_user = "' . $tid . '"';
		$queryA[] = 'DELETE FROM ' . TBL_MAP_USER_DICT . ' WHERE user_id = "' . $tid . '"';
		/* Change owner */
		$q1['id_user'] = $oSess->user_get('id_user');
		$queryA[] = gw_sql_update($q1, TBL_DICT, 'id_user = "' . $tid . '"');
		$queryA[] = gw_sql_update($q1, TBL_MAP_USER_TERM, 'id_user = "' . $tid . '"');
		$strR .= postQuery($queryA, 'a=' . BRWS . '&'.GW_TARGET.'=' . USER, $sys['isDebugQ'], 0);
	}

##
## --------------------------------------------------------
break;
default:
break;
} // end of switch
// --------------------------------------------------------

#}
#else
#{
#	$strR .= $oL->m('reason_13');
#}
/* end of file */
?>