<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: top.term_updated.inc.php,v 1.6 2005/06/07 17:27:13 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2004 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Makes the list of last added terms.
 *  This code runs inside function getTop10();
 *  switch keyname: R_TERM_UPDATED
 */
// --------------------------------------------------------
/**
 * Variables:
 * $amount, $arThText,  $arThAlign, $strTopicName, $strData, $curDateMk
 */
	$ar_terms = array();
	for (reset($gw_this['ar_dict_list']); list($k, $arDictParam) = each($gw_this['ar_dict_list']);)
	{
		$sql = $oSqlQ->getQ('top-term-new', $arDictParam['tablename'], $amount);
		if (GW_IS_BROWSE_ADMIN)
		{
			$arSql = $oDb->sqlExec($sql);
 		}
 		else
 		{
			$arSql = $oDb->sqlRun($sql, sprintf("%05d", $gw_this['vars'][GW_ID_DICT]));
		}
		for (; list($arK, $arV) = each($arSql);)
		{
			$arV['id_dict'] = $arDictParam['id'];
			$arV['title'] = $arDictParam['title'];
			if (GW_IS_BROWSE_ADMIN)
			{
				$arV['is_term_edit'] = $oSess->is_allow('term_edit_other', $arDictParam['id']);
			}
			/* `-$arK' is trick to show terms with the same date */
			$ar_terms[$arV['date_modified']-$arK] = $arV;
		}
	}
	if (empty($ar_terms)){ return; }
	krsort($ar_terms);
	$arThText = array();

	if (GW_IS_BROWSE_ADMIN)
	{
		$arThWidth = array('5%', '65%', '29%');
		$arThAlign = array('center', $sys['css_align_left'], $sys['css_align_left']);
	}
	else
	{
		$arThWidth = array('50%', '49%');
		$arThAlign = array($sys['css_align_left'], $sys['css_align_left']);
	}
	$strTopicName = '';
	/* For each term */
	for (; list($k, $arV) = each($ar_terms);)
	{
		if ($cnt == $amount) { break; }
		$cnt % 2 ? ($bgcolor = $GLOBALS['theme']['color_2']) : ($bgcolor = $GLOBALS['theme']['color_1']);
		$cnt++;
		$strData .= '<tr class="f" style="background:' . $bgcolor . '">';
		$strData .= '<td class="t">' . $cnt . '</td>';
		if (GW_IS_BROWSE_ADMIN)
		{
			$str_edit = $oL->m('3_edit');
			$url_term = strip_tags($arV['term']);
			$href_edit = $sys['page_admin']. '?'.GW_ACTION.'=' .GW_A_EDIT. '&'.GW_TARGET.'=' .GW_T_TERM. '&id=' . $arV['id_dict'] . '&tid='. $arV['id'];
			if (($oSess->user_get('perm_level') == 16)
				|| $oSess->is_allow('term_edit_other', $arV['id_dict'])
				)
			{
				$str_edit = $oHtml->a($href_edit, $oL->m('3_edit'));
				$url_term = $oHtml->a($href_edit, strip_tags($arV['term']));
			}
			$strData .= '<td class="t">[&#160;' . $str_edit . '&#160;]</td>';
			$url_dict = $oHtml->a($sys['page_admin'] . '?' .GW_ACTION. '=edit&' .GW_TARGET. '=' .GW_T_DICT. '&id=' . $arV['id_dict'], $arV['title']);
		}
		else
		{
			$url_term = $oHtml->a( $sys['page_index']
								. '?'.GW_ACTION.'=' .GW_T_TERM. '&d=' . $arV['id_dict']
								. '&'.GW_TARGET.'=' . $arV['id'], strip_tags($arV['term']), '');
			$url_dict = $oHtml->a( append_url($sys['page_index']
								. '?'.GW_ACTION.'=index&d=' . $arV['id_dict']), strip_tags($arV['title']), '');
		}
		$strData .= '<td class="termpreview">' . $url_term . '</td>';
		$strData .= '<td class="t">' . $url_dict . '</td>';
		$strData .= '</tr>';
	}
/**
 * end of R_TERM_UPDATED
 */
?>