﻿-- phpMyAdmin SQL Dump
-- version 2.6.1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Jun 07, 2005 at 09:37 PM
-- Server version: 4.1.9
-- PHP Version: 5.0.3
--
-- Database: `glossword1`
--

-- --------------------------------------------------------

--
-- Table structure for table `gw_auth`
--

DROP TABLE IF EXISTS `gw_auth`;
CREATE TABLE `gw_auth` (
  `id_auth` int(10) unsigned NOT NULL auto_increment,
  `login` varchar(32) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `perm_bits` varchar(16) NOT NULL default '10010010000000',
  PRIMARY KEY  (`id_auth`),
  UNIQUE KEY `login` (`login`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_dict`
--

DROP TABLE IF EXISTS `gw_dict`;
CREATE TABLE `gw_dict` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `id_tp` tinyint(3) unsigned NOT NULL default '1',
  `is_active` enum('0','1') NOT NULL default '0',
  `id_user` smallint(5) unsigned NOT NULL default '1',
  `lang` varchar(12) NOT NULL default 'en-utf8',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_terms` mediumint(8) unsigned NOT NULL default '0',
  `int_bytes` int(12) unsigned NOT NULL default '0',
  `tablename` varchar(32) NOT NULL default '',
  `visualtheme` varchar(64) NOT NULL default 'gw_silver',
  `title` varbinary(255) NOT NULL default '',
  `announce` varbinary(255) NOT NULL default '',
  `description` blob NOT NULL,
  `keywords` varbinary(255) NOT NULL default '',
  `dict_settings` blob NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_map_user_to_dict`
--

DROP TABLE IF EXISTS `gw_map_user_to_dict`;
CREATE TABLE `gw_map_user_to_dict` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` smallint(5) unsigned NOT NULL default '1',
  `dict_id` smallint(5) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_map_user_to_term`
--

DROP TABLE IF EXISTS `gw_map_user_to_term`;
CREATE TABLE `gw_map_user_to_term` (
  `id` int(12) NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `term_id` int(10) unsigned NOT NULL default '0',
  `dict_id` mediumint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `user_id` (`user_id`,`term_id`,`dict_id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_pages`
--

DROP TABLE IF EXISTS `gw_pages`;
CREATE TABLE `gw_pages` (
  `id_page` tinyint(3) unsigned NOT NULL auto_increment,
  `is_active` enum('0','1') NOT NULL default '1',
  `int_sort` tinyint(3) NOT NULL default '10',
  `id_parent` mediumint(5) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `page_icon` varchar(64) NOT NULL default '',
  `page_uri` varchar(255) NOT NULL default '',
  `page_php_1` mediumblob NOT NULL,
  `page_php_2` tinyblob NOT NULL,
  PRIMARY KEY  (`id_page`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_pages_phrase`
--

DROP TABLE IF EXISTS `gw_pages_phrase`;
CREATE TABLE `gw_pages_phrase` (
  `id_page_phrase` mediumint(5) unsigned NOT NULL auto_increment,
  `id_page` tinyint(3) unsigned NOT NULL default '0',
  `id_lang` varchar(10) NOT NULL default 'en-utf8',
  `page_title` varbinary(255) NOT NULL default '',
  `page_descr` mediumblob NOT NULL,
  `page_content` mediumblob NOT NULL,
  PRIMARY KEY  (`id_page_phrase`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_search_results`
--

DROP TABLE IF EXISTS `gw_search_results`;
CREATE TABLE `gw_search_results` (
  `id_srch` varchar(32) NOT NULL default '',
  `id_d` mediumint(5) unsigned NOT NULL default '0',
  `srch_date` int(10) unsigned NOT NULL default '0',
  `found` int(10) unsigned NOT NULL default '1',
  `hits` mediumint(5) unsigned NOT NULL default '0',
  `q` varbinary(255) NOT NULL default '',
  `srch_settings` mediumblob NOT NULL,
  PRIMARY KEY  (`id_srch`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_sessions`
--

DROP TABLE IF EXISTS `gw_sessions`;
CREATE TABLE `gw_sessions` (
  `id_sess` varchar(32) NOT NULL default '',
  `id_user` smallint(5) unsigned NOT NULL default '1',
  `name` varchar(8) NOT NULL default '',
  `changed` int(10) unsigned NOT NULL default '0',
  `sess_settings` blob,
  `ip` int(10) unsigned NOT NULL default '0',
  `ua` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`name`,`id_sess`),
  KEY `changed` (`changed`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_settings`
--

DROP TABLE IF EXISTS `gw_settings`;
CREATE TABLE `gw_settings` (
  `settings_key` varchar(127) NOT NULL default '',
  `settings_val` mediumblob NOT NULL,
  PRIMARY KEY  (`settings_key`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_stat_dict`
--

DROP TABLE IF EXISTS `gw_stat_dict`;
CREATE TABLE `gw_stat_dict` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `hits` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_toolbar`
--

DROP TABLE IF EXISTS `gw_toolbar`;
CREATE TABLE `gw_toolbar` (
  `id` mediumint(5) unsigned NOT NULL auto_increment,
  `int_sort` smallint(3) unsigned NOT NULL default '0',
  `character` varbinary(4) NOT NULL default '',
  `id_lang` varchar(9) NOT NULL default 'en-utf8',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_tpcs`
--

DROP TABLE IF EXISTS `gw_tpcs`;
CREATE TABLE `gw_tpcs` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `s` smallint(5) unsigned NOT NULL default '10',
  `p` smallint(5) unsigned NOT NULL default '0',
  `tpname` varbinary(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_users`
--

DROP TABLE IF EXISTS `gw_users`;
CREATE TABLE `gw_users` (
  `id_user` smallint(5) unsigned NOT NULL auto_increment,
  `date_reg` int(10) unsigned NOT NULL default '0',
  `date_login` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '0',
  `user_actkey` varchar(16) NOT NULL default '',
  `perm_level` tinyint(3) unsigned NOT NULL default '4',
  `user_name` varbinary(64) NOT NULL default '',
  `user_email` varchar(64) NOT NULL default '',
  `is_showcontact` enum('0','1') NOT NULL default '0',
  `int_terms` int(10) unsigned NOT NULL default '0',
  `user_settings` blob NOT NULL,
  PRIMARY KEY  (`id_user`),
  UNIQUE KEY `user_email` (`user_email`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_wordlist`
--

DROP TABLE IF EXISTS `gw_wordlist`;
CREATE TABLE `gw_wordlist` (
  `word_text` varbinary(100) NOT NULL default '',
  `word_id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`word_text`),
  UNIQUE KEY `word_id` (`word_id`)
) TYPE=MyISAM PACK_KEYS=0 DELAY_KEY_WRITE=1;

-- --------------------------------------------------------

--
-- Table structure for table `gw_wordmap`
--

DROP TABLE IF EXISTS `gw_wordmap`;
CREATE TABLE `gw_wordmap` (
  `word_id` int(10) unsigned NOT NULL default '0',
  `term_id` int(10) unsigned NOT NULL default '0',
  `dict_id` smallint(5) unsigned NOT NULL default '0',
  `term_match` tinyint(2) NOT NULL default '0',
  KEY `word_id` (`word_id`),
  KEY `term_id` (`term_id`)
) TYPE=MyISAM PACK_KEYS=0 DELAY_KEY_WRITE=1;

-- --------------------------------------------------------

--
-- Table structure for table `gw_x2zsnz6`
--

DROP TABLE IF EXISTS `gw_x2zsnz6`;
CREATE TABLE `gw_x2zsnz6` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `id_toolbar` mediumint(5) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(6) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_x8fjuvw`
--

DROP TABLE IF EXISTS `gw_x8fjuvw`;
CREATE TABLE `gw_x8fjuvw` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(6) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_xgnmjtj`
--

DROP TABLE IF EXISTS `gw_xgnmjtj`;
CREATE TABLE `gw_xgnmjtj` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(5) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `gw_xtsdmq8`
--

DROP TABLE IF EXISTS `gw_xtsdmq8`;
CREATE TABLE `gw_xtsdmq8` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(6) unsigned NOT NULL default '0',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

-- --------------------------------------------------------

--
-- Table structure for table `songs1`
--

DROP TABLE IF EXISTS `songs1`;
CREATE TABLE `songs1` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(6) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;





-- phpMyAdmin SQL Dump
-- version 2.6.1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Jun 07, 2005 at 09:37 PM
-- Server version: 4.1.9
-- PHP Version: 5.0.3
--
-- Database: `glossword1`
--

-- --------------------------------------------------------

--
-- Table structure for table `gw_auth`
--

DROP TABLE IF EXISTS `gw_auth`;
CREATE TABLE `gw_auth` (
  `id_auth` int(10) unsigned NOT NULL auto_increment,
  `login` varchar(32) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `perm_bits` varchar(16) NOT NULL default '10010010000000',
  PRIMARY KEY  (`id_auth`),
  UNIQUE KEY `login` (`login`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_dict`
--

DROP TABLE IF EXISTS `gw_dict`;
CREATE TABLE `gw_dict` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `id_tp` tinyint(3) unsigned NOT NULL default '1',
  `is_active` enum('0','1') NOT NULL default '0',
  `id_user` smallint(5) unsigned NOT NULL default '1',
  `lang` varchar(12) NOT NULL default 'en-utf8',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_terms` mediumint(8) unsigned NOT NULL default '0',
  `int_bytes` int(12) unsigned NOT NULL default '0',
  `tablename` varchar(32) NOT NULL default '',
  `visualtheme` varchar(64) NOT NULL default 'gw_silver',
  `title` varbinary(255) NOT NULL default '',
  `announce` varbinary(255) NOT NULL default '',
  `description` blob NOT NULL,
  `keywords` varbinary(255) NOT NULL default '',
  `dict_settings` blob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_map_user_to_dict`
--

DROP TABLE IF EXISTS `gw_map_user_to_dict`;
CREATE TABLE `gw_map_user_to_dict` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user_id` smallint(5) unsigned NOT NULL default '1',
  `dict_id` smallint(5) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_map_user_to_term`
--

DROP TABLE IF EXISTS `gw_map_user_to_term`;
CREATE TABLE `gw_map_user_to_term` (
  `id` int(12) NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `term_id` int(10) unsigned NOT NULL default '0',
  `dict_id` mediumint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `user_id` (`user_id`,`term_id`,`dict_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_pages`
--

DROP TABLE IF EXISTS `gw_pages`;
CREATE TABLE `gw_pages` (
  `id_page` tinyint(3) unsigned NOT NULL auto_increment,
  `is_active` enum('0','1') NOT NULL default '1',
  `int_sort` tinyint(3) NOT NULL default '10',
  `id_parent` mediumint(5) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `page_icon` varchar(64) NOT NULL default '',
  `page_uri` varchar(255) NOT NULL default '',
  `page_php_1` mediumblob NOT NULL,
  `page_php_2` tinyblob NOT NULL,
  PRIMARY KEY  (`id_page`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_pages_phrase`
--

DROP TABLE IF EXISTS `gw_pages_phrase`;
CREATE TABLE `gw_pages_phrase` (
  `id_page_phrase` mediumint(5) unsigned NOT NULL auto_increment,
  `id_page` tinyint(3) unsigned NOT NULL default '0',
  `id_lang` varchar(10) NOT NULL default 'en-utf8',
  `page_title` varbinary(255) NOT NULL default '',
  `page_descr` mediumblob NOT NULL,
  `page_content` mediumblob NOT NULL,
  PRIMARY KEY  (`id_page_phrase`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_search_results`
--

DROP TABLE IF EXISTS `gw_search_results`;
CREATE TABLE `gw_search_results` (
  `id_srch` varchar(32) NOT NULL default '',
  `id_d` mediumint(5) unsigned NOT NULL default '0',
  `srch_date` int(10) unsigned NOT NULL default '0',
  `found` int(10) unsigned NOT NULL default '1',
  `hits` mediumint(5) unsigned NOT NULL default '0',
  `q` varbinary(255) NOT NULL default '',
  `srch_settings` mediumblob NOT NULL,
  PRIMARY KEY  (`id_srch`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_sessions`
--

DROP TABLE IF EXISTS `gw_sessions`;
CREATE TABLE `gw_sessions` (
  `id_sess` varchar(32) NOT NULL default '',
  `id_user` smallint(5) unsigned NOT NULL default '1',
  `name` varchar(8) NOT NULL default '',
  `changed` int(10) unsigned NOT NULL default '0',
  `sess_settings` blob,
  `ip` int(10) unsigned NOT NULL default '0',
  `ua` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`name`,`id_sess`),
  KEY `changed` (`changed`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_settings`
--

DROP TABLE IF EXISTS `gw_settings`;
CREATE TABLE `gw_settings` (
  `settings_key` varchar(127) NOT NULL default '',
  `settings_val` mediumblob NOT NULL,
  PRIMARY KEY  (`settings_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_stat_dict`
--

DROP TABLE IF EXISTS `gw_stat_dict`;
CREATE TABLE `gw_stat_dict` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `hits` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_toolbar`
--

DROP TABLE IF EXISTS `gw_toolbar`;
CREATE TABLE `gw_toolbar` (
  `id` mediumint(5) unsigned NOT NULL auto_increment,
  `int_sort` smallint(3) unsigned NOT NULL default '0',
  `character` varbinary(4) NOT NULL default '',
  `id_lang` varchar(9) NOT NULL default 'en-utf8',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_tpcs`
--

DROP TABLE IF EXISTS `gw_tpcs`;
CREATE TABLE `gw_tpcs` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `s` smallint(5) unsigned NOT NULL default '10',
  `p` smallint(5) unsigned NOT NULL default '0',
  `tpname` varbinary(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_users`
--

DROP TABLE IF EXISTS `gw_users`;
CREATE TABLE `gw_users` (
  `id_user` smallint(5) unsigned NOT NULL auto_increment,
  `date_reg` int(10) unsigned NOT NULL default '0',
  `date_login` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '0',
  `user_actkey` varchar(16) NOT NULL default '',
  `perm_level` tinyint(3) unsigned NOT NULL default '4',
  `user_name` varbinary(64) NOT NULL default '',
  `user_email` varchar(64) NOT NULL default '',
  `is_showcontact` enum('0','1') NOT NULL default '0',
  `int_terms` int(10) unsigned NOT NULL default '0',
  `user_settings` blob NOT NULL,
  PRIMARY KEY  (`id_user`),
  UNIQUE KEY `user_email` (`user_email`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_wordlist`
--

DROP TABLE IF EXISTS `gw_wordlist`;
CREATE TABLE `gw_wordlist` (
  `word_text` varbinary(100) NOT NULL default '',
  `word_id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`word_text`),
  UNIQUE KEY `word_id` (`word_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 PACK_KEYS=0 DELAY_KEY_WRITE=1;

-- --------------------------------------------------------

--
-- Table structure for table `gw_wordmap`
--

DROP TABLE IF EXISTS `gw_wordmap`;
CREATE TABLE `gw_wordmap` (
  `word_id` int(10) unsigned NOT NULL default '0',
  `term_id` int(10) unsigned NOT NULL default '0',
  `dict_id` smallint(5) unsigned NOT NULL default '0',
  `term_match` tinyint(2) NOT NULL default '0',
  KEY `word_id` (`word_id`),
  KEY `term_id` (`term_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 PACK_KEYS=0 DELAY_KEY_WRITE=1;

-- --------------------------------------------------------

--
-- Table structure for table `gw_x2zsnz6`
--

DROP TABLE IF EXISTS `gw_x2zsnz6`;
CREATE TABLE `gw_x2zsnz6` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `id_toolbar` mediumint(5) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(6) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_x8fjuvw`
--

DROP TABLE IF EXISTS `gw_x8fjuvw`;
CREATE TABLE `gw_x8fjuvw` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(6) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_xgnmjtj`
--

DROP TABLE IF EXISTS `gw_xgnmjtj`;
CREATE TABLE `gw_xgnmjtj` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(5) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `gw_xtsdmq8`
--

DROP TABLE IF EXISTS `gw_xtsdmq8`;
CREATE TABLE `gw_xtsdmq8` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(6) unsigned NOT NULL default '0',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `songs1`
--

DROP TABLE IF EXISTS `songs1`;
CREATE TABLE `songs1` (
  `id` int(10) unsigned NOT NULL default '0',
  `is_active` enum('0','1') NOT NULL default '1',
  `date_modified` int(10) unsigned NOT NULL default '0',
  `date_created` int(10) unsigned NOT NULL default '0',
  `int_bytes` mediumint(6) unsigned NOT NULL default '0',
  `term_1` varbinary(6) NOT NULL default '',
  `term_2` varbinary(12) NOT NULL default '',
  `term` varbinary(255) NOT NULL default '',
  `defn` mediumblob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
