<?php
/**
 * Glossword installation 1.7
 * by Dmitry N. Shilnikov <dev at glossword dot info>
 * @version $Id: update_1.6.x_to_1.7.0.php,v 1.4 2005/06/08 20:44:05 yrtimd Exp $
 */
/* Change current directory to access for website files */
if (!@chdir('..'))
{
    exit(print "Can't change directory to `..'");
}
define('IN_GW', TRUE);
define('THIS_SCRIPT', 'update_1.6.x_to_1.7.0.php');
error_reporting(E_ALL);

/* Enter debug mode. None of database queries will be executed */
$sys['is_debug'] = 0;
$sys['path_install'] = 'gw_install';

/* Configuration */
$sys['path_gwlib'] = 'lib';
$sys['path_include'] = 'inc';
$sys['path_include_local'] = 'inc';
$sys['is_prepend'] = 0;
include('db_config.php');

/* Reset prefix for database tables */
$sys['tbl_prefix'] = '';


include_once($sys['path_include_local'] . '/config.inc.php');

if (file_exists($sys['path_install'].'/install_functions.php'))
{
	include_once($sys['path_install'].'/install_functions.php');
}
else
{
	printf('<br/><b>Error:</b> File %s required.', $sys['path_install'].'/install_functions.php');
}
include_once($sys['path_include'] . '/constants.inc.php');
include_once($sys['path_include'] . '/func.sql.inc.php');
include_once($sys['path_include'] . '/class.forms.php');
include_once($sys['path_include'] . '/class.gwtk.php');
include_once($sys['path_gwlib'].'/class.globals.php');
include_once($sys['path_gwlib'].'/class.func.php');
include_once($sys['path_gwlib'].'/class.db.mysql.php');
include_once($sys['path_gwlib'].'/class.db.q.php');
include_once('update_1.6.x_to_1.7.0-qs.php');


/* Constants */
define('CRLF', "\r\n");
define('LF', "\\n\\");
$tmp['arPhpVer'] = explode('.', PHP_VERSION);
define('PHP_VERSION_INT', intval(sprintf('%d%02d%02d', $tmp['arPhpVer'][0], $tmp['arPhpVer'][1], $tmp['arPhpVer'][2])));
$tmp['arMySQLVer'] = explode('.', mysql_get_client_info());
define('MYSQL_VERSION_INT', intval(sprintf('%d%02d%02d', $tmp['arMySQLVer'][0], $tmp['arMySQLVer'][1], $tmp['arMySQLVer'][2])));

@header('Content-Type: text/html; charset=utf-8');
@header("Expires: " . gmdate("D, d M Y H:i:s") . " GMT");
@header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
@header("Cache-Control: no-cache, must-revalidate");
@header("Pragma: no-cache");

/* */
$sys['user_name'] = 'Dmitry N. Shilnikov';
$sys['user_email'] = 'dev'.'@'.'glossword.info';
$sys['user_login'] = 'admin';
$sys['user_pass'] = '';
$sys['is_mod_rewrite']  = 0;
$sys['visualtheme']  = 'gw_silver';
$sys['path_css'] =  '../'.$sys['path_tpl'].'/'.$sys['visualtheme'];
$sys['version'] = '1.7.0';
$sys['db_type'] = 'mysql410';
include_once($sys['path_tpl'].'/'.$sys['visualtheme'].'/theme.inc.php');
/* */
$gv['vars'] = $oGlobals->register(array('step', 'arpost', 'id_dict', GW_LANG_I));
$oGlobals->do_default($gv['vars']['step'], 1);
$oGlobals->do_default($gv['vars']['arpost']['dbhost'], 'localhost');
$oGlobals->do_default($gv['vars']['arpost']['dbport'], '');
$oGlobals->do_default($gv['vars']['arpost']['dbname'], str_replace('`', '', GW_DB_DATABASE));
$oGlobals->do_default($gv['vars']['arpost']['dbprefix'], 'gw_');
$oGlobals->do_default($gv['vars']['arpost']['dbuser'], GW_DB_USER);
$oGlobals->do_default($gv['vars']['arpost']['dbpass'], GW_DB_PASSWORD);
/* English by default */
$oGlobals->do_default($gv['vars'][GW_LANG_I], 'en');
/* --------------------------------------------------------
 * Translation kit
 * -------------------------------------------------------- */
$oL = new gwtk;
$oL->setHomeDir('gw_install/gw_locale');
$oL->setLocale($gv['vars'][GW_LANG_I].'-utf8');
$oL->getCustom('l_install', $gv['vars'][GW_LANG_I].'-utf8', 'join');
$oL->getCustom('l_update', $gv['vars'][GW_LANG_I].'-utf8', 'join');
$sys['css_align_right'] = 'right';
$sys['css_align_left'] = 'left';
if ($oL->languagelist('1') == 'rtl')
{
	$sys['css_align_right'] = 'left';
	$sys['css_align_left'] = 'right';
}
/* */
$sys['html_title'] = sprintf($oL->m('up001'), '1.6.x', $sys['version']);

/* --------------------------------------------------------
 * Query storage
 * ----------------------------------------------------- */
$oSqlQ = new $sys['class_queries'];
/* */
function sqlGetQ($keyname)
{
	global $sys, $oSqlQ;
	
	$args = func_get_args();
	for ($i = 0; $i <= 5; $i++)
	{
		$ar[] = isset($args[$i]) ? $args[$i] : '';
	}	
	$oSqlQ->set_suffix('-'.$sys['db_type']);
	return $oSqlQ->getQ($keyname, $ar[1], $ar[2], $ar[3], $ar[4], $ar[5]);
}
/* */
class gw_update
{
	var $id_dict = 0;
	var $str_step = '';
	var $str_before = '';
	var $ar_status = '';
	var $str_after = '';
	var $cur_funcname = '';
	var $oDb;
	var $int_steps = 5;
	function gw_update()
	{
		global $oDb, $oFunc, $sys, $gv, $theme, $oL, $oSqlQ;
		$this->oDb = new gwtkDb;
		$this->oForm = new gwForms;
		$this->oFunc =& $oFunc;
		$this->oL =& $oL;
		$this->sys =& $sys;
		$this->gv =& $gv;
		$this->oSqlQ =& $oSqlQ;
		$this->arTheme =& $theme;
	}
	/* */
	function is_locked()
	{
		return file_exists($this->sys['file_lock']);
	}
	function get_html_steps_progress($step)
	{
		$ar = array();
		for ($i = 1; $i <= $this->int_steps; $i++)
		{
			$ar[$i] = ' '. $this->oL->m('054') . ' ' . $i.'  ';
			if ($step == $i) { $ar[$i] = '<b class="green">'.$ar[$i].'</b>'; }
		}
		return '<span class="gray">'.implode('&#x2192;', $ar).'</span>';
	}
	/* */
	function step()
	{
	  	/* Show 'installation is locked' page */
		if ($this->is_locked() && $this->gv['vars']['step'] > 0)
		{
			$this->ar_status[] = sprintf($this->oL->m('052'), $this->sys['file_lock']);
			return false;
		}
		else if ($this->gv['vars']['step'] > 0)
		{
		  	/* Show 'steps' for valid installation page only */
			$this->str_step .= $this->get_html_steps_progress($this->gv['vars']['step']);
		}
		$this->{$this->cur_funcname}();
	}
	/* */
	function step_1()
	{
		$this->str_before .= $this->oL->m('up007');
		$this->str_before .= $this->oL->m('up014');
		$this->str_before .= $this->oL->m('up002');
		$this->str_before .= '<ol>';
		$this->str_before .= '<li>'.$this->oL->m('005').'</li>';
		$this->str_before .= '<li>'.$this->oL->m('up013').'</li>';
		$this->str_before .= '<li>'.$this->oL->m('up011').'</li>';
		$this->str_before .= '<li>'.$this->oL->m('up008').'</li>';
		$this->str_before .= '<li>'.$this->oL->m('up010').'</li>';
		$this->str_before .= '</ol>';
		$is_continue = 1;
		/* Get permisions */
		$is_continue = 0;
		$this->ar_status[2] = $this->oL->m('059');
		if ( file_exists('db_config.php') && is_writeable('db_config.php') )
		{
			$this->ar_status[2] .= get_html_item_progress(sprintf($this->oL->m('060'), 'db_config.php'), 1);
			$is_continue = 1;
		}
		else
		{
			$this->ar_status[2] .= get_html_item_progress(sprintf($this->oL->m('061'), 'db_config.php'), 3);
		}
		
		$this->ar_status[5] = gw_next_step($is_continue, 'step=2');
	}
	/* */
	function step_2()
	{
		$this->str_before .= $this->oL->m('up012');
		$this->str_before .= $this->get_form(2);
	}
	function step_3()
	{
		$this->str_before .= '<br/><br/>';
		/* Check database connection */
		$is_continue = 0;
		if (@mysql_connect($this->gv['vars']['arpost']['dbhost'], $this->gv['vars']['arpost']['dbuser'], $this->gv['vars']['arpost']['dbpass']))
		{
			if (@mysql_select_db($this->gv['vars']['arpost']['dbname']))
			{
				$is_continue = 1;
				$this->oDb->host = $this->gv['vars']['arpost']['dbhost'];
				$this->oDb->user = $this->gv['vars']['arpost']['dbuser'];
				$this->oDb->password = $this->gv['vars']['arpost']['dbpass'];
				$this->oDb->database = $this->gv['vars']['arpost']['dbname'];
			}
			else
			{
				$this->str_before .= get_html_item_progress(sprintf($this->oL->m('084'), $this->gv['vars']['arpost']['dbname']), 3);
			}
		}
		else
		{
			$this->str_before .= get_html_item_progress(sprintf($this->oL->m('083'), $this->gv['vars']['arpost']['dbhost'], $this->gv['vars']['arpost']['dbuser']), 3);
		}
		/* Check contact information */
		$this->sys['user_email'] = $this->gv['vars']['arpost']['user_email'];
		$this->sys['user_name'] = $this->gv['vars']['arpost']['user_name'];
		$this->sys['user_login'] = $this->gv['vars']['arpost']['user_login'];
		$this->sys['pass_new'] = $this->gv['vars']['arpost']['pass_new'];
		if ($this->gv['vars']['arpost']['user_name'] == '')
		{
			$this->str_before .= get_html_item_progress($this->oL->m('095'), 2);
			$is_continue = 0;
		}
		if ($this->gv['vars']['arpost']['user_email'] == '')
		{
			$this->str_before .= get_html_item_progress($this->oL->m('096'), 2);
			$is_continue = 0;
		}
		if ($this->gv['vars']['arpost']['user_login'] == '')
		{
			$this->str_before .= get_html_item_progress($this->oL->m('097'), 2);
			$is_continue = 0;
		}
		/* Server settings */
		$this->sys['server_proto'] = $this->gv['vars']['arpost']['server_proto'];
		$this->sys['server_host'] = $this->gv['vars']['arpost']['server_host'];
		$this->sys['server_dir'] = $this->gv['vars']['arpost']['server_dir'];

		/* */
		if ($is_continue)
		{
			$this->ar_status[] = sprintf($this->oL->m('085'), $this->gv['vars']['arpost']['dbname']);
			$this->sys['tbl_prefix'] = $this->gv['vars']['arpost']['dbprefix'];
			$this->sys['db_type'] = $this->gv['vars']['arpost']['db_type'];
			/* Prepare configuration file */
			$is_continue = 0;
			$str_file = '<'.'?php';
			$str_file .= CRLF . '/* Database settings for Glossword */';
			$str_file .= CRLF . sprintf("defined('GW_DB_HOST') ? '' : define('GW_DB_HOST', '%s');", $this->gv['vars']['arpost']['dbhost']);
			$str_file .= CRLF . sprintf("defined('GW_DB_DATABASE') ? '' : define('GW_DB_DATABASE', '`%s`');", $this->gv['vars']['arpost']['dbname']);
			$str_file .= CRLF . sprintf("defined('GW_DB_USER') ? '' : define('GW_DB_USER', '%s');", $this->gv['vars']['arpost']['dbuser']);
			$str_file .= CRLF . sprintf("defined('GW_DB_PASSWORD') ? '' : define('GW_DB_PASSWORD', '%s');", $this->gv['vars']['arpost']['dbpass']);
			$str_file .= CRLF . sprintf("\$sys['tbl_prefix'] = '%s';", $this->gv['vars']['arpost']['dbprefix']);
			$str_file .= CRLF . sprintf("\$sys['db_type'] = '%s';", $this->gv['vars']['arpost']['db_type']);
			$str_file .= CRLF . '/* Path names for Glossword */';
			$str_file .= CRLF . sprintf("\$sys['server_proto'] = '%s';", $this->gv['vars']['arpost']['server_proto']);
			$str_file .= CRLF . sprintf("\$sys['server_host'] = '%s';", $this->gv['vars']['arpost']['server_host']);
			$str_file .= CRLF . sprintf("\$sys['server_dir'] = '%s';", $this->gv['vars']['arpost']['server_dir']);
			$str_file .= CRLF . sprintf("\$sys['server_url'] = '%s';", $this->gv['vars']['arpost']['server_proto'].$this->gv['vars']['arpost']['server_host'].$this->gv['vars']['arpost']['server_dir']);
			$str_file .= CRLF . '?'.'>';
			$this->ar_status[] = $this->oL->m('087');
			if (!$this->sys['is_debug'])
			{
				$is_continue = $this->oFunc->file_put_contents('db_config.php', $str_file, 'w');
			}
			if ($is_continue)
			{
				$this->ar_status[(sizeof($this->ar_status)-1)] .= '... Done';
				$is_continue = 0;
			}
			else
			{
				$this->ar_status[(sizeof($this->ar_status)-1)] .= get_html_item_progress('<b>db_config.php</b><pre>'.htmlspecialchars($str_file).'</pre>', 3);
			}
			/* Prepare database queries */
			$arQuery = array();
			
			/* TBL_SESS */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_SESS);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_SESS.'`';
			$arQuery[] = sqlGetQ('TBL_SESS');

			/* TBL_SETTINGS */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_SETTINGS);

			$arSql = $this->oDb->sqlExec('SELECT * FROM `'.$this->sys['tbl_prefix'].TBL_SETTINGS.'`');
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_SETTINGS.'`';
			$arQuery[] = sqlGetQ('TBL_SETTINGS');
			for (reset($arSql); list($kQ, $arV) = each($arSql);)
			{
				$q1 = array();
				switch($arV['settings_key'])
				{
					case 'site_name':
					case 'site_desc':
					case 'keywords':
						$arQuery[] = sqlGetQ('ins-setting', $arV['settings_key'], $arV['settings_val']);
					break;
				}
			}
			$arQuery[] = sqlGetQ('ins-setting', 'y\_email', gw_text_sql($this->gv['vars']['arpost']['user_email']));
			$arQuery[] = sqlGetQ('ins-setting', 'y\_name', gw_text_sql($this->gv['vars']['arpost']['user_name']));
			$arQuery[] = sqlGetQ('ins-setting', 'version', $this->sys['version']);
			$arQuery[] = sqlGetQ('ins-setting', 'locale\_name', 'en-utf8');
			$arQuery[] = sqlGetQ('ins-setting', 'page\_limit', '20');
			$arQuery[] = sqlGetQ('ins-setting', 'time\_refresh', '2');
			$arQuery[] = sqlGetQ('ins-setting', 'time\_new', '7');
			$arQuery[] = sqlGetQ('ins-setting', 'time\_upd', '14');
			$arQuery[] = sqlGetQ('ins-setting', 'defn\_cut', '200');
			$arQuery[] = sqlGetQ('ins-setting', 'srch\_len', '1');
			$arQuery[] = sqlGetQ('ins-setting', 'is\_hideurl', '1');
			$arQuery[] = sqlGetQ('ins-setting', 'dp\_layout', '0');
			$arQuery[] = sqlGetQ('ins-setting', 'searchformcode', '');
			$arQuery[] = sqlGetQ('ins-setting', 'visualtheme', gw_text_sql('gw_silver'));
			$arQuery[] = sqlGetQ('ins-setting', 'max\_dict\_updated', '5');
			$arQuery[] = sqlGetQ('ins-setting', 'max\_dict\_top', '10');
			$arQuery[] = sqlGetQ('ins-setting', 'is\_list_numbers', '1');
			$arQuery[] = sqlGetQ('ins-setting', 'is\_list\_images', '1');
			$arQuery[] = sqlGetQ('ins-setting', 'is\_list\_announce', '0');
			
			/* TBL_AUTH */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_AUTH);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_AUTH.'`';
			$arQuery[] = sqlGetQ('TBL_AUTH');
			$q1['id_auth'] = 1;
			$q1['login'] = 'guest';
			$q1['password'] = md5('guest');
			$q1['perm_bits'] = '10010010000000';
			$arQuery[] = gw_sql_replace($q1, $this->sys['tbl_prefix'].TBL_AUTH);
			$q1['id_auth'] = 2;
			$q1['login'] = gw_text_sql($this->gv['vars']['arpost']['user_login']);
			$q1['password'] = md5($this->gv['vars']['arpost']['pass_new']);
			$q1['perm_bits'] = '11111111111111';
			$arQuery[] = gw_sql_replace($q1, $this->sys['tbl_prefix'].TBL_AUTH);

			/* TBL_USERS */
			$this->ar_status[] = sprintf($this->oL->m('up009'), $this->sys['tbl_prefix'].TBL_USERS);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_USERS.'`';
			$arQuery[] = sqlGetQ('TBL_USERS');
			$q2 = array();
			$q2['id_user'] = 1;
			$q2['date_reg'] = gmmktime();
			$q2['date_login'] = 0;
			$q2['is_active'] = 1;
			$q2['int_terms'] = 0;
			$q2['is_showcontact'] = 1;
			$q2['perm_level'] = '1';
			$q2['user_name'] = 'Guest';
			$q2['user_email'] = 'guest@localhost';
			$q2['user_settings'] = serialize(array(
					'is_htmled' => 1,
					'locale_name' => 'en-utf8',
					'visualtheme' => $this->sys['visualtheme'],
					'dictionaries' => array()
				)
			);
			$arQuery[] = gw_sql_replace($q2, $this->sys['tbl_prefix'].TBL_USERS);
			$q2['id_user'] = 2;
			$q2['perm_level'] = '16';
			$q2['user_name'] = $this->gv['vars']['arpost']['user_name'];
			$q2['user_email'] = $this->gv['vars']['arpost']['user_email'];
			$arQuery[] = gw_sql_replace($q2, $this->sys['tbl_prefix'].TBL_USERS);


			/* TBL_MAP_USER_DICT */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_MAP_USER_DICT);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_MAP_USER_DICT.'`';
			$arQuery[] = sqlGetQ('TBL_MAP_USER_DICT');
			
			/* TBL_MAP_USER_TERM */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_MAP_USER_TERM);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_MAP_USER_TERM.'`';
			$arQuery[] = sqlGetQ('TBL_MAP_USER_TERM');
			
			/* TBL_SRCH_RESULTS */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_SRCH_RESULTS);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_SRCH_RESULTS.'`';
			$arQuery[] = sqlGetQ('TBL_SRCH_RESULTS');
			
			/* TBL_CUSTOMPAGES */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_CUSTOMPAGES);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_CUSTOMPAGES.'`';
			$arQuery[] = sqlGetQ('TBL_CUSTOMPAGES');
			$arQuery[] = sqlGetQ('q-pages');
			
			/* TBL_CUSTOMPAGES_PH */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_CUSTOMPAGES_PH);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_CUSTOMPAGES_PH.'`';
			$arQuery[] = sqlGetQ('TBL_CUSTOMPAGES_PH');
			$arQuery[] = sqlGetQ('q-pages_ph');
			/* */
			

			/* TBL_DICT */
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $this->sys['tbl_prefix'].TBL_DICT);
			$arQuery[] = 'DROP TABLE IF EXISTS `'.$this->sys['tbl_prefix'].TBL_DICT.'`';
			$arQuery[] = sqlGetQ('TBL_DICT');
			$arSql = $this->oDb->sqlExec('SELECT * FROM `'.$this->sys['tbl_prefix'].TBL_DICT.'`');
			/* Default dictionary settings */
			$arDictNewSettings = array(
				'min_srch_length' => 2,
				'is_trsp' => '0',
				'is_trns' => '1',
				'is_abbr' => '1',
				'is_defn' => '1',
				'is_usg' => '0',
				'is_src' => '1',
				'is_syn' => '1',
				'is_see' => '1',
				'is_phone' => '0',
				'is_address' => '0',
				'is_show_full' => '0',
				'is_dict_as_index' => '0',
				'is_show_tooltip_defn' => '0',
				'is_filter_specials' => 1,
				'is_filter_stopwords' => 1,
				'is_leech' => 0,
				'is_show_az' => 1,
				'is_sens_num' => 1,
				'is_sens_alp' => 1,
				'is_sens_chr' => 1,
				'is_sens_dia' => 0,
				'ar_filter_stopwords' => array(),
			);
			for (reset($arSql); list($kQ, $arV) = each($arSql);)
			{
				$q1 = array();
				$q1['dict_settings'] = serialize($arDictNewSettings);
				$q1['id']            = $arV['id'];
				$q1['id_tp']         = $arV['id_tp'];
				$q1['is_active']     = 1;
				$q1['lang']          = $arV['lang'];
				$q1['visualtheme']   = isset($arV['themename']) ? $arV['themename'] : $arV['visualtheme'];
				$q1['tablename']     = $arV['tablename'];
				$q1['title']         = $arV['title'];
				$q1['announce']      = $arV['announce'];
				$q1['keywords']      = $arV['keywords'];
				$q1['description']   = $arV['description'];
				$q1['date_created']  = $q1['date_modified'] = gmmktime();
				$q1['id_user']       = 2;
				$arQuery[] = gw_sql_replace($q1, $this->sys['tbl_prefix'].TBL_DICT);
			}
			$this->ar_status[] = sprintf($this->oL->m('up005'), sizeof($arSql));

			/* !!! POSTING QUERIES !!! */
			$is_continue = 1; /* Continue by default */
			for (reset($arQuery); list($k, $v) = each($arQuery);)
			{
				if ($this->sys['is_debug'])
				{
					$this->ar_status[] = $v . ';';
				}
				else
				{
					if (!$this->oDb->sqlExec($v)){
						$is_continue = 0;
						$this->ar_status[] = $this->oL->m('103').' '.$v;
					}
				}
			}
			$this->ar_status[] = sprintf('<a href="%s">'.$this->oL->m('002').'</a>', THIS_SCRIPT.'?step=4');
		}
		else
		{
			$this->ar_status[0] = '';
			$this->ar_status[0] .= ' <span class="red">'.$this->oL->m('102').'</span>';
			return false;
		}
	}
	function step_4()
	{
		include('db_config.php');
		$old_sys = $this->sys;
		$this->sys =& $sys;
		$this->sys = array_merge($old_sys, $this->sys);
		$this->str_before .= '<br /><br />';
		/* TBL_DICT */
		$arSql = $this->oDb->sqlExec('SELECT * FROM `'.$this->sys['tbl_prefix'].TBL_DICT.'` ORDER BY ID');
		
		for (reset($arSql); list($kQ, $arV) = each($arSql);)
		{
			$arQuery = array();
			$this->ar_status[] = sprintf($this->oL->m('up009'),  $arV['tablename']);
			$q1 = array();

			$sql = 'DESCRIBE ' . $arV['tablename'];
			$arD = $this->oDb->sqlExec($sql);
			$arFields = array();
			for (reset($arD); list($kQ2, $fldV) = each($arD);)
			{
				$arFields[] = $fldV['Field'];
			}
			for (reset($arFields); list($kf, $kv) = each($arFields);)
			{
				switch($kv)
				{
					case 'id';
						$arQuery[] = sprintf("REPLACE INTO `%s` (`id`) VALUES ('%s')", $this->sys['tbl_prefix'].TBL_STAT_DICT, $arV['id']);
						unset($arFields[$kf]);
					break;
					/* Remove unused fields */
					case 'id_d';
						$arQuery[] = sprintf('ALTER TABLE `%s` DROP `id_d`', $arV['tablename']);
						unset($arFields[$kf]);
					break;
					case 'hits';
						$arQuery[] = sprintf('ALTER TABLE `%s` DROP `hits`', $arV['tablename']);
						unset($arFields[$kf]);
					break;
					case 'id_user';
						$arQuery[] = sprintf('ALTER TABLE `%s` DROP `id_user`', $arV['tablename']);
						unset($arFields[$kf]);
					break;
					/* Update current fields */
					case 'date_created';
						$arQuery[] = sprintf("ALTER TABLE `%s` CHANGE `date_created` `date_created` INT(10) UNSIGNED DEFAULT '0' NOT NULL", $arV['tablename']);
						$arQuery[] = sprintf("UPDATE `%s` SET `date_created` = '%s'", $arV['tablename'], gmmktime());
						unset($arFields[$kf]);
					break;
					case 'date_modified';
						$arQuery[] = sprintf("ALTER TABLE `%s` CHANGE `date_modified` `date_modified` INT(10) UNSIGNED DEFAULT '0' NOT NULL", $arV['tablename']);
						$arQuery[] = sprintf("UPDATE `%s` SET `date_modified` = '%s'", $arV['tablename'], gmmktime());
					break;
					case 'term_1';
						$arQuery[] = sqlGetQ('16x-170-001', $arV['tablename']);
						unset($arFields[$kf]);
					break;
					case 'term_2';
						$arQuery[] = sqlGetQ('16x-170-002', $arV['tablename']);
						unset($arFields[$kf]);
					break;
					case 'term';
						$arQuery[] = sqlGetQ('16x-170-003', $arV['tablename']);
						unset($arFields[$kf]);
					break;
					case 'defn';
						$arQuery[] = sqlGetQ('16x-170-004', $arV['tablename']);
						unset($arFields[$kf]);
					break;
				}
			}
			/* New fields */
			if (!in_array('int_bytes', $arFields))
			{
				$arQuery[] = sqlGetQ('16x-170-005', $arV['tablename']);
			}
			if (!in_array('is_active', $arFields))
			{
				$arQuery[] = sqlGetQ('16x-170-006', $arV['tablename']);
			}
			if (!in_array('date_modified', $arFields))
			{
				$arQuery[] = sqlGetQ('16x-170-007', $arV['tablename']);
				$arQuery[] = sprintf("UPDATE `%s` SET `date_modified` = '%s'", $arV['tablename'], gmmktime());
			}
			$arQuery[] = sprintf("UPDATE `%s` SET `int_bytes` = LENGTH(defn)", $arV['tablename']);
			$arQuery[] = sprintf("OPTIMIZE TABLE `%s`", $arV['tablename']);
			/* */
			
			/* !!! POSTING QUERIES !!! */
			$is_continue = 1; /* Continue by default */
			for (reset($arQuery); list($k, $v) = each($arQuery);)
			{
				if ($this->sys['is_debug'])
				{
					$this->ar_status[] = $v . ';';
				}
				else
				{
					if (!$this->oDb->sqlExec($v)){
						$is_continue = 0;
						$this->ar_status[] = $this->oL->m('103').' '.$v;
					}
				}
			}
		}
		$this->ar_status[] = sprintf('<a href="%s">'.$this->oL->m('002').'</a>', THIS_SCRIPT.'?step=5');
	}
	function step_5()
	{
		$this->str_before .= '<br/><br/>';

		$is_continue = 0;
		/* Lock installer */
		$this->ar_status[1] = $this->oL->m('088');
		if (!$this->sys['is_debug'])
		{
			$is_continue = $this->oFunc->file_put_contents($this->sys['file_lock'], $this->oL->m('100', $this->sys['file_lock']), 'w');
		}
		if ($is_continue)
		{
			$this->ar_status[1] .= '... Done';
			$is_continue = 0;
		}


		/* COMPLETE */
		$this->ar_status[] = '<b class="green">'.$this->oL->m('up004').'</b>';
		/* Link to administrative interface */
		$login_url =  $this->sys['server_proto'].$this->sys['server_host'].$this->sys['server_dir'] . '/'.$this->sys['path_admin'].'/login.php';
		$this->ar_status[] = 'Login URL: ' . '<a href="' . $login_url . '" target="_blank">' . $login_url.'</a>';

	}
	
	/* */
	function step_novar()
	{
		$this->str_before .= '<br />';
		$this->str_before .= '<p>';
		$this->str_before .= $this->oL->m('025').' '.$this->oL->m('026');
		$this->str_before .= '</p>';
		$this->str_before .= '<ul>';
		$this->str_before .= '<li>'.$this->oL->m('027').' '.sprintf($this->oL->m('028'), THIS_SCRIPT).'</li>';
		$this->str_before .= '<li>'.$this->oL->m('029').' '.sprintf($this->oL->m('030'), 'db_config.php').'</li>';
		$this->str_before .= '</ul>';
	}
	/* */
	function get_form($step)
	{
		$tmp = '';
		$this->oForm->set('formbgcolor',       $this->arTheme['color_2']);
		$this->oForm->set('formbordercolor',   $this->arTheme['color_4']);
		$this->oForm->set('formbordercolorL',  $this->arTheme['color_1']);
		$this->oForm->set('formwidth', '75%');
		$this->oForm->set('action', THIS_SCRIPT);
		$this->oForm->set('isButtonCancel', 0);
		$this->oForm->set('align_buttons', 'right');

		/* 1.7.0 */
		if (MYSQL_VERSION_INT >= 40100) { $this->gv['vars']['arpost']['db_type'] = 'mysql410'; }
		else { $this->gv['vars']['arpost']['db_type'] = 'mysql323'; }

		switch ($step)
		{
			case 2:
				/* Default password */
				if (empty($this->sys['pass_new']))
				{
					$this->sys['pass_new'] = $this->oFunc->text_make_uid(8, 0);
				}
				$tmp .= $this->get_form_title($this->oL->m('094'));
				$tmp .= '<table class="gw2TableFieldset" width="100%">';
				$tmp .= '<tbody><tr><td style="width:30%"></td><td></td></tr>';
				$tmp .= $this->get_form_tr($this->oL->m('095'), $this->oForm->field('input', 'arpost[user_name]', $this->sys['user_name']));
				$tmp .= $this->get_form_tr($this->oL->m('096'), $this->oForm->field('input', 'arpost[user_email]', $this->sys['user_email']));
				$tmp .= $this->get_form_tr($this->oL->m('097'), $this->oForm->field('input', 'arpost[user_login]', $this->sys['user_login']));
				$tmp .= $this->get_form_tr($this->oL->m('098'), $this->oForm->field('input', 'arpost[pass_new]', $this->sys['pass_new']));
#				$tmp .= $this->get_form_tr($this->oL->m('099'), $this->oForm->field('input', 'arpost[pass_confirm]', $this->sys['pass_new']));
				$tmp .= '</tbody></table>';
				$tmp .= $this->get_form_title($this->oL->m('050'));
				$tmp .= '<table class="gw2TableFieldset" width="100%">';
				$tmp .= '<tbody><tr><td style="width:30%"></td><td></td></tr><tbody>';

				$tmp .= $this->get_form_tr($this->oL->m('081'), $this->oForm->field('select', 'arpost[server_proto]', 'http://', '50%', array('http://' => 'http://', 'https://'=> 'https://')));
				$tmp .= $this->get_form_tr($this->oL->m('046'), $this->oForm->field('input', 'arpost[server_host]', $this->sys['server_host']));
				$tmp .= $this->get_form_tr($this->oL->m('048'), $this->oL->m('101').'<br/>'.$this->oForm->field('input', 'arpost[server_dir]', $this->sys['server_dir']));
				$tmp .= '</tbody></table>';
				$tmp .= $this->get_form_title($this->oL->m('049'));
				$tmp .= '<table class="gw2TableFieldset" width="100%">';
				$tmp .= '<tbody><tr><td style="width:30%"></td><td></td></tr><tbody>';
				$tmp .= $this->get_form_tr($this->oL->m('040'), $this->oForm->field('input', 'arpost[dbhost]', $this->gv['vars']['arpost']['dbhost']));
#				$tmp .= $this->get_form_tr($this->oL->m('041'), $this->oForm->field('input', 'arpost[server_proto]', $this->gv['vars']['arpost']['dbport']));

				/* Database types */
				$arDbTypes = array(
				  	'mysql323' => $this->oL->m('031'),
				  	'mysql410' => $this->oL->m('032')
				);
				$tmp .= $this->get_form_tr($this->oL->m('033'), $this->oForm->field('select', 'arpost[db_type]', $this->gv['vars']['arpost']['db_type'], '50%', $arDbTypes));

				/* The list of databases or default databse name */
				$arDatabases = $this->oDb->get_databases();
				if (!empty($arDatabases))
				{
					$tmp .= $this->get_form_tr($this->oL->m('042'), $this->oForm->field('select', 'arpost[dbname]', $this->gv['vars']['arpost']['dbname'], '50%', $arDatabases));
				}
				else
				{
					$tmp .= $this->get_form_tr($this->oL->m('042'), $this->oForm->field('input', 'arpost[dbname]', $this->gv['vars']['arpost']['dbname']));
				}
				$tmp .= $this->get_form_tr($this->oL->m('043'), $this->oForm->field('input', 'arpost[dbprefix]', $this->gv['vars']['arpost']['dbprefix']));
				$tmp .= $this->get_form_tr($this->oL->m('044'), $this->oForm->field('input', 'arpost[dbuser]', $this->gv['vars']['arpost']['dbuser']));
				$tmp .= $this->get_form_tr($this->oL->m('045'), $this->oForm->field('input', 'arpost[dbpass]', $this->gv['vars']['arpost']['dbpass']));
				$tmp .= '</tbody></table>';
			break;
		}
		$tmp .= $this->oForm->field('hidden', 'step', $step+1);
		return '<div class="center">'.$this->oForm->Output($tmp).'</div>';
	}
	/* */
	function get_form_tr($td1, $td2)
	{
		return sprintf('<tr><td class="td1">%s</td><td class="td2">%s</td></tr>', $td1, $td2);
	}
	/* */
	function get_form_title($t)
	{
		return '<div class="r" style="padding:4px;background:'.$this->arTheme['color_4'].'">'.$t.'</div>';
	}
	/* */
	function output()
	{
		$str_status = '';
		if (!empty($this->ar_status))
		{
			$str_status .= '<ul class="gwstatus"><li>' . implode('</li><li>', $this->ar_status) . '</li></ul>';
		}
		$str = '<div class="contents u">';
		$str .= $this->str_step;
		$str .= $this->str_before;
		$str .= $str_status;
		$str .= $this->str_after;
		$str .= '</div>';
		return $str;
	}
}
/* */

/* */


$oInstall = new gw_update;
$gv['vars']['cur_funcname'] = 'step_'.$gv['vars']['step'];
/* Open step number  */
if (in_array(strtolower($gv['vars']['cur_funcname']), get_class_methods($oInstall)))
{
	$oInstall->cur_funcname = $gv['vars']['cur_funcname'];
	$oInstall->step();
}
gw_html_open();
print $oInstall->output();
gw_html_close();

?>