<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: a.import.inc.php,v 1.16 2005/06/09 06:32:02 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  Import. External utility for a dictionary.
 *
 *   <line>
 *    <term>A Term</term>
 *    <defn><abbr>abbreviation</abbr>1st definition</defn>
 *    <defn><trns lang="en.">translation</trns>2nd definition</defn>
 *   </line>
 *
 *  @version $Id: a.import.inc.php,v 1.16 2005/06/09 06:32:02 yrtimd Exp $
 */
// --------------------------------------------------------
/**
 *
 */
function getFormImport($vars, $runtime = 0, $arBroken = array(), $arReq = array())
{
	global ${GW_ACTION}, $id, $oL, $oSess, $arPost, $oFunc, ${GW_SID}, $sys, $oCase;
	$strForm = '';
	$trClass = 't';
	$v_class_1 = 'td1';
	$v_class_2 = 'td2';
	$v_td1_width = '20%';
	
	$form = new gwForms();
	$form->Set('action',          $sys['page_admin']);
	$form->Set('submitok',        $oL->m('3_save'));
	$form->Set('submitdel',       $oL->m('3_remove'));
	$form->Set('submitcancel',    $oL->m('3_cancel'));
	$form->Set('formbgcolor',     $GLOBALS['theme']['color_2']);
	$form->Set('formbordercolor', $GLOBALS['theme']['color_4']);
	$form->Set('formbordercolorL',$GLOBALS['theme']['color_1']);
	$form->Set('align_buttons',   $GLOBALS['sys']['css_align_right']);
	$form->Set('charset', $sys['internal_encoding']);
	// Upload xml-file
	if ($sys['is_upload']) { $form->Set('enctype', 'multipart/form-data'); }
	## ----------------------------------------------------
	##
	 // check vars
	// reverse array keys <-- values;
	$arReq = array_flip($arReq);
	// mark fields as "REQUIRED" and make error messages
	while(is_array($vars) && list($key, $val) = each($vars) )
	{
		$arReqMsg[$key] = $arBrokenMsg[$key] = "";
		if (isset($arReq[$key])) { $arReqMsg[$key] = '&#160;<span style="color:#E30"><b>*</b></span>'; }
		if (isset($arBroken[$key])) { $arBrokenMsg[$key] = ' <span class="'.$trClass.'" style="color:#E30"><b>' . $oL->m('reason_9') .'</b></span>'; }
	} // end of while
	##
	## ----------------------------------------------------

	$strForm .= getFormTitleNav('XML');
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tbody>';
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'" style="width:15%">' . $oL->m('enter_xml') . ':' . $arReqMsg['xml'] . '</td>'.
				'<td class="'.$v_class_2.'">' . $arBrokenMsg['xml'] . '<textarea '.
				' onfocus="if(typeof(document.layers)==\'undefined\'||typeof(ts)==\'undefined\'){ts=1;this.form.elements[\'arPost[\'+\'xml\'+\']\'].select();}"'.
				' style="border:1px solid '.$GLOBALS['theme']['color_5'].';overflow:scroll;word-wrap:normal;width:100%;color:#888;background:'.$GLOBALS['theme']['color_1'].';font:85% \'verdana\',arial,sans-serif"'.
				' onmouseover="javascript:vbform.file_location.value=this.value" name="arPost[xml]" cols="70" rows="12">' . textcodetoform($vars['xml']) . '</textarea>'.
				'</td>'.
				'</tr>';
	/* 3 mar 2003 */
	/* Allows to upload a file */
	if ($sys['is_upload'])
	{
		$strForm .= '<tr>'.
					'<td class="'.$v_class_1.'">' . '&#160;' . '' . $arReqMsg['file_location'] . '</td>'.
					'<td class="'.$v_class_2.'">' . $arBrokenMsg['file_location'] . $form->field('file', 'file_location', $vars['file_location']) . '</td>'.
					'</tr>';
	}
	$strForm .= '<tr>'.
				'<td class="'.$v_class_1.'"></td>'.
				'<td class="'.$v_class_2.'">';

		$vars['is_validate'] = $oSess->user_get('import_is_validate') ? 1 : 0;
		$vars['is_overwrite'] = $oSess->user_get('import_is_overwrite') ? 1 : 0;
		$vars['is_specialchars'] = $oSess->user_get('import_is_specialchars') ? 1 : 0;
		$vars['is_whitespace'] = $oSess->user_get('import_is_whitespace') ? 1 : 0;
		$vars['is_convert_esc'] = $oSess->user_get('import_is_convert_esc') ? 1 : 0;

		/*  1.7.0 */
		$objCells = new htmlRenderCells();
		$objCells->tClass = '';
		$arFieldsStr = array();
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle">'.
							 '<td style="width:2%">' . $form->field('checkbox', "arPost[is_validate]", $vars['is_validate']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_validate_">' . $oL->m('validate') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle">'.
							 '<td style="width:2%">' . $form->field('checkbox', "arPost[is_overwrite]", $vars['is_overwrite']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_overwrite_">' . $oL->m('overwrite') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle">'.
							 '<td style="width:2%">' . $form->field('checkbox', "arPost[is_specialchars]", $vars['is_specialchars']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_specialchars_">' . $oL->m('is_specialchars') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle">'.
							 '<td style="width:2%">' . $form->field('checkbox', "arPost[is_convert_esc]", $vars['is_convert_esc']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_convert_esc_">' . $oL->m('1040') . '</label></td>'.
							 '</tr>'.
							 '</table>';
			$arFieldsStr[] = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'.
							 '<tr style="vertical-align:middle">'.
							 '<td style="width:2%">' . $form->field('checkbox', "arPost[is_whitespace]", $vars['is_whitespace']) . '</td>'.
							 '<td style="width:98%"><label for="arPost_is_whitespace_">' . $oL->m('1039') . '</label></td>'.
							 '</tr>'.
							 '</table>';
		$objCells->X = 2;
		$objCells->Y = 99;
		$objCells->ar = $arFieldsStr;
		$strForm .= $objCells->RenderCells();

	$strForm .= '</td>';
	$strForm .= '</tr>';
	$strForm .= '</tbody>';
	$strForm .= '</table>';

	/* After posting... */
	$strForm .= getFormTitleNav($oL->m('options'));
	$tmp['after_post'] = $oSess->user_get('after_post_import');
	if (!$tmp['after_post'])
	{
		/* turn on "Import" option by default */
		$tmp['after_post'] = 4;
	}
	$tmp['ar_after_posting'] = array(
		4 => $oL->m('3_import'),
		1 => $oL->m('after_post_1'),
		3 => $oL->m('after_post_3')
	);
	$form->setTag('select', 'class',  'input50');
	$strForm .= '<table class="gw2TableFieldset" width="100%">';
	$strForm .= '<tr><td style="width:15%"></td><td></td></tr>';
	$strForm .= '<tr>'.
				'<td class="td1">' . $oL->m('after_post') . '</td>'.
				'<td class="td2">' . $form->field('select', 'arPost[after]', $tmp['after_post'], '', $tmp['ar_after_posting']).
				'</td>'.
				'</tr>';
	$strForm .= '</table>';
	

	$strForm .= $form->field("hidden", 'id', $id);
	$strForm .= $form->field("hidden", GW_TARGET, GW_T_DICT);
	$strForm .= $form->field("hidden", GW_ACTION, IMPORT);
	$strForm .= $form->field("hidden", GW_SID, ${GW_SID});

	if ($arPost[GW_ACTION] == GW_A_ADD)
	{
		$strForm .= $form->field("hidden", 'arPost['.GW_ACTION.']', GW_A_ADD);
	}
	else
	{
		$strForm .= $form->field("hidden", 'arPost['.GW_ACTION.']', UPDATE);
	}
	return $form->Output($strForm);
} // end of getFormImport()
// --------------------------------------------------------
// Prepare variables
if ($arPost == '') { $arPost = array(); }
if (!isset($arPost[GW_ACTION])) { $arPost[GW_ACTION] = GW_A_ADD; }
$vars['is_overwrite']    = isset($arPost['is_overwrite']) ? $arPost['is_overwrite'] : 0;
$vars['is_validate']     = isset($arPost['is_validate']) ? $arPost['is_validate'] : 0;
$vars['is_specialchars'] = isset($arPost['is_specialchars']) ? $arPost['is_specialchars'] : 0;
$vars['is_whitespace']   = isset($arPost['is_whitespace']) ? $arPost['is_whitespace'] : 1;
$vars['is_convert_esc']  = isset($arPost['is_convert_esc']) ? $arPost['is_convert_esc'] : 0;
$vars['is_active']       = isset($arPost['is_active']) ? $arPost['is_active'] : 1;
$vars['file_location'] = $file_location;
$arReq['dict'] = array('xml');

switch ($arPost[GW_ACTION])
{
case GW_A_ADD:
## --------------------------------------------------------
## Show HTML-form
	/* Check permission */
	if (!isset($id) || (!$oSess->is('dict_edit')) )
	{
		$strR .= $oL->m('reason_13');
		return;
	}
if ($post == '')
{
	/* Not saved */
	$cntFiles = 1;
	$vars['xml'] = '';
	$strR .= getFormImport($vars, 0, 0, $arReq[$t]);
	$arHelpMap = array(
					'enter_xml' => htmlspecialchars('<line><term>A Term</term><trsp></trsp><defn><abbr>abbreviation</abbr>First definition</defn><defn><trns lang="103">translation</trns>Second definition</defn></line>'),
					'validate'  => 'tip011',
					'overwrite' => 'tip012',
					'is_specialchars' => 'tip013',
					'1040' => 'tip027',
					'1039' => 'tip026',
				 );
	$strHelp = '';
	$strHelp .= '<dl>';
	for (; list($k, $v) = each($arHelpMap);)
	{
		$strHelp .= '<dt><b>' . $oL->m($k) . '</b></dt>';
		$strHelp .= '<dd>' . $oL->m($v) . '</dd>';
	}
	$strHelp .= '</dl>';
	$strR .= '<br />' . kTbHelp($oL->m('2_tip'), $strHelp);
}
else 
{
	/* Start import */
	$objTimer = new gw_timer;

	@set_time_limit(3600);
	/* Fix on/off options */
	$arIsV = array('is_validate', 'is_overwrite', 'is_specialchars', 'is_whitespace', 'is_convert_esc');
	for (; list($k, $v) = each($arIsV);)
	{
		$arPost[$v]  = isset($arPost[$v]) ? $arPost[$v] : 0;
	}
	/* Save user settings */
	$oSess->user_set('import_is_validate', $arPost['is_validate']);
	$oSess->user_set('import_is_overwrite', $arPost['is_overwrite']);
	$oSess->user_set('import_is_specialchars', $arPost['is_specialchars']);
	$oSess->user_set('import_is_whitespace', $arPost['is_whitespace']);
	$oSess->user_set('import_is_convert_esc', $arPost['is_convert_esc']);

	$arBroken = validatePostWalk($arPost, $arReq[$t]);
	/* remove xml field from broken fields if file location exists */
	if (isset($arBroken['xml']) && $vars['file_location'] != '')
	{
		unset($arBroken['xml']);
	}
	if (sizeof($arBroken) == 0) // no broken fields
	{
		$isPostError = 0;
	}
	if (!$isPostError) // single check is ok
	{
		/* Uploaded file */
		$xml_file = isset($file_location['tmp_name']) ? $file_location['tmp_name'] : '';
		if (is_uploaded_file($xml_file)
			&& move_uploaded_file($xml_file, $sys['path_temporary'].'/'.urlencode($file_location['name']))
			)
		{
			$arPost['xml'] = $oFunc->file_get_contents($sys['path_temporary'].'/'.urlencode($file_location['name']));
			unlink($sys['path_temporary'].'/'.urlencode($file_location['name']));
		}
		/* XML-syntax check */
		if ($vars['is_validate'] && function_exists('xslt_create'))
		{
			/* Fix header if there are single <line>'s only */
			if (preg_match("/^([\s])*<line/", $arPost['xml']))
			{
				$arPost['xml'] = '<?xml version="1.0" encoding="'.$sys['internal_encoding'].'"?>' . CRLF.
								 '<glossword>' . CRLF . $arPost['xml'] . '</glossword>';
			}
			include_once( $sys['path_include']. '/class.xmlparse.' . $sys['phpEx'] );
			$xml_parser =& new xmlTinyParser();
			$return = $xml_parser->parse($arPost['xml']);
			if (!$return)
			{
				// Uploaded file can be too big
				// so we do not need to put file contents into HTML-form
				// show filename instead
				if (file_exists($xml_file) && is_uploaded_file($xml_file))
				{
					$arPost['xml'] = $file_location['name'];
				}
				$arBroken['xml'] = $isPostError = 1;
			}
		}
	}
	if ($isPostError)
	{
		/* Call HTML-form again */
#		$arPost['is_overwrite'] = isset($arPost['is_overwrite']) ? $arPost['is_overwrite'] : 0;
#		$arPost['is_validate'] = isset($arPost['is_validate']) ? $arPost['is_validate'] : 0;
#		$arPost['is_specialchars'] = isset($arPost['is_specialchars']) ? $arPost['is_specialchars'] : 0;
#		$arPost['is_whitespace'] = isset($arPost['is_whitespace']) ? $arPost['is_whitespace'] : 0;
#		$arPost['is_convert_esc'] = isset($arPost['is_convert_esc']) ? $arPost['is_convert_esc'] : 0;
		$strR .= getFormImport($arPost, 1, $arBroken, $arReq[$t]);
	}
	else
	{
		/* Final update */
		
		/* Escape sequences */
		if ($arPost['is_convert_esc'])
		{
			$ar_esc = array('\r\n' => "\r\n", '\n' => "\n", '\r' => "\r", '\t' => "\t");
			$arPost['xml'] = str_replace(array_keys($ar_esc), array_values($ar_esc), $arPost['xml']);
		}
		/* Whitespace characters */
		if (!$arPost['is_whitespace'])
		{
			$arPost['xml'] = preg_replace("/(\r\n|\r|\n|\t)/", ' ', $arPost['xml']);
		}
		$objDom = new gw_domxml;
		$cnt = 0;
		$queryA = array();
		$sfA1 = explode("<line>", $arPost['xml']); // should be changed to DOM model
		/* Get stopwords */
		$arStop = gw_get_stopwords($arDictParam);
		/* Prepare allowed special chars */
		if ($arPost['is_specialchars'])
		{
			$oCase->reload(array(1,2,3,4,5,6,7,8), array());
		}
		else
		{
			$oCase->reload(array(1,2,3,4,5,6,7,8), array(1,2,3,4,5));
		}
		/* Enter debug mode. None of `INSERT' or `DELETE' queries will be executed. */
#        $sys['isDebugQ'] = 1;
#		error_reporting(E_ALL ^ E_NOTICE);
		if (is_array($sfA1)) // <line> found
		{
			for (reset($sfA1); list($k1, $v1) = each($sfA1);) // for each <line>
			{
				$arPre = array();
				$v1 = str_replace('</line>', '', $v1);
				$v1 = str_replace('</glossword>', '', $v1);
				$v1 = str_replace('<glossword>', '', $v1);
				//
				// Parse term parameters
				preg_match_all("/<term(.*?)>/", $v1, $term_attr);
				if (isset($term_attr[1][0]))
				{
					$v1 = preg_replace("/<term(.*?)>/", '<term>', $v1);
					$term_attr[1][0] = str_replace('"', '', $term_attr[1][0]);
					$arAttr = explode(" ", trim($term_attr[1][0]));
					for (reset($arAttr); list($attrK, $attrV) = each($arAttr);)
					{
						$arAttrV = explode('=', $attrV);
						if (isset($arAttrV[1]))
						{
							$arPre['term'][0]['attributes'][$arAttrV[0]] = $arAttrV[1];
						}
						if ($vars['is_active'])
						{
							$arPre['term'][0]['attributes']['is_active'] = 1;
						}
					}
					$arPre['term'][0]['tag'] = 'term';
				}
				$arPre = array_merge_clobber($arPre, gw_Xml2Array($v1));
				//
				$arPre['parameters']['xml'] = preg_replace("/<term>(.*?)<\/term>/", '', $v1);
				//
				if ( isset($arPre['term']) ) // parsed terms only
				{
					$i = 0;
					$arPre['parameters']['action'] = ${GW_ACTION};
					//
					// Prepare definition
					$ar = gwAddTerm($arPre, $id, $arStop, 1, $arPost['is_specialchars'], $arPost['is_overwrite'], $k1);
					if (is_array($ar))
					{
						if ($sys['isDebugQ'])
						{
							$queryA = array_merge($queryA, $ar);
						}
						else
						{
							/* Post queries */
							for (reset($ar); list($qk, $qv) = each($ar);)
							{
								if ($oDb->sqlExec($qv)){ $isPostError = false; }
							}
						}
						$cnt++;
					}
					else // on error
					{
						$strR .= $ar;
					}
				} // end of only childrens
			} // end of for each <line>
			//
			// Clean search results for edited dictionary
			$queryA[] = $oSqlQ->getQ('del-srch-by-dict', $d);
			//
			// Clear dictionary cache (hidden)
			gw_tmp_clear($id);
			//
			// Show time usage
			//
			$strR .= '<table cellpadding="2" cellspacing="1" width="100%" border="0">';
			if (@ini_get('max_execution_time'))
			{
				$strR .= '<tr class="t"><td>max_execution_time:</td><td><b>' . @ini_get('max_execution_time') . '</b> seconds</td></tr>';
			}
			$strR .= '<tr class="t"><td style="width:25%">php_running_time:</td>';
			$strR .= '<td style="width:75%"><b>' . sprintf("%1.5f", $objTimer->end()) . '</b> seconds</td></tr>';
			if (($xml_file != '') && ($xml_file != 'none'))
			{
				$strR .= '<tr class="t"><td>local file:</td><td><b>' . $xml_file. '</b></td></tr>';
				$strR .= '<tr class="t"><td>uploaded file:</td><td><b>' . $file_location['name'] . '</b></td></tr>';
				$strR .= '<tr class="t"><td>'. sprintf("%s:</td><td><b>%s</b> %s</td></tr>", $oL->m('size'), $oFunc->number_format($file_location['size'], 0, $oL->languagelist('4')), $oL->m('bytes'));
			}
			$intAddedTerms = $cnt;
			$strR .= '<tr class="t"><td>'. sprintf("%s:</td><td><b>%s</b></td></tr>", $oL->m('str_on_page'), $intAddedTerms);
			$strR .= '</table>';
			//
			/* Redirect to... */
			$str_url = gw_after_redirect_url($arPost['after']);
			$strR .= postQuery($queryA, $str_url, $sys['isDebugQ'], 1);
		} // is_array, <line> found
	} // final update
} // submitted
##
## --------------------------------------------------------
break;
default:
break;
} // end of switch

/* End of file */
?>