<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: constants.inc.php,v 1.17 2005/06/07 17:27:09 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/) 
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  page numbers, url parameters, navigation map, dictionary fields
 *   
 *  Configuration scheme:
 *  index -> config.inc -> lib.prepend, constants.inc -> custom.inc
 *                                      ^^^^^^^^^^^^^
 */
if (!defined('GW_DB_HOST')){ define('GW_DB_HOST', 'localhost'); }
if (!defined('GW_DB_DATABASE')){ define('GW_DB_DATABASE',  'glossword1'); }
if (!defined('GW_DB_USER')){ define('GW_DB_USER',  'root'); }
if (!defined('GW_DB_PASSWORD')){ define('GW_DB_PASSWORD',  'root'); }
if (!isset($sys['tbl_prefix'])){ $sys['tbl_prefix'] = ''; }
// --------------------------------------------------------
// Database table names
define('TBL_AUTH',          $sys['tbl_prefix'] . 'auth');
define('TBL_DICT',          $sys['tbl_prefix'] . 'dict');
define('TBL_TPCS',          $sys['tbl_prefix'] . 'tpcs');
define('TBL_STAT_DICT',     $sys['tbl_prefix'] . 'stat_dict');
define('TBL_SETTINGS',      $sys['tbl_prefix'] . 'settings');
define('TBL_SESS',          $sys['tbl_prefix'] . 'sessions');
define('TBL_USERS',         $sys['tbl_prefix'] . 'users');
define('TBL_MAP_USER_DICT', $sys['tbl_prefix'] . 'map_user_to_dict');
define('TBL_MAP_USER_TERM', $sys['tbl_prefix'] . 'map_user_to_term');
define('TBL_WORDLIST',      $sys['tbl_prefix'] . 'wordlist');
define('TBL_WORDMAP',       $sys['tbl_prefix'] . 'wordmap');
define('TBL_SRCH_RESULTS',  $sys['tbl_prefix'] . 'search_results');
define('TBL_CUSTOMPAGES',   $sys['tbl_prefix'] . 'pages');
define('TBL_CUSTOMPAGES_PH',$sys['tbl_prefix'] . 'pages_phrase');
// --------------------------------------------------------
// Critical system constants. DO NOT EDIT.
// --------------------------------------------------------
// Action URL parameters
define('GW_SID',          'sid');
define('GW_ID_DICT',      'd');
// '?index.php?a=[...]&t=topics' calls file '[...]_topic.at.php'
define('GW_ACTION',       'a');
define('BRWS',            'browse');
define('CFG',             'cfg');
define('CLEAN',           'clean');
define('EXPORT',          'export');
define('GW_A_ADD',        'add');
define('GW_A_EDIT',       'edit');
define('GW_A_LIST',       'list');
define('GW_A_MAINTENANCE','maintenance');
define('GW_A_PRINT',      'print');
define('GW_A_REMOVE',     'remove');
define('GW_A_SEARCH',     'srch');
define('IMPORT',          'import');
define('NEWPASS',         'newpass');
define('PROFILE',         'profile');
define('REG',             'register');
define('STATS',           'stats');
define('UPDATE',          'update');
// --------------------------------------------------------
// Target URL parameters
// '?index.php?a=import&t=[...]' calls file 'import_[...].at.php'
define('GW_TARGET', 't');
define('TPCS',      'topic');
define('GW_T_DICT', 'dict');
define('GW_T_TERM', 'term');
define('TPL',       'template');
define('SYS',       'sys');
define('USER',      'user');
define('GW_T_CUSTOMPAGE','page');
// --------------------------------------------------------
define('GW_LANG_I', 'il');
define('GW_LANG_C', 'cl');
// --------------------------------------------------------
/* -------------------------------------------------------- */
/* Switches */
define('GW_AFTER_DICT_UPDATE', 1);
define('GW_AFTER_TERM_ADD', 2);
define('GW_AFTER_SRCH_BACK', 3);
define('GW_AFTER_TERM_IMPORT', 4);


/* Page numbers */
$arPageNumbers = array(
	'index' => 1,
	TPCS.'_'.BRWS => 2,
	TPCS.'_'.GW_A_ADD => 3,
	TPCS.'_'.GW_A_EDIT => 4,
	TPCS.'_'.GW_A_REMOVE => 5,
	GW_T_DICT.'_'.BRWS => 6,
	GW_T_DICT.'_'.GW_A_ADD => 7,
	GW_T_DICT.'_'.GW_A_EDIT => 8,
	GW_T_DICT.'_'.GW_A_REMOVE => 9,
	GW_T_DICT.'_'.UPDATE => 10,
	GW_T_DICT.'_'.CLEAN => 11,
	GW_T_DICT.'_'.IMPORT => 12,
	GW_T_DICT.'_'.EXPORT => 13,
	GW_T_TERM.'_'.GW_A_ADD => 14,
	GW_T_TERM.'_'.GW_A_EDIT => 15,
	GW_T_TERM.'_'.GW_A_REMOVE => 16,
	GW_T_TERM.'_'.UPDATE => 17,
	'_'.GW_A_SEARCH => 18,
	SYS.'_'.CFG => 19,
	SYS.'_'.GW_A_MAINTENANCE => 25,
	GW_T_CUSTOMPAGE.'_'.BRWS => 26,
	GW_T_CUSTOMPAGE.'_'.GW_A_ADD => 27,
	GW_T_CUSTOMPAGE.'_'.GW_A_EDIT => 28,
	GW_T_CUSTOMPAGE.'_'.GW_A_REMOVE => 29,
	GW_T_CUSTOMPAGE.'_'.UPDATE => 30,
	USER.'_'.REG => 20,
	USER.'_'.PROFILE => 21,
	USER.'_'.NEWPASS => 22,
	USER.'_'.UPDATE => 23,
	USER.'_'.BRWS => 24,
	USER.'_'.GW_A_REMOVE => 31
);
// --------------------------------------------------------
// Navigation
$arNav = array(
	TPCS => array(BRWS, GW_A_ADD, GW_A_EDIT, GW_A_REMOVE),
	GW_T_DICT => array(BRWS, GW_A_ADD, GW_A_EDIT, GW_A_REMOVE, CLEAN, IMPORT, EXPORT),
	GW_T_TERM => array(BRWS, GW_A_ADD, GW_A_EDIT, GW_A_REMOVE),
	SYS  => array(CFG, GW_A_MAINTENANCE),
	GW_T_CUSTOMPAGE => array(BRWS, GW_A_ADD, GW_A_EDIT, GW_A_REMOVE),
	USER => array(BRWS, REG, PROFILE)
);
// --------------------------------------------------------
// Dictionary fields:
// - Field name (latin characters only)
// - Type [ textarea | input ]
// - Search index length [ 0 - off | 1..9 | auto ]
// - Is multiple records (split each item with a new line)
// - Is root element (<line><term>..<trsp>..<defn>..</line>)
// - index for CSV-export/import
// Array keys cannot be changed, i.e. 2 always transcription.
$arFields = array(
				1 => array('term',    'input',    'auto', 0,  1, 0),
				2 => array('trsp',    'textarea', 'auto', 1,  1, 3),
				0 => array('defn',    'textarea', 'auto', 1,  1, 4),
				3 => array('abbr',    '',         '',     '', 0, 5),
				4 => array('trns',    '',         '',     '', 0, 6),
				5 => array('usg',     'textarea', 'auto', 1,  0, 7),
				6 => array('src',     'textarea', 0,      0,  0, 10),
				7 => array('syn',     'textarea', 1,      1,  0, 9),
				8 => array('see',     'textarea', 1,      1,  0, 8),
				9 => array('address', 'textarea', 2,      0,  0, 11),
				10 => array('phone',  'textarea', 2,      0,  0, 12),
			);
$intFields = count($arFields);
// --------------------------------------------------------

/* end of file */
?>