<?php
if (!defined('IN_GW'))
{
	die('<!-- $Id: constructor.inc.php,v 1.30 2005/06/09 06:55:30 yrtimd Exp $ -->');
}
/**
 *  Glossword - glossary compiler (http://glossword.info/dev/)
 *   2002-2005 Dmitry N. Shilnikov <dev at glossword.info>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  (see `glossword/support/license.html' for details)
 */
// --------------------------------------------------------
/**
 *  General page constructor.
 */
// --------------------------------------------------------
/* default template */
$tplConstructList = $tplConstructAdd = 'index.html';
$str_current_section = '';
$tmp['str_defn'] = '';
// --------------------------------------------------------
// because this is a basic constructor for the whole site,
// we need to separate templates between dictionary and website
if ($layout != '') // settings for all dictionary pages
{
	if ( ($layout == 'index') || ($layout == GW_A_LIST) || ($layout == 'term') )
	{
		if ( empty($arDictParam) || !isset($arDictParam['title']) )
		{
			gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_index']);
		}
	}
	if ( $gw_this['vars'][GW_ID_DICT] > 0 ) // dictionary pages
	{
		// hits + 1 for non-localhost installations
		if (!IS_MYHOST)
		{
			$oDb->sqlExec($oSqlQ->getQ('up-dict-hits', $gw_this['vars'][GW_ID_DICT]), '', 0);
		}
		$mktCreated = $oFunc->date_Ts14toTime($arDictParam['date_created']);
		// 1.3.9
		// Sets last modified date for all dictionary pages (!)
		if ($sys['is_cache_http'])
		{
			// first header
			$oHdr->add("Last-Modified: " . date("D, d M Y H:i:s", $mktCreated) . ' GMT');
		}
		// Dictionary table name, Depreciated variable
		$DBTABLE = $arDictParam['tablename'];
		// Do we need to link main page from main page? No.
		if ($layout == 'index')
		{
			$oTpl->addVal("DICT_NAME_LINKED", $arDictParam['title']);
		}
		else
		{
			$oTpl->addVal("DICT_NAME_LINKED", $oHtml->a($sys['page_index'] . '?a=index&d=' . $gw_this['vars'][GW_ID_DICT], $arDictParam['title']));
		}
		$oTpl->addVal("DICT_NAME",  $arDictParam['title']);
		$oTpl->addVal("DICT_DESCR", $arDictParam['description']);
		$oTpl->addVal("DICT_SIZE",  $oFunc->number_format($arDictParam['int_terms'], 0, $oL->languagelist('4')));
		/* 1.7.0 */
		$oTpl->addVal( 'L_BROWSE_PAGES', $oHtml->a($sys['page_index'] . '?a='.GW_A_LIST.'&'.GW_ID_DICT.'=' . $gw_this['vars'][GW_ID_DICT].'&p=1', 
						$oFunc->number_format(ceil($arDictParam['int_terms']/$sys['page_limit']), 0, $oL->languagelist('4')) .' ('. $oL->m('3_browse').')')
					);
		// letters 0-Z
		if ($arDictParam['is_show_az'] == 1) // show or hide letters toolbar
		{
			// Always constructs A-Z toolbar (single letters)
			$ar0z = getLettersArray($gw_this['vars'][GW_ID_DICT]);
			// arrays, dictionary ID, current letter, isLinked, isLine;
			if ((${GW_ACTION} != GW_T_TERM) && (${GW_ACTION} != GW_A_SEARCH))
			{
				$oTpl->addVal("AZ", getLetterHtml($ar0z, $gw_this['vars'][GW_ID_DICT], $w1 . ' ') );
			}
		}
		$oTpl->addVal( "INT_D", $gw_this['vars'][GW_ID_DICT] );
	}
	else // non-dictionary pages (top10, feedback, title page)
	{
		if ($sys['is_cache_http'])
		{
			$oHdr->add("Last-Modified: " . gmdate("D, d M Y H:i:s") . ' GMT');
		}
	}
} // end of dictionary pages
// Language settings, from Translation Kit
$oTpl->addVal( 'LANG',           $oL->languagelist("0") );
$oTpl->addVal( 'TEXT_DIRECTION', $oL->languagelist("1") );
$oTpl->addVal( 'CHARSET',        $oL->languagelist("2") );
// 11 december 2002, r-t-l with l-t-r
$sys['css_align_right'] = 'right';
$sys['css_align_left'] = 'left';
if ($oL->languagelist('1') == 'rtl')
{
	$sys['css_align_right'] = 'left';
	$sys['css_align_left'] = 'right';
}
$oTpl->addVal( "CSS_ALIGN_RIGHT", $sys['css_align_right']);
$oTpl->addVal( "CSS_ALIGN_LEFT",  $sys['css_align_left']);
// other variables
$oTpl->addVal( "q",               '');
$oTpl->addVal( "U_TO_MAIN",       $oHtml->url_normalize($sys['page_index']) );
$oTpl->addVal( "PATH_DICT",       append_url($sys['page_index'].'?a=index&'.GW_ID_DICT.'='.$gw_this['vars'][GW_ID_DICT]) );
$oTpl->addVal( "L_TO_MAIN",       $oL->m('3_tomain'));
$oTpl->addVal( "L_TOP_OF_PAGE",   $oL->m('3_top'));
$oTpl->addVal( "GLOSSWORDVERSION",$sys['version']);
$oTpl->addVal( "FORM_ACTION",     $sys['page_index'] );
$oTpl->addVal( "L_TERMS_AMOUNT",  $oL->m('termsamount'));
$oTpl->addVal( "URL_MAILTO",      $oFunc->text_mailto('<a href="mailto:'.$sys['y_email'].'">'. $sys['y_name'] . '</a>'));
$oTpl->addVal( "NOURL_MAILTO",    $sys['y_name']);
$oTpl->addVal( "SITE_NAME",       $sys['site_name'] );
$oTpl->addVal( "L_SRCH_STRICT",   $oL->m('srch_strict') );
$oTpl->addVal( 'path_root',       $sys['server_dir'] );
$oTpl->addVal( 'href:home',       $sys['server_dir'].'/index.php' );


$tmp['input_url_append'] = '';
/* Append URL for integration */
for (reset($sys['ar_url_append']); list($k, $v) = each($sys['ar_url_append']);)
{
	$tmp['input_url_append'] .= '<input type="hidden" name="'.$k.'" value="'.$v.'" />';
}
$oTpl->addVal( "v:input_url_append", $tmp['input_url_append'] );
/* */
switch ($layout)
{
	case 'index': // Dictionary title page
	{
		$str_current_section = '';
		$ar_tpl_construct = array( "header.html", "search_form.html", "menu_letters_az.html",
								"dict_about.html", "footer_inside.html");
		$oTpl->addVal( "T_LASTADDED",         getTop10('R_TERM_NEWEST') );
		$oTpl->addVal( "DICT_MODIFIED",       sprintf("%s: %s", $oL->m('date_modif'), date_extract_int($arDictParam['date_modified'], "%d %F %Y") ));
		$oTpl->addVal( 'L_PAGES',   $oL->m('L_pages'));
	}
	break;
	case GW_A_LIST:
	{
		/* Build the list of terms for preview */
		$str_current_section = '';
		$oTpl->addVal("L_PAGES",         '');
		$oTpl->addVal("PAGE_SELECTION",  '');
		$ar_tpl_construct = array( 'header.html', 'search_form.html', 'menu_letters_az.html');

		if (($w1 != '') && ($w2 == ''))
		{
			/* 0-Z */
			$listA = getDictWordList($w1, $w2, $gw_this['vars'][GW_ID_DICT], $p, 1, $arDictParam['is_show_full']);
			$gw_this['arTitle'][0] = $w1;
		}
		elseif (($w1 != '') && ($w2 != ''))
		{
			/* 00-ZZ */
			$listA = getDictWordList($w1, $w2, $gw_this['vars'][GW_ID_DICT], $p, 1, $arDictParam['is_show_full']);
			$gw_this['arTitle'][0] = $w2;
		}
		else
		{
			/* By page */
			$listA = getDictWordList($w1, $w2, $gw_this['vars'][GW_ID_DICT], $p, 1, $arDictParam['is_show_full']);
			if ($p > 1)
			{
				$gw_this['arTitle'][0] = $p;
			}
		}
		$oTpl->addVal('block:term_list', $listA[0]);
		$sys['total'] = $listA[1];
		$intSumPages = $listA[3];
		if ($intSumPages > 1)
		{
			$oTpl->addVal("L_PAGES", $oL->m('L_pages').':');
		}
		// checking page numbers
		if ( ( $p < 1 ) || ( $p > $intSumPages) ){ $p = 1; }

		if ($arDictParam['is_show_az']) // show or hide letters toolbar
		{
			// $w1 already selected
			$oTpl->addVal( "AAZZ", getLetterHtml( $ar0z, $gw_this['vars'][GW_ID_DICT], $w1, $w2 . ' ') );
			$ar_tpl_construct[] = "menu_letters_aazz.html";
		}
		if ($intSumPages > 1)
		{
			$oTpl->addVal( "PAGE_SELECTION", getNavToolbar($intSumPages, $p, $sys['page_index'] . '?'.GW_ACTION.'='.$layout.'&strict='.$strict.'&d='.$gw_this['vars'][GW_ID_DICT].'&w1='.urlencode($w1).'&w2='.urlencode($w2).'&p='));
		}
		$ar_tpl_construct[] = '../common/term_list.html';
		$ar_tpl_construct[] = "menu_pages.html";
		$ar_tpl_construct[] = "footer_inside.html";
	}
	break;
	case GW_T_TERM:
	{
		/* Term selected */
		$str_current_section = '';
		$oTpl->addVal( 'PAGE_SELECTION', '');
		$oTpl->addVal( 'T_LASTADDED',    getTop10('R_TERM_NEWEST', 10, 1) );
		$oTpl->addVal( 'PATH_IMG_DICT',  $sys['path_img'] . '/' . sprintf('%05d', $gw_this['vars'][GW_ID_DICT]) );
		$oTpl->addVal( 'L_TERM_LINK',    $oL->m('page_link_term'));
		$oTpl->addVal( 'L_DICT_LINK',    $oL->m('page_link_dict'));
		// -------------------------------------------------
		// Load HTML-templates
		if ($isPrint)
		{
			$ar_tpl_construct = array("header_print.html", "search_form_print.html");
		}
		else
		{
			$ar_tpl_construct = array("header.html", "search_form.html");
			if ($arDictParam['is_show_az']) // show or hide alphabetic toolbar
			{
				$ar_tpl_construct[] = "menu_letters_az.html";
				$ar_tpl_construct[] = "menu_letters_aazz.html";
			}
		}
		// -------------------------------------------------
		// Get term parameters
		$listA = getTermParam($t, $q);
		// Redirect to dictionary title page if no definition found for specified Term ID
		if (!isset($listA['defn']))
		{
			gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_index'].'?a=list&d=' . $gw_this['vars'][GW_ID_DICT]);
		}
		/* State: Term parameters were taken */

		/* 25 may 2002: ?a=term&d=55&t=1 */
		$gw_this['term_linked'] = strip_tags($listA['term']);
		$gw_this['term_linked'] = str_replace('/', ' ', $gw_this['term_linked']);
		$gw_this['term_linked'] = preg_replace("/\s{2,}/" , ' ', $gw_this['term_linked']);
		$gw_this['term_linked'] = urlencode($gw_this['term_linked']);
		$oTpl->addVal( 'TERM_URL',
						$oHtml->a(
							$sys['server_proto'] . $sys['server_host'] . $sys['page_index']. '?a=term&d=' . $gw_this['vars'][GW_ID_DICT] . '&t=' . $listA['tid'],
							$sys['server_proto'] . $sys['server_host'] . $sys['page_index']. '?a=term&d=' . $gw_this['vars'][GW_ID_DICT] . '&t=' . $listA['tid']
						)
		);
		$oTpl->addVal( 'DICT_URL',
						$oHtml->a(
							$sys['page_index']. '?a=list&d=' . $gw_this['vars'][GW_ID_DICT],
							$sys['server_proto'] . $sys['server_host'] . $oHtml->url_normalize($sys['page_index']. '?a=list&d=' . $gw_this['vars'][GW_ID_DICT])
						)
		);
		// -------------------------------------------------
		// Printable version
		$listA['term_length'] = $oFunc->mb_strlen( $listA['term'] );
		$gw_this['href_print'] = $oHtml->a($sys['page_index'].'?a='.GW_A_PRINT.'&d='. $gw_this['vars'][GW_ID_DICT].'&t='.$listA['tid'], $oL->m('printversion'));
		// -------------------------------------------------
		// Process automatic functions
		if (!empty($gw_this['vars']['funcnames'][GW_T_TERM]))
		{
			for (; list($k, $v) = each($gw_this['vars']['funcnames'][GW_T_TERM]);)
			{
				if (function_exists($v))
				{
					$v();
				}
			}
		}
		// -------------------------------------------------
		$tmp['cssTrClass'] = 't';
		$tmp['xref'] = $sys['page_index'] . '?a=term&amp;d=' . $gw_this['vars'][GW_ID_DICT] . '&amp;q=';
		$tmp['href_srch_term'] = $oHtml->url_normalize($sys['page_index'] . '?a=srch&in=term&d=%d&q=%s&strict=1');
		$tmp['href_link_term'] = $oHtml->url_normalize($sys['page_index'] . '?a=term&d=%d&q=%s');
		$arDictParam['lang'] = $gw_this['vars'][GW_LANG_I].'-utf8';
		//
		// Render HTML page, 25 apr 2003
		//
		$arPre = gw_Xml2Array($listA['defn']);
		$tmp['term'] = $listA['term'];
		$tmp['t1'] = $listA['term_1'];
		$tmp['t2'] = $listA['term_2'];
		$tmp['tid'] = $listA['tid'];
		//
		$objDom = new gw_domxml;
		$objDom->setCustomArray($arPre);
		$oRender = new $gw_this['vars']['class_render'];
		$oRender->Set('Gtmp', $tmp );
		$oRender->Set('Gsys', $sys );
		$oRender->Set('oL', $oL );
		$oRender->Set('objDom', $objDom );
		$oRender->Set('arDictParam', $arDictParam );
		$oRender->Set('arEl', $arPre );
		$oRender->Set('arFields', $arFields );
		$oRender->load_abbr_trns();
		//
		$tmp['str_defn'] = $oRender->array_to_html($arPre);
		/* Process text filters */
		while (!$sys['is_debug_output']
				&& is_array($sys['filters_defn'])
				&& list($k, $v) = each($sys['filters_defn']) )
		{
			$tmp['str_defn'] = $v($tmp['str_defn']);
		}
		$oTpl->addVal( "DEFN", $tmp['str_defn'] );
		// -------------------------------------------------
		/* $tag_stress_rule */
		$ar_pairs_src = explode("|", $oRender->tag_stress_rule);
		$listA['term'] = str_replace('<stress>', $ar_pairs_src[0], $listA['term']);
		$listA['term'] = str_replace('</stress>', $ar_pairs_src[1], $listA['term']);
		// --------------------------------------------------
		$oTpl->addVal( 'TERM', $listA['term'] );
		$oTpl->varXref = $sys['page_index'] . '?a=term&amp;d=' . $gw_this['vars'][GW_ID_DICT] . '&amp;q=';
		$oTpl->layout = $layout;
		$oTpl->addVal( "L_pages", "&#160;");
		//
		// linked term does not exist
		//
		if ($listA['term'] == '')
		{
			$oTpl->addVal( 'AAZZ', '' );
			// avoid cross-scripting
			$oTpl->addVal( 'DEFN', '<span class="term">'. textcodetoform($q) .'</span><br /><span class="r">' .
			htmlTagsA('?a=fb&name=Visitor&email=guest@'.HTTP_HOST.'&arPost[message]='.urlencode($q.' - '.CRLF.$oL->m('reason_26')), $oL->m('reason_26')) .'</span>');
		}
		//
		if ($isPrint) // HTML-code modifications for printable version
		{
			$oTpl->addVal('PRINTVERSION', $oL->m('printversion'));
			$oTpl->tplPairs['DEFN'] = preg_replace("/<ol(.*[^>])>/", "<br />", $oTpl->tplPairs['DEFN']);
			$oTpl->tplPairs['DEFN'] = str_replace("</ol>", " ", $oTpl->tplPairs['DEFN']);
			$oTpl->tplPairs['DEFN'] = preg_replace("/<ul(.*[^>])>/", "<br />", $oTpl->tplPairs['DEFN']);
			$oTpl->tplPairs['DEFN'] = str_replace("</ul>", " ", $oTpl->tplPairs['DEFN']);
			$oTpl->tplPairs['DEFN'] = str_replace("<li>", "&#160;&#8226;", $oTpl->tplPairs['DEFN']);
			$oTpl->tplPairs['DEFN'] = str_replace("</li>", "<br/>", $oTpl->tplPairs['DEFN']);
			$oTpl->tplPairs['DEFN'] = str_replace('&#x25BA;', ' ', $oTpl->tplPairs['DEFN']);
			//
			$ar_tpl_construct[] = 'term_item_print.html';
			$ar_tpl_construct[] = 'footer_print.html';
		}
		else
		{
			if ($arDictParam['is_show_az']) // show or hide letters toolbar
			{
				$oTpl->addVal("AZ", getLetterHtml($ar0z, $gw_this['vars'][GW_ID_DICT], $listA['term_1']));
				$oTpl->addVal("AAZZ", getLetterHtml($ar0z, $gw_this['vars'][GW_ID_DICT], $listA['term_1'], $listA['term_2']. ' '));
			}
			/* Add to favorites */
			$gw_this['url_fav'] = 'http://' . HTTP_HOST . $sys['page_index']. '?a=term&amp;d=' . $gw_this['vars'][GW_ID_DICT] . '&amp;q=' . $gw_this['term_linked'];
			$oHtml->setTag('a', 'onclick', 'window.external.AddFavorite(\''. strip_tags($gw_this['url_fav']) . "','". addslashes(strip_tags($listA['term'].' - '.$arDictParam['title'])) . "');return false;");
			$gw_this['href_fav'] = $oHtml->a('#', $oL->m('page_fav'));
			$oHtml->setTag('a', 'onclick', '');
			/* Refresh the page */
			# 'http://' . HTTP_HOST . REQUEST_URI.'&r=' . rand(0, 9999);
			$gw_this['url_refresh'] = 'http://' . HTTP_HOST . $oHtml->url_normalize(append_url($sys['page_index'].'?a=term&d='. $gw_this['vars'][GW_ID_DICT].'&t='.$listA['tid'].'&r='.rand(0,999)));
			$oHtml->setTag('a', 'onclick', "window.location.href('".$gw_this['url_refresh']."');return false;");
			$gw_this['href_refresh'] = $oHtml->a('#', $oL->m('page_refresh'));
			$oHtml->setTag('a', 'onclick', '');

			$arTermActions = array(
				$gw_this['href_refresh'],
				$gw_this['href_fav'],
				$gw_this['href_print'],
			);
			$oTpl->addVal( 'TERM_ACTIONS', implode(' | ', $arTermActions));
			//
			$ar_tpl_construct[] = 'term_item.html';
			$ar_tpl_construct[] = 'menu_pages.html';
			$ar_tpl_construct[] = 'footer_inside.html';
		}
		$gw_this['arTitle'][] = strip_tags($listA['term']);
	}
	break;
	case GW_A_SEARCH: // Search mode
	{
		$str_current_section = '';
		$oTpl->addVal("DICT_NAME_LINKED", $oL->m('2_page_18'));
		$ar_tpl_construct = array("header.html", "search_form.html", "menu_letters_az.html");
		$intFound = 0;
		$q = trim($oFunc->mb_substr($q, 0, 254));
		//
		$gw_this['arSrchResults'] = array();
		$gw_this['arSrchResults']['found'] = 0;
		$gw_this['arSrchResults']['q'] = $q;
		if ($id_srch == '') // 1st search query
		{
			gw_search($q, $gw_this['arDictListSrch'], $srch);
		}
		else // list seach results
		{
			$gw_this['arSrchResults'] = gw_search_results($id_srch, $p, $gw_this['vars'][GW_ID_DICT]);
			/* Write search log */
			if (isset($gw_this['arSrchResults']['found']) && ($p == 1) && $sys['is_LogSearch'] )
			{
				if (!isset($oLog))
				{
					$oLog = new gw_logwriter($sys['path_logs']);
				}
				$arLogSrch = array();
				$arLogSrch[0] = GW_TIME_NOW_UNIX;
				$arLogSrch[1] = $oFunc->ip2int(REMOTE_IP);
				$arLogSrch[2] = 'd=' . urlencode($gw_this['vars'][GW_ID_DICT]) . '&in=' . $gw_this['arSrchResults']['in'] .
								'&found=' . $gw_this['arSrchResults']['found'] .
								'&q=' . urlencode($gw_this['arSrchResults']['q']);
				$oFunc->file_put_contents($oLog->get_filename('srch'), $oLog->make_str($arLogSrch), 'a');
			}
		}
		/* nothing was found */
		if ($gw_this['arSrchResults']['found'] == 0)
		{
			$gw_this['arSrchResults']['html'] = '';
			$ar_tpl_construct[] = '../common/term_empty_search.html';
			$oTpl->addVal( 'l:reason_5', $oL->m('reason_5') );
			$oTpl->addVal( 'l:srch_trydefn', sprintf(
							$oL->m('srch_trydefn'),
							$oHtml->url_normalize(append_url($sys['page_index'] . '?'. GW_ACTION . '='.GW_A_SEARCH.'&d='.$gw_this['vars'][GW_ID_DICT]."&amp;q=".urlencode($gw_this['arSrchResults']['q']).'&in=defn&strict=1')),
							$oHtml->url_normalize(('index.'. $sys['phpEx'] . '?'. GW_ACTION . '='.GW_A_SEARCH.'&q='.urlencode($gw_this['arSrchResults']['q']))) )
			);
			$oTpl->addVal( 'l:1075', $oL->m('1075') );
		}
		$ar_tpl_construct[] = '../common/term_list_search.html';
		$oTpl->addVal( 'block:term_list_search', $gw_this['arSrchResults']['html']);
		$intSumPages = 1;
		if ( isset($gw_this['arSrchResults']['pages']) ){ $intSumPages = $gw_this['arSrchResults']['pages']; }
		// fix page number
		if ( ( $p < 1 ) || ( $p > $intSumPages) ){ $p = 1; }
		// show dictionary name on search results
		if ($gw_this['vars'][GW_ID_DICT] > 0)
		{
			$oTpl->addVal('DICT_NAME_LINKED', $oL->m('2_page_18') . '<br />' . $oHtml->a($sys['page_index'] . '?a=index&d=' . $gw_this['vars'][GW_ID_DICT], $arDictParam['title']));
		}
		// redirect when only one word found
		if (($gw_this['arSrchResults']['found'] == 1) && ($gw_this['vars'][GW_ID_DICT] > 0) && isset($gw_this['arSrchResults']['results'][$gw_this['vars'][GW_ID_DICT]]))
		{
			gwtk_header($sys['server_proto'].$sys['server_host'].$sys['page_index']
						. '?a=term&d=' . $gw_this['vars'][GW_ID_DICT]
						. '&t=' . $gw_this['arSrchResults']['results'][$gw_this['vars'][GW_ID_DICT]], $sys['is_delay_redirect']
			);
		}

		$oTpl->addVal( 'q', textcodetoform($gw_this['arSrchResults']['q']) );

		if ($intSumPages > 1) // enable page navigation
		{
			$oTpl->addVal( 'L_PAGES', $oL->m('L_pages').':');
			$oTpl->addVal( 'PAGE_SELECTION',
				getNavToolbar($intSumPages, $p, $sys['page_index'] . '?'.GW_ACTION.'='.${GW_ACTION}.'&id_srch='.$id_srch.'&d='.$gw_this['vars'][GW_ID_DICT].'&strict='.$strict.'&p=')
					);
		}
		$ar_tpl_construct[] = "menu_pages.html";
		$ar_tpl_construct[] = "footer_inside.html";

		$gw_this['arTitle'][] = textcodetoform($gw_this['arSrchResults']['q']);
		$gw_this['arTitle'][] = $oL->m('2_page_18');
	}
	break;
	case GW_A_CUSTOMPAGE:
		$oTpl->addVal( 'AZ',             '');
		$oTpl->addVal( 'L_PAGES',        '&#160;' );
		$oTpl->addVal( 'PAGE_SELECTION', '');
		$ar_tpl_construct = array('header.html', 'search_form_empty.html');

		gw_custom_page($gw_this['vars']['id']);

		$ar_tpl_construct[] = 'menu_pages.html';
		$ar_tpl_construct[] = 'footer_inside.html';
	break;
	default:
	{
		/* Title page */
		$str_current_section = '';
		$oTpl->addVal( "SITE_DESCR", $sys['site_desc']);
		$oTpl->addVal( "legend_updated", sprintf($oL->m('tip015'), '<span class="red">'.$oL->m('mrk_new').'</span>', $sys['time_new']));
		$oTpl->addVal( "legend_new",     sprintf($oL->m('tip014'), '<span class="green">'.$oL->m('mrk_upd').'</span>', $sys['time_upd']));
		## ------------------------------------------------
		## Catalog object
		/* "", links per category, X, Y, order by */
		$oTpl->addVal( "block:catalog", getDictList('', 99, 2, 99 ) );
		## ------------------------------------------------
		## Statistics
		$arStatCommon = getStat();
		$oTpl->addVal("block:stats", gw_html_block_small($oL->m('web_stat'),
					'<span class="f">' . (date_extract_int($arStatCommon['date'], "%d")/1) . date_extract_int($arStatCommon['date'], (" %FL %Y")) . "</span>"
					.'<br/>' . $oL->m('stat_dict') . ': ' . $oFunc->number_format($arStatCommon['num'], 0, $oL->languagelist('4'))
					.'<br/>' . $oL->m('stat_defn') . ': ' . $oFunc->number_format($arStatCommon['sum'], 0, $oL->languagelist('4')), 0, 't', 0, 0)
			);
		## ------------------------------------------------
		## Global search
		$oTpl->addVal( "block:allsearch", gw_html_block_small($oL->m('srch_title'), getDictSrch(), 't', 0, 0, 'center') );
		## ------------------------------------------------
		## Last updated dictionaries
		$oTpl->addVal( "block:dict_updated", gw_html_block_small($oL->m('r_dict_updated'), getTop10('R_DICT_UPDATED', $sys['max_dict_updated'] , 1), 't', 0, 0, $sys['css_align_left'] ));
		$oTpl->addVal( "block:term_updated", gw_html_block_small($oL->m('r_term_updated'), getTop10('R_TERM_UPDATED', $sys['max_dict_top'] , 1), 't', 0, 0, $sys['css_align_left'] ));
		$ar_tpl_construct = array("header.html", "indexpage.html", "footer.html");
	}
	break;
}

## ------------------------------------------------
## Get random term
/*
$gw_this['vars']['arTermRandom'] = getTermRandom();
$gw_this['vars']['arDictParam'] = getDictParam( $gw_this['vars']['arTermRandom']['id'] );
if (isset($gw_this['vars']['arTermRandom']['defn']))
{
	$tmp['cssTrClass'] = 't';
	$tmp['xref'] = $sys['page_index'] . '?a=term&amp;d=' . $gw_this['vars']['arTermRandom']['id'] . '&amp;q=';
	// Render html page, 25 apr 2003
	$arPre = gw_Xml2Array($gw_this['vars']['arTermRandom']['defn']);
	$objDom = new gw_domxml;
	$objDom->setCustomArray($arPre);
	$oRender = new gw_render;
	$oRender->Set('Gtmp', $tmp );
	$oRender->Set('Gsys', $sys );
	$oRender->Set('margin_top', '-1em' );
	$oRender->Set('oL', $oL );
	$oRender->Set('objDom', $objDom );
	$oRender->Set('arDictParam', $gw_this['vars']['arDictParam'] );
	$oRender->Set('arEl', $arPre );
	$oRender->Set('arFields', $arFields );
	$oRender->load_abbr_trns();
	$oTpl->addVal( 'block:randomterm', gw_html_block_small('Randomly choosed term',
				'<span class="r">'.$gw_this['vars']['arTermRandom']['term'].'</span>'.$oRender->array_to_html($arPre), 't' ) );
	$gw_this['vars']['arTermRandom'] = $gw_this['vars']['arDictParam'] = array();
}
*/
/* Menu with custom pages */
if (!isset($sys['str_nav_prepend'])){ $sys['str_nav_prepend'] = '<span class="nobr">'; }
if (!isset($sys['str_nav_split'])){ $sys['str_nav_split'] = '</span> &#160; <span class="nobr">'; }
if (!isset($sys['str_nav_append'])){ $sys['str_nav_append'] = '</span>'; }
if (!isset($sys['str_navb_prepend'])){ $sys['str_navb_prepend'] = '<span class="nobr">'; }
if (!isset($sys['str_navb_split'])){ $sys['str_navb_split'] = '</span> | <span class="nobr">'; }
if (!isset($sys['str_navb_append'])){ $sys['str_navb_append'] = '</span>'; }

$arNavBarTop = array();

$arSql = $oDb->sqlRun($oSqlQ->getQ('get-pages-list'), 'page');
$arSql2 = array();
/* re-arrange */
for (; list($k, $arV) = each($arSql);)
{
	$arSql2[sprintf("%05d", $arV['int_sort']).sprintf("%03d", $arV['id_page'])][$arV['id_lang']] = $arV;
}
$arSql = array();
for (; list($k, $arV) = each($arSql2);)
{
	$oHtml->unsetTag('a');
	$cur_id_lang = $gw_this['vars'][GW_LANG_I].'-'.$gw_this['vars']['lang_enc'];
	if (isset($arV[$cur_id_lang]))
	{
		$arV = $arV[$cur_id_lang];
	}
	elseif (isset($arV[$sys['locale_name']]))
	{
		$arV = $arV[$sys['locale_name']];
	}
	else
	{
		$ar_keys = array_keys($arV);
		$arV = $arV[$ar_keys[0]];
	}
	$icon = '';
	if ($arV['page_icon'])
	{
		$file_icon = $sys['path_tpl'] . '/' . $gw_this['vars']['visualtheme'] . '/' . $arV['page_icon'];
		if (file_exists($file_icon))
		{
			$icon = '<img style="vertical-align:top;margin:1px" src="' . $sys['server_dir'] . '/' . $file_icon . '" ' .
				' width="13" height="13" alt="'. $arV['page_title'] .'" />&#160;';
		}
	}
	/* Custom PHP-code */
	@eval( $arV['page_php_2'] );
	/* Link mode */
	switch ($sys['pages_link_mode'])
	{
		case GW_PAGE_LINK_NAME:
			$str_page_id = urlencode($arV['page_title']);
			$str_cur_page = $arV['page_title'];
		break;
		case GW_PAGE_LINK_URI:
			$str_page_id = urlencode($arV['page_uri']);
			$str_cur_page = $arV['page_uri'];
		break;
		default:
			$str_page_id = $arV['id_page'];
			$str_cur_page = $arV['id_page'];
		break;
	}
	/* Indicators active/inactive */
	if (isset($gw_this['ar_pages']) && (($gw_this['vars']['id'] == $str_cur_page)
	  || gw_breadcrumbs_is_in_root($gw_this['ar_pages'], $gw_this['id_page_int'], $arV['id_page'])))
	{
		$oHtml->setTag('a', 'class', 'on');
	}
	elseif (!isset($gw_this['ar_pages']) && ($str_cur_page == $sys['id_custom_page_on'])
	  && ($layout != 'title'))
	{
		$oHtml->setTag('a', 'class', 'on');
	}
	$arNavBarTop[] = $icon . $oHtml->a($sys['page_index'] . '?a='.GW_A_CUSTOMPAGE.'&id=' . $str_page_id, $arV['page_title']);
	$arNavBarBottom[] = $oHtml->a($sys['page_index'] . '?a='.GW_A_CUSTOMPAGE.'&id=' . $str_page_id, $arV['page_title']);
}
$oTpl->addVal('NAV_TOP',    $sys['str_nav_prepend'].implode($sys['str_nav_split'], $arNavBarTop).$sys['str_nav_append']);
$oTpl->addVal('NAV_BOTTOM', $sys['str_navb_prepend'].implode($sys['str_navb_split'], $arNavBarBottom).$sys['str_navb_append']);
unset($arSql);
$oTpl->addVal( 'block:current_section',  $str_current_section);
## Site navigation
## --------------------------------------------------------

## --------------------------------------------------------
## Keywords section
if (!is_array($k)){ $k = array(); }
if (!isset($kw) || !is_array($kw)){ $kw = array('0' => '0'); }
if ($w != '') // if letter selected
{
	$k[] = $w;
}
if ( !empty($listA['term']) ) // if term selected
{
	$listA['term'] = htmlspecialchars(strip_tags($listA['term']));
	// fix for special chars (a term &amp; a term)
	$listA['term'] = str_replace("&amp;", "&", $listA['term']);
	// meta keywords
	$k[] = $listA['term'];
}
if ( !empty($arDictParam['title']) ) // call $arDictParam safely
{
	$gw_this['arTitle'][] = $k[] = htmlspecialchars(strip_tags($arDictParam['title']));
}
if (empty($k))
{
	$gw_this['arTitle'][] = $sys['site_name'];
	$k[] = $sys['site_desc'];
	if ($str_current_section != '')
	{
		$k[] = $str_current_section;
	}
	$metaDescr = $sys['site_desc'];
}
else
{
	$metaDescr = $sys['site_name'] . ' - ' . $sys['site_desc'];
}
if (empty($metaDescr)) { $metaDescr = $str_current_section; }
if (isset($arDictParam['keywords']))
{
	if (!empty($arDictParam['keywords'])){ $kw[] = $arDictParam['keywords']; }
}
if (!empty($sys['keywords'])){ $kw[] = $sys['keywords']; }

$oTpl->addVal( "TITLE",  implode(' - ', $gw_this['arTitle']) );
$oTpl->addVal( "htmlKeywords", strip_tags(searchkeys(array_merge($k, $kw))) );
$oTpl->addVal( "htmlDescription", trim(strip_tags($metaDescr)) );
## Keywords section
## --------------------------------------------------------

// Add previously defined template variables
for (reset($arTplVars['srch']); list($k, $v) = each($arTplVars['srch']);)
{
	while (is_array($v) && list($k2, $v2) = each($v))
	{
		$oTpl->AddVal($k2, $v2);
	}
}
// Add previously defined template files
if (isset($ar_tpl_construct) && is_array($ar_tpl_construct))
{
	for (reset($ar_tpl_construct); list($k, $v) = each($ar_tpl_construct);)
	{
		$oTpl->setHandle( $k , $sys['path_tpl'] . '/' . $sys['path_theme'] . '/' . $v );
	}
}

/* end of file */
?>